<?php
if(!defined('sugarEntry'))define('sugarEntry', true);
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Professional Subscription
 * Agreement ("License") which can be viewed at
 * http://www.sugarcrm.com/crm/products/sugar-professional-eula.html
 * By installing or using this file, You have unconditionally agreed to the
 * terms and conditions of the License, and You may not use this file except in
 * compliance with the License.  Under the terms of the license, You shall not,
 * among other things: 1) sublicense, resell, rent, lease, redistribute, assign
 * or otherwise transfer Your rights to the Software, and 2) use the Software
 * for timesharing or service bureau purposes such as hosting the Software for
 * commercial gain and/or for the benefit of a third party.  Use of the Software
 * may be subject to applicable fees and any use of the Software without first
 * paying applicable fees is strictly prohibited.  You do not have the right to
 * remove SugarCRM copyrights from the source code or user interface.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *  (i) the "Powered by SugarCRM" logo and
 *  (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * Your Warranty, Limitations of liability and Indemnity are expressly stated
 * in the License.  Please refer to the License for the specific language
 * governing these rights and limitations under the License.  Portions created
 * by SugarCRM are Copyright (C) 2004-2007 SugarCRM, Inc.; All Rights Reserved.
 ********************************************************************************/
require_once('include/entryPoint.php');
global $sugar_config;
global $locale;

session_cache_limiter('public');
session_start();

if(empty($_REQUEST['id']) || empty($_REQUEST['type']) || !isset($_SESSION['authenticated_user_id'])) {
	die("Not a Valid Entry Point");
} else {
	// cn: bug 8753: current_user's preferred export charset not being honored
	$current_user->retrieve($_SESSION['authenticated_user_id']);
	$current_language = $_SESSION['authenticated_user_language'];
	$app_strings = return_application_language($current_language);
	$local_location = (isset($_REQUEST['isTempFile'])) ? "{$sugar_config['cache_dir']}/modules/Emails/{$_REQUEST['ieId']}/attachments/{$_REQUEST['id']}"
		 : $sugar_config['upload_dir']."/".$_REQUEST['id'];
	
	
	if(!file_exists( $local_location )) {
		die($app_strings['ERR_INVALID_FILE_REFERENCE']);
	} elseif(strpos($local_location, "../") || strpos($local_location, "..\\") ) {
		die($app_strings['ERR_INVALID_FILE_REFERENCE']);
	} else {
		$doQuery = true;
		
		if(strtolower($_REQUEST['type']) == 'documents') {
			// cn: bug 9674 document_revisions table has no 'name' column.
			$query = "SELECT filename name FROM document_revisions WHERE id = '" . $_REQUEST['id'] ."'";
		} elseif(strtolower($_REQUEST['type']) == 'notes') {
			$query = "SELECT filename name FROM notes WHERE id = '" . $_REQUEST['id'] ."'";
		} elseif(strtolower($_REQUEST['type']) == 'temp') {
			$doQuery = false;
		}
		
		if($doQuery) {
			$rs = $db->query($query);
			$row = $db->fetchByAssoc($rs);
			
			if(empty($row)){
				die($app_strings['ERR_INVALID_FILE_REFERENCE']);
			}
	
			// cn: leave name charset translation to the browsers - they will handle it better than 2nd guessing.
			$emailStrings = return_module_language($current_language, 'Emails');
			$name = urldecode(str_replace($emailStrings['LBL_EMAIL_ATTACHMENT'].': ', '', $row['name']));
			
			if(isset($_SERVER['HTTP_USER_AGENT']) && preg_match("/MSIE/", $_SERVER['HTTP_USER_AGENT'])) {
				// cn: bug 7870 IE cannot handle MBCS in filenames gracefully. set $name var to filename
				$name = str_replace("+", "_", $row['name']);
				$name = $locale->translateCharset($name, 'UTF-8', $locale->getOutboundEmailCharset());
			} else {
				// ff 1.5+
				$name = mb_encode_mimeheader($name, $locale->getOutboundEmailCharset(), 'Q');
			}




			$download_location = $sugar_config['upload_dir']."/".$_REQUEST['id'];
		} else {
			// downloading a temp file (email 2.0)
			$name = $_REQUEST['tempName'];
			$download_location = $local_location;
			if(isset($_SERVER['HTTP_USER_AGENT']) && preg_match("/MSIE/", $_SERVER['HTTP_USER_AGENT'])) {
				// cn: bug 7870 IE cannot handle MBCS in filenames gracefully. set $name var to filename
				$name = str_replace("+", "_", $name);
				$name = $locale->translateCharset($name, 'UTF-8', $locale->getOutboundEmailCharset());
			} else {
				// ff 1.5+
				$name = mb_encode_mimeheader($name, $locale->getOutboundEmailCharset(), 'Q');
			}
		}

		header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
		header("Content-type: application/force-download");
		header("Content-Length: " . filesize($local_location));
		header("Content-disposition: attachment; filename=\"".$name."\";");
//		header("Pragma: ");
		header("Expires: 0");
		set_time_limit(0);
		
		@ob_end_clean();
		ob_start();
		if(filesize($local_location) < 2097152) {
			readfile($download_location);
		} else {
			readfile_chunked($download_location);
		}
		@ob_flush();
	}
}
?>
