<?php
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Professional Subscription
 * Agreement ("License") which can be viewed at
 * http://www.sugarcrm.com/crm/products/sugar-professional-eula.html
 * By installing or using this file, You have unconditionally agreed to the
 * terms and conditions of the License, and You may not use this file except in
 * compliance with the License.  Under the terms of the license, You shall not,
 * among other things: 1) sublicense, resell, rent, lease, redistribute, assign
 * or otherwise transfer Your rights to the Software, and 2) use the Software
 * for timesharing or service bureau purposes such as hosting the Software for
 * commercial gain and/or for the benefit of a third party.  Use of the Software
 * may be subject to applicable fees and any use of the Software without first
 * paying applicable fees is strictly prohibited.  You do not have the right to
 * remove SugarCRM copyrights from the source code or user interface.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *  (i) the "Powered by SugarCRM" logo and
 *  (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * Your Warranty, Limitations of liability and Indemnity are expressly stated
 * in the License.  Please refer to the License for the specific language
 * governing these rights and limitations under the License.  Portions created
 * by SugarCRM are Copyright (C) 2004-2007 SugarCRM, Inc.; All Rights Reserved.
 * *******************************************************************************/
require_once('include/SugarFields/Fields/Base/SugarFieldBase.php');

class SugarFieldRelate extends SugarFieldBase {
    
	function getDetailViewSmarty($parentFieldArray, $vardef, $displayParams, $tabindex) {
		$nolink = array('Users', 'Teams');
		if(in_array($vardef['module'], $nolink)){
			$this->ss->assign('nolink', true);
		}else{
			$this->ss->assign('nolink', false);
		}
        $this->setup($parentFieldArray, $vardef, $displayParams, $tabindex);
        return $this->fetch('include/SugarFields/Fields/Relate/DetailView.tpl');
    }
    
    function getEditViewSmarty($parentFieldArray, $vardef, $displayParams, $tabindex) {
    	
    	$form_name = 'EditView';
    	if(isset($displayParams['formName'])) {
    		$form_name = $displayParams['formName'];
    	}
    	
        //Special Case for accounts; use the displayParams array and retrieve
        //the key and copy indexes.  'key' is the suffix of the field we are searching
        //the Account's address with.  'copy' is the suffix we are copying the addresses
        //form fields into.
        if(isset($vardef['module']) && preg_match('/Accounts/si',$vardef['module']) 
           && isset($displayParams['key']) && isset($displayParams['copy'])) {
        	
        	if(isset($displayParams['key']) && is_array($displayParams['key'])) {
        	  $database_key = $displayParams['key'];	
        	} else {
              $database_key[] = $displayParams['key'];
        	}
        	
        	if(isset($displayParams['copy']) && is_array($displayParams['copy'])) {
                $form = $displayParams['copy'];
        	} else {
        		$form[] = $displayParams['copy'];
        	}
        	
        	if(count($database_key) != count($form)) {
        	  global $app_list_strings;
        	  $this->ss->trigger_error($app_list_strings['ERR_SMARTY_UNEQUAL_RELATED_FIELD_PARAMETERS']);
        	} //if
        	
        	$copy_phone = isset($displayParams['copyPhone']) ? $displayParams['copyPhone'] : true;
        	
        	$field_to_name = array();
        	$field_to_name['id'] = $vardef['id_name'];
        	$field_to_name['name'] = $vardef['name'];
        	$address_fields = array('_address_street', '_address_city', '_address_state', '_address_postalcode', '_address_country');
        	$count = 0;
        	foreach($form as $f) {
        		foreach($address_fields as $afield) {
        	   		$field_to_name[$database_key[$count] . $afield] = $f . $afield;
        		}
        		$count++;
        	}

			$popup_request_data = array(
				'call_back_function' => 'set_return',
				'form_name' => $form_name,
				'field_to_name_array' => $field_to_name,
			);
				
		    if($copy_phone) {
		   	  $popup_request_data['field_to_name_array']['phone_office'] = 'phone_work';
		    }	        	
        } else {
			$popup_request_data = array(
				'call_back_function' => 'set_return',
				'form_name' => $form_name,
				'field_to_name_array' => array(
                          'id' => $vardef['id_name'],
						  'name' => $vardef['name'],
					),
				);
		}
		$json = getJSONobj();
		$displayParams['popupData'] = '{literal}'.$json->encode($popup_request_data). '{/literal}';
	    if(!isset($displayParams['readOnly'])) {
	       $displayParams['readOnly'] = '';
	    } else {
	       $displayParams['readOnly'] = $displayParams['readOnly'] == false ? '' : 'READONLY'; 	
	    }
	    $this->setup($parentFieldArray, $vardef, $displayParams, $tabindex);
	    return $this->fetch('include/SugarFields/Fields/Relate/EditView.tpl'); 
    }
    
	function getSearchViewSmarty($parentFieldArray, $vardef, $displayParams, $tabindex) {
    	$form_name = 'search_form';
    	if(isset($displayParams['formName'])) {
    		$form_name = $displayParams['formName'];
    	}
    	
		$popup_request_data = array(
								'call_back_function' => 'set_return',
								'form_name' => $form_name,
								'field_to_name_array' => array(
					                      'id' => $vardef['id_name'],
										  'name' => $vardef['name'],
								),
							  );
		
		$json = getJSONobj();
		if(!empty($_REQUEST[$vardef['id_name']])) {
		   $displayParams['request_value'] = '{$smarty.request.'.$vardef['id_name'].'}';
		}
		$displayParams['popupData'] = '{literal}'.$json->encode($popup_request_data). '{/literal}';
	    if(!isset($displayParams['readOnly'])) {
	       $displayParams['readOnly'] = '';
	    } else {
	       $displayParams['readOnly'] = $displayParams['readOnly'] == false ? '' : 'READONLY'; 	
	    }
	    $this->setup($parentFieldArray, $vardef, $displayParams, $tabindex);
	    return $this->fetch('include/SugarFields/Fields/Relate/SearchView.tpl'); 
    }    
}
?>
