<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Professional Subscription
 * Agreement ("License") which can be viewed at
 * http://www.sugarcrm.com/crm/products/sugar-professional-eula.html
 * By installing or using this file, You have unconditionally agreed to the
 * terms and conditions of the License, and You may not use this file except in
 * compliance with the License.  Under the terms of the license, You shall not,
 * among other things: 1) sublicense, resell, rent, lease, redistribute, assign
 * or otherwise transfer Your rights to the Software, and 2) use the Software
 * for timesharing or service bureau purposes such as hosting the Software for
 * commercial gain and/or for the benefit of a third party.  Use of the Software
 * may be subject to applicable fees and any use of the Software without first
 * paying applicable fees is strictly prohibited.  You do not have the right to
 * remove SugarCRM copyrights from the source code or user interface.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *  (i) the "Powered by SugarCRM" logo and
 *  (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * Your Warranty, Limitations of liability and Indemnity are expressly stated
 * in the License.  Please refer to the License for the specific language
 * governing these rights and limitations under the License.  Portions created
 * by SugarCRM are Copyright (C) 2004-2007 SugarCRM, Inc.; All Rights Reserved.
 ********************************************************************************/
/*********************************************************************************

* Description: This file generates the appropriate manager for the database
* 
* Portions created by SugarCRM are Copyright (C) SugarCRM, Inc.
* All Rights Reserved.
* Contributor(s): ______________________________________..
********************************************************************************/

global $sugar_config;

class DBManagerFactory
{
	/** This function returns the correct instance of the manager
	*   depending on the database type
	*/
	function &getInstance($instanceName=''){
		global $sugar_config;
			$temp_var =& DBManager::getInstance($instanceName);
			return $temp_var;
}

    /** This function returns the correct instance of the manager
    *   depending on the database type
    */
    function getHelperInstance(){
        global $sugar_config;

        if( $sugar_config['dbconfig']['db_type'] == "oci8" || $sugar_config['dbconfig']['setup_db_type'] == 'oci8'){



        } 
        elseif( $sugar_config['dbconfig']['db_type'] == "mssql" ) 
		{				
            $my_db_manager = 'MssqlHelper';
        }
        else {
            $my_db_manager = 'MysqlHelper';
            if (!isset($sugar_config['mysqli_disabled']) or $sugar_config['mysqli_disabled']==false) {
                if (function_exists('mysqli_connect')) {
                    $my_db_helper = 'MysqliHelper';    
                }   
            } 
        }
        DBManagerFactory::load_db_manager_class($my_db_manager);
        return new $my_db_manager();
    }
    
	function load_db_manager_class($class_name) {
		global $sugar_config;
		
		if( strcmp($class_name, 'MysqliManager')  == 0 and !class_exists($class_name))
		{
		    require_once('include/database/MysqliManager.php');
			require_once('include/database/MysqliHelper.php');
		}		
		if( strcmp($class_name, 'MysqlManager')  == 0 and !class_exists($class_name))
		{
		    require_once('include/database/MysqlManager.php');
			require_once('include/database/MysqlHelper.php');
		}
		if(strcmp($class_name, 'MssqlManager')  == 0 and !class_exists($class_name))
		{
		    require_once('include/database/MssqlManager.php');  
			require_once('include/database/MssqlHelper.php');
		}







		if( strcmp($class_name, 'FreeTDSManager')  == 0 and !class_exists($class_name))
		{
		    require_once('include/database/FreeTDSManager.php');
			require_once('include/database/FreeTDSHelper.php');
		}		

	}
}

?>
