<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Professional Subscription
 * Agreement ("License") which can be viewed at
 * http://www.sugarcrm.com/crm/products/sugar-professional-eula.html
 * By installing or using this file, You have unconditionally agreed to the
 * terms and conditions of the License, and You may not use this file except in
 * compliance with the License.  Under the terms of the license, You shall not,
 * among other things: 1) sublicense, resell, rent, lease, redistribute, assign
 * or otherwise transfer Your rights to the Software, and 2) use the Software
 * for timesharing or service bureau purposes such as hosting the Software for
 * commercial gain and/or for the benefit of a third party.  Use of the Software
 * may be subject to applicable fees and any use of the Software without first
 * paying applicable fees is strictly prohibited.  You do not have the right to
 * remove SugarCRM copyrights from the source code or user interface.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *  (i) the "Powered by SugarCRM" logo and
 *  (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * Your Warranty, Limitations of liability and Indemnity are expressly stated
 * in the License.  Please refer to the License for the specific language
 * governing these rights and limitations under the License.  Portions created
 * by SugarCRM are Copyright (C) 2004-2007 SugarCRM, Inc.; All Rights Reserved.
 ********************************************************************************/

function build_related_list_by_user_id($bean, $user_id,$where) {
	$bean_id_name = strtolower($bean->object_name).'_id';

	$select = "SELECT {$bean->table_name}.* from {$bean->rel_users_table},{$bean->table_name} ";

	$auto_where = ' WHERE ';
	if(!empty($where)) {
		$auto_where .= $where. ' AND ';
	}

	$auto_where .= " {$bean->rel_users_table}.{$bean_id_name}={$bean->table_name}.id AND {$bean->rel_users_table}.user_id='{$user_id}' AND {$bean->table_name}.deleted=0 AND {$bean->rel_users_table}.deleted=0";

	$query = $select.$auto_where;

	$result = $bean->db->query($query, true);


	// We need to confirm that the user is a member of the team of the item.
	$bean->add_team_security_where_clause($select);
	$query = $select.$auto_where;
	$team_result = $bean->db->query($query, true);
	
	while($team_row = $bean->db->fetchByAssoc($team_result)) {
		$viewable_records[$team_row['id']] = 1;
	}


	$list = array();

	while($row = $bean->db->fetchByAssoc($result)) {
		foreach($bean->column_fields as $field) {
			if(isset($row[$field])) {
				$bean->$field = $row[$field];
			} else {
				$bean->$field = '';
			}
		}

		if(!isset($viewable_records[$row['id']])) {
			$bean->name = '';
		}

		$bean->processed_dates_times = array();
		$bean->check_date_relationships_load();
		$bean->fill_in_additional_detail_fields();
		
		/**
		 * PHP  5+ always treats objects as passed by reference
		 * Need to clone it if we're using 5.0+
		 * clone() not supported by 4.x
		 */
		if(version_compare(phpversion(), "5.0", ">=")) {
			$newBean = clone($bean);	
		} else {
			$newBean = $bean;
		}
		$list[] = $newBean;
	}

	return $list;
}
?>
