<?php
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Professional Subscription
 * Agreement ("License") which can be viewed at
 * http://www.sugarcrm.com/crm/products/sugar-professional-eula.html
 * By installing or using this file, You have unconditionally agreed to the
 * terms and conditions of the License, and You may not use this file except in
 * compliance with the License.  Under the terms of the license, You shall not,
 * among other things: 1) sublicense, resell, rent, lease, redistribute, assign
 * or otherwise transfer Your rights to the Software, and 2) use the Software
 * for timesharing or service bureau purposes such as hosting the Software for
 * commercial gain and/or for the benefit of a third party.  Use of the Software
 * may be subject to applicable fees and any use of the Software without first
 * paying applicable fees is strictly prohibited.  You do not have the right to
 * remove SugarCRM copyrights from the source code or user interface.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *  (i) the "Powered by SugarCRM" logo and
 *  (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * Your Warranty, Limitations of liability and Indemnity are expressly stated
 * in the License.  Please refer to the License for the specific language
 * governing these rights and limitations under the License.  Portions created
 * by SugarCRM are Copyright (C) 2004-2007 SugarCRM, Inc.; All Rights Reserved.
 ********************************************************************************/
/* 
 * This is the array that is used to determine how to group/concatenate js files together
 * The format is to define the location of the file to be concatenated as the array element key
 * and the location of the file to be created that holds the child files as the array element value.
 * So: $original_file_location => $Concatenated_file_location
 * 
 * If you wish to add a grouping that contains a file that is part of another group already,
 * add a '.' after the .js in order to make the element key unique.  Make sure you pare the extension out
 *    
 */

       $js_groupings = array(
           $sugar_grp1 = array(
                //scripts loaded on first page
                'include/javascript/sugar_3.js'         => 'include/javascript/sugar_grp1.js',
                'include/javascript/cookie.js'          => 'include/javascript/sugar_grp1.js',
                'jscalendar/calendar.js'                => 'include/javascript/sugar_grp1.js',
                //'jscalendar/lang/calendar-en.js'        => 'include/javascript/sugar_grp1.js',
                'jscalendar/calendar-setup_3.js'        => 'include/javascript/sugar_grp1.js',
            ),            
            
            $sugar_grp1_yui = array(
            //YUI scripts loaded on first page
            'include/javascript/yui/YAHOO.js'       => 'include/javascript/sugar_grp1_yui.js',
            'include/javascript/yui/log.js'         => 'include/javascript/sugar_grp1_yui.js',
            'include/javascript/yui/dom.js'         => 'include/javascript/sugar_grp1_yui.js',
            'include/javascript/yui/event.js'       => 'include/javascript/sugar_grp1_yui.js',
            'include/javascript/yui/animation.js'   => 'include/javascript/sugar_grp1_yui.js',
            'include/javascript/yui/connection.js'  => 'include/javascript/sugar_grp1_yui.js',
            'include/javascript/yui/dragdrop.js'    => 'include/javascript/sugar_grp1_yui.js',
            'include/javascript/yui/container.js'   => 'include/javascript/sugar_grp1_yui.js',
            'include/javascript/yui/ygDDList.js'    => 'include/javascript/sugar_grp1_yui.js',
            ),            
            
            $sugar_grp_yui_ext = array(
            //YUI-EXT scripts loaded     
            'include/javascript/yui/ext/yui-ext.js'                 => 'include/javascript/sugar_grp_yui_ext.js',
            'include/javascript/yui/ext/ddgrid.js'                  => 'include/javascript/sugar_grp_yui_ext.js',
            'include/javascript/yui/ext/data/XMLChildDataModel.js'  => 'include/javascript/sugar_grp_yui_ext.js',
            'include/javascript/yui/ext/grid/ChildGridView.js'      => 'include/javascript/sugar_grp_yui_ext.js',
            ),            
            
            $sugar_grp_yui2 = array(
            //YUI combination 2     
            'include/javascript/yui/dragdrop.js'    => 'include/javascript/sugar_grp_yui2.js',
            'include/javascript/yui/container.js'   => 'include/javascript/sugar_grp_yui2.js',
            ),            
            
            $sugar_grp_overlib = array(            
            //overlib combination            
            'include/javascript/overlibmws.js'              => 'include/javascript/sugar_grp_overlib.js',
            'include/javascript/overlibmws_iframe.js'       => 'include/javascript/sugar_grp_overlib.js',
            ),            
            
            $sugar_grp_ytree = array(
            //ytree files
            'include/ytree/TreeView/TreeView.js'        => 'include/javascript/sugar_grp_ytree.js',
            'include/ytree/TreeView/TaskNode.js'        => 'include/javascript/sugar_grp_ytree.js',
            'include/ytree/treeutil.js'                 => 'include/javascript/sugar_grp_ytree.js',
            ),             
        );
        
?>
