/**
 * groupTabs javascript file
 *
 * The contents of this file are subject to the SugarCRM Professional Subscription
 * Agreement ("License") which can be viewed at
 * http://www.sugarcrm.com/crm/products/sugar-professional-eula.html
 * By installing or using this file, You have unconditionally agreed to the
 * terms and conditions of the License, and You may not use this file except in
 * compliance with the License.  Under the terms of the license, You shall not,
 * among other things: 1) sublicense, resell, rent, lease, redistribute, assign
 * or otherwise transfer Your rights to the Software, and 2) use the Software
 * for timesharing or service bureau purposes such as hosting the Software for
 * commercial gain and/or for the benefit of a third party.  Use of the Software
 * may be subject to applicable fees and any use of the Software without first
 * paying applicable fees is strictly prohibited.  You do not have the right to
 * remove SugarCRM copyrights from the source code or user interface.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *  (i) the "Powered by SugarCRM" logo and
 *  (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * Your Warranty, Limitations of liability and Indemnity are expressly stated
 * in the License.  Please refer to the License for the specific language
 * governing these rights and limitations under the License.  Portions created
 * by SugarCRM are Copyright (C) 2004-2007 SugarCRM, Inc.; All Rights Reserved.
 */
 


SUGAR.themes.updateDelay = 250;

SUGAR.themes.updateSubTabHtml = function(mainTab){
	var subTabs = document.getElementById("subtabs");
	subTabs.innerHTML = SUGAR.themes.subTabs[mainTab];
};

SUGAR.themes.updateSubTabs = function(mainTab, htmlTab){
	if(typeof htmlTab != 'undefined'){
		SUGAR.themes.updateSubTabHtml(htmlTab);
	}else{
		SUGAR.themes.updateSubTabHtml(mainTab);
	}
	
	if(SUGAR.themes.activeTab){
		var oldActive = document.getElementById(SUGAR.themes.activeTab + "_tab");
		oldActive.getElementsByTagName('a')[0].className = 'otherTab';
		oldActive.className = 'otherTab';
	}
	
	var newActive = document.getElementById(mainTab + "_tab");
	newActive.getElementsByTagName('a')[0].className = 'currentTab';
	newActive.className = 'currentTab';
	
	SUGAR.themes.activeTab = mainTab;
};

SUGAR.themes.updateMoreTab = function(tabName){
	var moreTab = document.getElementById(SUGAR.themes.moreTab + "_tab");
	if(SUGAR.themes.moreTabUrl == null){
		SUGAR.themes.moreTabUrl = moreTab.getElementsByTagName('a')[0].href;
	}
	var href = (tabName!=SUGAR.themes.moreTab)?document.getElementById(tabName + "Handle").href:SUGAR.themes.moreTabUrl;
	moreTab.onmouseover = function(){SUGAR.themes.updateSubTabsDelay(SUGAR.themes.moreTab,tabName);};
	moreTab.getElementsByTagName('a')[0].innerHTML = tabName;
	moreTab.getElementsByTagName('a')[0].href = href;
	moreTab.getElementsByTagName('a')[0].onclick = function(){SUGAR.themes.chooseTab(tabName);return true;};
};

SUGAR.themes.resetTabs = function(){
	SUGAR.themes.updateSubTabs(SUGAR.themes.startTab);
	SUGAR.themes.updateMoreTab(SUGAR.themes.moreTab);
}

SUGAR.themes.firstReset = function(){
	SUGAR.themes.resetTabs();
}

SUGAR.themes.setResetTimer = function(){
	window.clearTimeout(SUGAR.themes.updateSubTabsTimer);
	window.clearTimeout(SUGAR.themes.resetSubTabsTimer);
	SUGAR.themes.resetSubTabsTimer = window.setTimeout('SUGAR.themes.resetTabs();', 1000);
}

SUGAR.themes.updateSubTabsDelay = function(mainTab, htmlTab, moreTab){
	var htmlTabArg = '';
	if(typeof htmlTab != 'undefined'){
		htmlTabArg = ', "'+htmlTab+'"';
	}
	var moreTabCode = '';
	if(typeof moreTab != 'undefined'){
		moreTabCode = 'SUGAR.themes.updateMoreTab("'+moreTab+'");';
	}
	window.clearTimeout(SUGAR.themes.updateSubTabsTimer);
	SUGAR.themes.updateSubTabsTimer = window.setTimeout('SUGAR.themes.updateSubTabs("'+mainTab+'"'+htmlTabArg+');'+moreTabCode, SUGAR.themes.updateDelay);
}

SUGAR.themes.chooseTab = function(tab){
	Set_Cookie('parentTab',tab,30,'/','','');
}
