<?php
if(!defined('sugarEntry') || !sugarEntry)
	die('Not A Valid Entry Point');
/**
 * The contents of this file are subject to the SugarCRM Professional Subscription
 * Agreement ("License") which can be viewed at
 * http://www.sugarcrm.com/crm/products/sugar-professional-eula.html
 * By installing or using this file, You have unconditionally agreed to the
 * terms and conditions of the License, and You may not use this file except in
 * compliance with the License.  Under the terms of the license, You shall not,
 * among other things: 1) sublicense, resell, rent, lease, redistribute, assign
 * or otherwise transfer Your rights to the Software, and 2) use the Software
 * for timesharing or service bureau purposes such as hosting the Software for
 * commercial gain and/or for the benefit of a third party.  Use of the Software
 * may be subject to applicable fees and any use of the Software without first
 * paying applicable fees is strictly prohibited.  You do not have the right to
 * remove SugarCRM copyrights from the source code or user interface.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *  (i) the "Powered by SugarCRM" logo and
 *  (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * Your Warranty, Limitations of liability and Indemnity are expressly stated
 * in the License.  Please refer to the License for the specific language
 * governing these rights and limitations under the License.  Portions created
 * by SugarCRM are Copyright (C) 2004-2007 SugarCRM, Inc.; All Rights Reserved.
 */



require_once ('modules/Contracts/Contract.php');
require_once ('log4php/LoggerManager.php');
require_once ('include/formbase.php');
require_once ('modules/ContractTypes/ContractType.php');
require_once ('modules/Documents/Document.php');

global $timedate;
if(!empty($_POST['expiration_notice_time_meridiem']) && !empty($_POST['expiration_notice_time'])) {
	$_POST['expiration_notice_time'] = $timedate->merge_time_meridiem($_POST['expiration_notice_time'],$timedate->get_time_format(true), $_POST['expiration_notice_time_meridiem']);
}


$sugarbean = new Contract();
$sugarbean = populateFromPost('', $sugarbean);
if (!empty($sugarbean->expiration_notice_date) or !empty($sugarbean->expiration_notice_time)) {
	$now=gmdate("Y-m-d H:i:s");
	if (empty($sugarbean->expiration_notice_date)) {
		$sugarbean->expiration_notice_date=$timedate->to_display_date($now);
	}
	if (empty($sugarbean->expiration_notice_time)) {
		$sugarbean->expiration_notice_time=$timedate->to_display_time($now);
	}
	$sugarbean->expiration_notice = $sugarbean->expiration_notice_date . ' ' . $sugarbean->expiration_notice_time;
}


if (!$sugarbean->ACLAccess('Save')) {
	ACLController :: displayNoAccess(true);
	sugar_cleanup(true);
}

$sugarbean->unformat_all_fields();  // this is to transform the displayed numbers back into database-formated numbers.
$check_notify = isset($GLOBALS['check_notify']) ? $GLOBALS['check_notify'] : false;
$sugarbean->save($check_notify);
if(!empty($_REQUEST['return_module']) && $_REQUEST['return_module'] != "Contracts") {
    $return_id = $_REQUEST['return_id'];
}
else {
    $return_id = $sugarbean->id;
}
if (!empty($_POST['type']) && $_POST['type'] !== $_POST['old_type']) {
	//attach all documents from contract type into contract.
	$ctype = new ContractType();
	$ctype->retrieve($_POST['type']);
	if (!empty($ctype->id)) {
		$ctype->load_relationship('documents');
		$doc = new Document();
		$documents=$ctype->documents->getBeans($doc);
		if (count($documents) > 0) {
			$sugarbean->load_relationship('documents');
			foreach($documents as $document) {
				$sugarbean->documents->add($document->id,array('document_revision_id'=>$document->document_revision_id));
			}			
		}	
	}
}
handleRedirect($return_id, 'Contracts');
?>
