<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
/**
 * The contents of this file are subject to the SugarCRM Professional Subscription
 * Agreement ("License") which can be viewed at
 * http://www.sugarcrm.com/crm/products/sugar-professional-eula.html
 * By installing or using this file, You have unconditionally agreed to the
 * terms and conditions of the License, and You may not use this file except in
 * compliance with the License.  Under the terms of the license, You shall not,
 * among other things: 1) sublicense, resell, rent, lease, redistribute, assign
 * or otherwise transfer Your rights to the Software, and 2) use the Software
 * for timesharing or service bureau purposes such as hosting the Software for
 * commercial gain and/or for the benefit of a third party.  Use of the Software
 * may be subject to applicable fees and any use of the Software without first
 * paying applicable fees is strictly prohibited.  You do not have the right to
 * remove SugarCRM copyrights from the source code or user interface.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *  (i) the "Powered by SugarCRM" logo and
 *  (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * Your Warranty, Limitations of liability and Indemnity are expressly stated
 * in the License.  Please refer to the License for the specific language
 * governing these rights and limitations under the License.  Portions created
 * by SugarCRM are Copyright (C) 2004-2007 SugarCRM, Inc.; All Rights Reserved.
 */



$popupMeta = array (
	'moduleMain' => 'Contract',
	'varName' => 'CONTRACT',
	'className' => 'Contract',
	'orderBy' => 'contracts.name',
	'whereClauses' => array (
		'name' => 'contracts.name', 
		'reference_code' => 'contracts.reference_code',
		'status' => 'contracts.status',
		'account_id' => 'contracts.account_id',
	),
	'searchInputs' => array('account_id','account_name','name','reference_code','status'),
	'selectDoms' => array('STATUS_OPTIONS' => 
								array('dom' => 'contract_status_dom', 'searchInput' => 'status'),
	),
	'listviewdefs' => array(
											'NAME' => array(
										        'width' => '40', 
										        'label' => 'LBL_LIST_CONTRACT_NAME', 
										        'link' => true,
										        'default' => true),
										    'REFERENCE_CODE' => array(
										        'width' => '10', 
										        'label' => 'LBL_REFERENCE_CODE', 
										        'link' => false,
										        'default' => true),
										    'STATUS' => array(
										        'width' => '10', 
										        'label' => 'LBL_STATUS', 
										        'link' => false,
										        'default' => true),
										    'START_DATE' => array(
										        'width' => '15', 
										        'label' => 'LBL_LIST_START_DATE', 
										        'link' => false,
										        'default' => true),
										    'END_DATE' => array(
										        'width' => '15', 
										        'label' => 'LBL_LIST_END_DATE', 
										        'link' => false,
										        'default' => true),
											'ASSIGNED_USER_NAME' => array(
												'width' => '10', 
												'label' => 'LBL_LIST_ASSIGNED_USER',
										        'link' => false,
										        'default' => true        
										        ),
										     'account_name'  => array(
												'width' => '10', 
												'label' => 'LBL_LIST_ASSIGNED_USER',
										        'link' => false,
										        ),
											),
						'searchdefs'   => array(
										 	'name', 
											'reference_code', 
											'status',
											'start_date',
											'end_date',
											array('name' => 'assigned_user_id', 'type' => 'enum', 'label' => 'LBL_ASSIGNED_TO', 'function' => array('name' => 'get_user_array', 'params' => array(false))),
										  )
);
?>
