<?php
if ( ! defined ( 'sugarEntry' ) || ! sugarEntry )
    die ( 'Not A Valid Entry Point' ) ;
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Professional Subscription
 * Agreement ("License") which can be viewed at
 * http://www.sugarcrm.com/crm/products/sugar-professional-eula.html
 * By installing or using this file, You have unconditionally agreed to the
 * terms and conditions of the License, and You may not use this file except in
 * compliance with the License.  Under the terms of the license, You shall not,
 * among other things: 1) sublicense, resell, rent, lease, redistribute, assign
 * or otherwise transfer Your rights to the Software, and 2) use the Software
 * for timesharing or service bureau purposes such as hosting the Software for
 * commercial gain and/or for the benefit of a third party.  Use of the Software
 * may be subject to applicable fees and any use of the Software without first
 * paying applicable fees is strictly prohibited.  You do not have the right to
 * remove SugarCRM copyrights from the source code or user interface.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *  (i) the "Powered by SugarCRM" logo and
 *  (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * Your Warranty, Limitations of liability and Indemnity are expressly stated
 * in the License.  Please refer to the License for the specific language
 * governing these rights and limitations under the License.  Portions created
 * by SugarCRM are Copyright (C) 2004-2007 SugarCRM, Inc.; All Rights Reserved.
 ********************************************************************************/
require_once ('modules/DynamicFields/templates/Fields/TemplateEnum.php') ;
require_once ('include/utils/array_utils.php') ;
class TemplateMultiEnum extends TemplateEnum
{
    var $type = 'text' ;
    
    function get_html_edit ()
    {
        $this->prepare () ;
        $xtpl_var = strtoupper ( $this->name ) ;
        // MFH BUG#13645
        return "<input type='hidden' name='" . $this->name . "' value='0'><select name='" . $this->name . "[]' size='5' title='{" . $xtpl_var . "_HELP}' MULTIPLE=true>{OPTIONS_" . $xtpl_var . "}</select>" ;
    }
    
    function get_db_type ()
    {
        if ( $GLOBALS [ 'db' ]->dbType == 'oci8' )
        {
            return " CLOB " ;
        } else
        {
            return " TEXT " ;
        }
    }
    
    function get_xtpl_edit ()
    {
        $name = $this->name ;
        $value = '' ;
        if ( isset ( $this->bean->$name ) )
        {
            $value = $this->bean->$name ;
        } else
        {
            if ( empty ( $this->bean->id ) )
            {
                $value = $this->default_value ;
            }
        }
        if ( ! empty ( $this->help ) )
        {
            $returnXTPL [ strtoupper ( $this->name . '_help' ) ] = translate ( $this->help, $this->bean->module_dir ) ;
        }
        
        global $app_list_strings ;
        $returnXTPL = array ( ) ;
        
        $returnXTPL [ strtoupper ( $this->name ) ] = str_replace ( '^,^', ',', $value ) ;
        if ( empty ( $this->ext1 ) )
        {
            $this->ext1 = $this->options ;
        }
        $returnXTPL [ strtoupper ( 'options_' . $this->name ) ] = get_select_options_with_id ( $app_list_strings [ $this->ext1 ], explode ( '^,^', $value ) ) ;
        
        return $returnXTPL ;
    
    }
    function prepSave ()
    {
    
    }
    function get_xtpl_list ()
    {
        return $this->get_xtpl_detail () ;
    
    }
    function get_xtpl_detail ()
    {
        
        $name = $this->name ;
        $value = '' ;
        if ( isset ( $this->bean->$name ) )
        {
            $value = $this->bean->$name ;
        } else
        {
            if ( empty ( $this->bean->id ) )
            {
                $value = $this->default_value ;
            }
        }
        $returnXTPL = array ( ) ;
        if ( empty ( $value ) )
            return $returnXTPL ;
        global $app_list_strings ;
        
        $values = explode ( '^,^', $value ) ;
        $translatedValues = array ( ) ;
        
        foreach ( $values as $val )
        {
            $translated = translate ( $this->options, '', $val ) ;
            if ( is_string ( $translated ) )
                $translatedValues [] = $translated ;
        }
        
        $returnXTPL [ strtoupper ( $this->name ) ] = implode ( ', ', $translatedValues ) ;
        return $returnXTPL ;
    
    }
    function get_field_def ()
    {
        $def = parent::get_field_def () ;
 
// uncomment the following for Dynamic Fields to handle defaults the same way as we handle them for fields in ModuleBuilder modules
// special handling for multienum fields - because multienums are implemented in some <DB>handler.php's as field types which cannot take a default value, we store the default directly in the vardefs, just as we do for dates (for the same reason)
// 'default' values in the vardef => a default in the db schema, 'display_default' values are by contrast handled in populateDefaultValue in SugarBean       
        if ( ! empty ( $def [ 'default' ] ) )
        {
            $def [ 'display_default' ] = $def [ 'default' ] ;
            $def [ 'default' ] = '' ;
       }
        return array_merge ( array ( 'isMultiSelect' => true ), $def ) ;
    }
    
    function get_db_default ()
    {
        return '' ;
    }

}

?>
