{*
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Professional Subscription
 * Agreement ("License") which can be viewed at
 * http://www.sugarcrm.com/crm/products/sugar-professional-eula.html
 * By installing or using this file, You have unconditionally agreed to the
 * terms and conditions of the License, and You may not use this file except in
 * compliance with the License.  Under the terms of the license, You shall not,
 * among other things: 1) sublicense, resell, rent, lease, redistribute, assign
 * or otherwise transfer Your rights to the Software, and 2) use the Software
 * for timesharing or service bureau purposes such as hosting the Software for
 * commercial gain and/or for the benefit of a third party.  Use of the Software
 * may be subject to applicable fees and any use of the Software without first
 * paying applicable fees is strictly prohibited.  You do not have the right to
 * remove SugarCRM copyrights from the source code or user interface.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *  (i) the "Powered by SugarCRM" logo and
 *  (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * Your Warranty, Limitations of liability and Indemnity are expressly stated
 * in the License.  Please refer to the License for the specific language
 * governing these rights and limitations under the License.  Portions created
 * by SugarCRM are Copyright (C) 2004-2007 SugarCRM, Inc.; All Rights Reserved.
 ********************************************************************************/
*}
<form name="emailSettingsGeneral" id="formEmailSettingsGeneral">

<table cellpadding="4" cellspacing="0" border="0">
	<tr>
		<th colspan="4">
			<div class="sectionTitle">{$app_strings.LBL_EMAIL_SETTINGS_TITLE_PREFERENCES}</div>
		</th>
	</tr>
	<tr>
		<td width="20%" NOWRAP class="tabDetailViewDL">
			{$app_strings.LBL_EMAIL_SETTINGS_CHECK_INTERVAL}:
		</td>
		<td width="30%" NOWRAP class="tabDetailViewDF">
			{html_options options=$emailCheckInterval.options selected=$emailCheckInterval.selected name='emailCheckInterval' id='emailCheckInterval'}
		</td>
		<td NOWRAP class="tabDetailViewDL">
			&nbsp;
		</td>
		<td NOWRAP class="tabDetailViewDF">
			&nbsp;
		</td>
	</tr>
	<tr>
		<td width="20%" NOWRAP class="tabDetailViewDL">
			{$app_strings.LBL_EMAIL_SETTINGS_SEND_EMAIL_AS}:
		</td>
		<td width="30%" NOWRAP class="tabDetailViewDF">
			<input class="checkbox" type="checkbox" id="sendPlainText" name="sendPlainText" value="1" {$sendPlainTextChecked} />
		</td>
		<td NOWRAP class="tabDetailViewDL">
			{$app_strings.LBL_EMAIL_SETTINGS_SAVE_OUTBOUND}:
		</td>
		<td NOWRAP class="tabDetailViewDF">
			<input class='checkbox' type="checkbox" id="alwaysSaveOutbound" name="alwaysSaveOutbound" value="1" {$alwaysSaveOutboundChecked} />
		</td>
	</tr>
	<tr>
		<td NOWRAP class="tabDetailViewDL">
        	{if isset($pro)}
				{$app_strings.LBL_EMAIL_TEAMS}:
        	{else}
        		&nbsp;
        	{/if}
        </td>
		<td NOWRAP class="tabDetailViewDF">
        	{if isset($pro)}
				{html_options options=$teams.options selected=$teams.selected name='assign_to_team' id='assign_to_team'}
        	{else}
        		&nbsp;
        	{/if}
        </td>
		<td NOWRAP class="tabDetailViewDL">
        	{$app_strings.LBL_EMAIL_SIGNATURES}:
        </td>
		<td NOWRAP class="tabDetailViewDF">
        	{$signaturesSettings} {$signatureButtons} 
        	<input type="hidden" name="signatureDefault" id="signatureDefault" value="{$signatureDefaultId}">
        </td>
	</tr>
	<tr>
		<td NOWRAP class="tabDetailViewDL">
        	{$app_strings.LBL_EMAIL_CHARSET}:
        </td>
		<td NOWRAP class="tabDetailViewDF">
        	{html_options options=$charset.options selected=$charset.selected name='default_charset' id='default_charset'}
        </td>
		<td NOWRAP class="tabDetailViewDL">
        	{$mod_strings.LBL_SIGNATURE_PREPEND}:
        </td>
		<td NOWRAP class="tabDetailViewDF">
        	<input type="checkbox" name="signature_prepend" {$signaturePrepend}>
        </td>
	</tr>


	<tr>
		<th colspan="4">
			<div class="sectionTitle">{$app_strings.LBL_EMAIL_SETTINGS_TITLE_LAYOUT}</div>
			<i>{$app_strings.LBL_EMAIL_SETTINGS_REQUIRE_REFRESH}</i>
		</th>
	</tr>
	<tr>
		<td NOWRAP class="tabDetailViewDL">
			{$app_strings.LBL_EMAIL_SETTINGS_LAYOUT}:
		</td>
		<td NOWRAP class="tabDetailViewDF">
			<input type="radio" name="layoutStyle" id="2rows" value="2rows" {$rowsChecked}>  <img src="modules/Emails/images/rowsView.gif" align="absmiddle" height="10"> {$app_strings.LBL_EMAIL_SETTINGS_2_ROWS}<br>
			<input type="radio" name="layoutStyle" id="2cols" value="2cols" {$colsChecked}>  <img src="modules/Emails/images/colsView.gif" align="absmiddle" height="10"> {$app_strings.LBL_EMAIL_SETTINGS_3_COLS}<br>
		</td>
		<td NOWRAP class="tabDetailViewDL">
			{$app_strings.LBL_EMAIL_SETTINGS_TAB_POS}:
		</td>
		<td NOWRAP class="tabDetailViewDF">
			<input type="checkbox" name="tabPosition" id="tabPosition" value="top" {$tabPositionChecked}>
		</td>
	</tr>
	<tr>
		<td NOWRAP class="tabDetailViewDL">
			{$app_strings.LBL_EMAIL_SETTINGS_SHOW_NUM_IN_LIST}:
		</td>
		<td NOWRAP class="tabDetailViewDF">
			<select name="showNumInList" id="showNumInList">
			{$showNumInList}
			</select>
		</td>
		<td NOWRAP class="tabDetailViewDL">
			{$app_strings.LBL_EMAIL_SETTINGS_FULL_SCREEN}:
		</td>
		<td NOWRAP class="tabDetailViewDF">
			<input type="checkbox" class="checkbox" id="fullScreen" name="fullScreen" value="1" {$fullScreenChecked} onchange="SUGAR.email2.settings.toggleFullScreen(this);">
		</td>
	</tr>



	<tr>
		<td NOWRAP class="tabDetailViewDF">
			&nbsp;
		</td>
		<td NOWRAP class="tabDetailViewDF">
			<input type="button" class="button" value="   {$app_strings.LBL_EMAIL_SAVE}   " onclick="javascript:SUGAR.email2.settings.saveOptionsGeneral(true);">
		</td>
		<td NOWRAP class="tabDetailViewDL">
			&nbsp;
		</td>
		<td NOWRAP class="tabDetailViewDF">
			&nbsp;
		</td>
	</tr>
</table>

</form>
