<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Professional Subscription
 * Agreement ("License") which can be viewed at
 * http://www.sugarcrm.com/crm/products/sugar-professional-eula.html
 * By installing or using this file, You have unconditionally agreed to the
 * terms and conditions of the License, and You may not use this file except in
 * compliance with the License.  Under the terms of the license, You shall not,
 * among other things: 1) sublicense, resell, rent, lease, redistribute, assign
 * or otherwise transfer Your rights to the Software, and 2) use the Software
 * for timesharing or service bureau purposes such as hosting the Software for
 * commercial gain and/or for the benefit of a third party.  Use of the Software
 * may be subject to applicable fees and any use of the Software without first
 * paying applicable fees is strictly prohibited.  You do not have the right to
 * remove SugarCRM copyrights from the source code or user interface.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *  (i) the "Powered by SugarCRM" logo and
 *  (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * Your Warranty, Limitations of liability and Indemnity are expressly stated
 * in the License.  Please refer to the License for the specific language
 * governing these rights and limitations under the License.  Portions created
 * by SugarCRM are Copyright (C) 2004-2007 SugarCRM, Inc.; All Rights Reserved.
 ********************************************************************************/

require_once('include/database/PearDatabase.php');
require_once('data/SugarBean.php');


// User is used to store Forecast information.
class Worksheet extends SugarBean {

	var $id;

	var $table_name = "worksheet";
	
	var $object_name = "Worksheet";

	// This is used to retrieve related fields from form posts.
	var $additional_column_fields = Array('');

	

	var $new_schema = true;
	var $module_dir = 'Forecasts';
	function Worksheet() {
		global $current_user;
		parent::SugarBean();
		$this->disable_row_level_security =true;
	}

	function save($check_notify = false){	
	
		parent::save($check_notify);		
	}

	function get_summary_text() {
		return "$this->id";
	}

	function retrieve($id, $encode=false){
		$ret = parent::retrieve($id, $encode);	
		
		return $ret;
	}

	function is_authenticated()
	{
		return $this->authenticated;
	}

	function create_list_query($order_by, $where, $show_deleted=0 )
	{	
		//this module does not support custom fields.
		$query = "select *";
		$query .= " FROM worksheet ";

		if (isset($where)) $query .= " WHERE ".$where;

		if(!empty($order_by))
			$query .= " ORDER BY $order_by";
		
		return $query;
	}
	
}
?>
