<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Professional Subscription
 * Agreement ("License") which can be viewed at
 * http://www.sugarcrm.com/crm/products/sugar-professional-eula.html
 * By installing or using this file, You have unconditionally agreed to the
 * terms and conditions of the License, and You may not use this file except in
 * compliance with the License.  Under the terms of the license, You shall not,
 * among other things: 1) sublicense, resell, rent, lease, redistribute, assign
 * or otherwise transfer Your rights to the Software, and 2) use the Software
 * for timesharing or service bureau purposes such as hosting the Software for
 * commercial gain and/or for the benefit of a third party.  Use of the Software
 * may be subject to applicable fees and any use of the Software without first
 * paying applicable fees is strictly prohibited.  You do not have the right to
 * remove SugarCRM copyrights from the source code or user interface.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *  (i) the "Powered by SugarCRM" logo and
 *  (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * Your Warranty, Limitations of liability and Indemnity are expressly stated
 * in the License.  Please refer to the License for the specific language
 * governing these rights and limitations under the License.  Portions created
 * by SugarCRM are Copyright (C) 2004-2007 SugarCRM, Inc.; All Rights Reserved.
 ********************************************************************************/

global $current_user, $sugar_version, $sugar_config, $image_path;

require_once('include/Sugar_Smarty.php');

// build dashlet cache file if not found
if(!is_file('cache/dashlets/dashlets.php')) {
    require_once('include/Dashlets/DashletCacheBuilder.php');
    
    $dc = new DashletCacheBuilder();
    $dc->buildCache();
}
require_once('cache/dashlets/dashlets.php');

$pages = $current_user->getPreference('pages', 'Home'); 
$dashlets = $current_user->getPreference('dashlets', 'Home');

$defaultHomepage = false;
// BEGIN fill in with default homepage and dashlet selections
if(!isset($pages) || !isset($dashlets)){

	// BEGIN 'My Sugar'
	$defaultHomepage = true;

    $dashlets = array();
    
    //list of preferences to move over and to where
    $prefstomove = array(
        'mypbss_date_start' => 'MyPipelineBySalesStageDashlet',
        'mypbss_date_end' => 'MyPipelineBySalesStageDashlet',
        'mypbss_sales_stages' => 'MyPipelineBySalesStageDashlet',
        'mypbss_chart_type' => 'MyPipelineBySalesStageDashlet',
        'lsbo_lead_sources' => 'OpportunitiesByLeadSourceByOutcomeDashlet',
        'lsbo_ids' => 'OpportunitiesByLeadSourceByOutcomeDashlet',
        'pbls_lead_sources' => 'OpportunitiesByLeadSourceDashlet',
        'pbls_ids' => 'OpportunitiesByLeadSourceDashlet',
        'pbss_date_start' => 'PipelineBySalesStageDashlet',
        'pbss_date_end' => 'PipelineBySalesStageDashlet',
        'pbss_sales_stages' => 'PipelineBySalesStageDashlet',
        'pbss_chart_type' => 'PipelineBySalesStageDashlet',
        'obm_date_start' => 'OutcomeByMonthDashlet',
        'obm_date_end' => 'OutcomeByMonthDashlet',
        'obm_ids' => 'OutcomeByMonthDashlet');

	//upgrading from pre-5.0 homepage
	$old_columns = $current_user->getPreference('columns', 'home');
	$old_dashlets = $current_user->getPreference('dashlets', 'home');

	if (isset($old_columns) && !empty($old_columns) && isset($old_dashlets) && !empty($old_dashlets)){
		$columns = $old_columns;
		$dashlets = $old_dashlets;
		
		// resetting old columns and dashlets to have no preference and data
		$old_columns = array();
		$old_dashlets = array();
		$current_user->setPreference('columns', $old_columns, 0, 'home');
		$current_user->setPreference('dashlets', $old_dashlets, 0, 'home');
	}
	else{
	    $defaultDashlets = array('MyCallsDashlet', 'JotPadDashlet', 'MyMeetingsDashlet', 'MyCasesDashlet', 'MyLeadsDashlet',

	      //  'TeamNoticesDashlet', 

	        'MyOpportunitiesDashlet', 'MyAccountsDashlet', );
	    
	    foreach($defaultDashlets as $dashletName){
	    	if (isset($dashletsFiles[$dashletName])){
	        	$options = array();
               $prefsforthisdashlet = array_keys($prefstomove,$dashletName);
               foreach ( $prefsforthisdashlet as $pref ) {
                   $options[$pref] = $current_user->getPreference($pref);
               }
                $dashlets[create_guid()] = array('className' => $dashletName, 
	            	                             'fileLocation' => $dashletsFiles[$dashletName]['file'],
                                                 'options' => $options);
	    	}
	    }
	    
	    $count = 0;
	    $columns = array();
	    $columns[0] = array();
	    $columns[0]['width'] = '60%';
	    $columns[0]['dashlets'] = array();
	    $columns[1] = array();
	    $columns[1]['width'] = '40%';
	    $columns[1]['dashlets'] = array();
	    
	    foreach($dashlets as $guid=>$dashlet) {
	        if($count % 2 == 0) array_push($columns[0]['dashlets'], $guid); 
	        else array_push($columns[1]['dashlets'], $guid);
	        $count++;
	    }
	}


    // END 'My Sugar'



    require_once('modules/Reports/SavedReport.php');
    
    // BEGIN 'Sales Page'
    $defaultSalesChartDashlets = array( translate('DEFAULT_REPORT_TITLE_6', 'Reports'),
										  );    
    $defaultSalesDashlets = array( 'MyPipelineBySalesStageDashlet', 
    								   'MyOpportunitiesGaugeDashlet', 
    								   'MyOpportunitiesDashlet',
    								   'MyClosedOpportunitiesDashlet',
    								   'MyForecastingChartDashlet',
    								  );   								  
        
    foreach($defaultSalesDashlets as $salesDashletName){
    	if (isset($dashletsFiles[$salesDashletName])){
            $options = array();
            $prefsforthisdashlet = array_keys($prefstomove,$salesDashletName);
            foreach ( $prefsforthisdashlet as $pref ) {
               $options[$pref] = $current_user->getPreference($pref);
            }
            $salesDashlets[create_guid()] = array('className' => $salesDashletName, 
	                                         'fileLocation' => $dashletsFiles[$salesDashletName]['file'],
                                             'options' => $options);
    	}
    }    

    foreach ($defaultSalesChartDashlets as $salesChartDashlet){
		$savedReport = new SavedReport();
		$reportId = $savedReport->retrieveReportIdByName($salesChartDashlet);
		if(!isset($reportId))
			continue;
					
    	$salesDashlets[create_guid()] = array('className' => 'ChartsDashlet',
    												'fileLocation' => $dashletsFiles['ChartsDashlet']['file'],
    												'reportId' => $reportId, );
    }    
    
    $count = 0;
    $salesColumns = array();
    $salesColumns[0] = array();
    $salesColumns[0]['width'] = '60%';
    $salesColumns[0]['dashlets'] = array();
    $salesColumns[1] = array();
    $salesColumns[1]['width'] = '40%';
    $salesColumns[1]['dashlets'] = array();

    foreach($salesDashlets as $guid=>$dashlet){
        if($count % 2 == 0) array_push($salesColumns[0]['dashlets'], $guid); 
        else array_push($salesColumns[1]['dashlets'], $guid);        
        $count++;
    }
    // END 'Sales Page'
    
	// BEGIN 'Marketing & Support Page'       
	$defaultMarketingChartDashlets = array( translate('DEFAULT_REPORT_TITLE_9', 'Reports'), // Open Cases By Priority By User
											translate('DEFAULT_REPORT_TITLE_10', 'Reports'), // New Cases By Month
											translate('DEFAULT_REPORT_TITLE_18', 'Reports'), // Leads By Lead Source
										  );
										  
	$defaultMarketingDashlets = array( 'MyLeadsDashlet', 
    								  );
											
    foreach ($defaultMarketingChartDashlets as $marketingChartDashlet){
		$savedReport = new SavedReport();
		$reportId = $savedReport->retrieveReportIdByName($marketingChartDashlet);
		if(!isset($reportId))
			continue;
    	
    	$marketingDashlets[create_guid()] = array('className' => 'ChartsDashlet',
    												'fileLocation' => $dashletsFiles['ChartsDashlet']['file'],
    												'reportId' => $reportId, );
    }
    	     								  
    foreach($defaultMarketingDashlets as $marketingDashletName){
    	if (isset($dashletsFiles[$marketingDashletName])){
	        $options = array();
            $prefstomove = array_keys($prefstomove,$marketingDashletName);
            foreach ( $prefsforthisdashlet as $pref ) {
               $options[$pref] = $prefsforthisdashlet->getPreference($pref);
            }
            $marketingDashlets[create_guid()] = array('className' => $marketingDashletName, 
	                                         'fileLocation' => $dashletsFiles[$marketingDashletName]['file'],
                                             'options' => $options);
    	}
    }    
    
    $count = 0;
    $marketingColumns = array();
    $marketingColumns[0] = array();
    $marketingColumns[0]['width'] = '30%';
    $marketingColumns[0]['dashlets'] = array();
    $marketingColumns[1] = array();
    $marketingColumns[1]['width'] = '30%';
    $marketingColumns[1]['dashlets'] = array();
    $marketingColumns[2] = array();
    $marketingColumns[2]['width'] = '40%';
    $marketingColumns[2]['dashlets'] = array();
    
    foreach($marketingDashlets as $guid=>$dashlet){
        if($count % 3 == 0) array_push($marketingColumns[0]['dashlets'], $guid); 
        else if($count % 3 == 1) array_push($marketingColumns[1]['dashlets'], $guid);         
        else array_push($marketingColumns[2]['dashlets'], $guid);        
        $count++;
    }
	// END 'Marketing & Support Page'
    
    $dashlets = array_merge($dashlets, $salesDashlets, $marketingDashlets);

    
    $current_user->setPreference('dashlets', $dashlets, 0, 'Home');
}

if (empty($pages)){
	$pages = array();
	$pages[0]['columns'] = $columns;
	$pages[0]['numColumns'] = '2';
	$pages[0]['pageTitle'] = $mod_strings['LBL_HOME_PAGE_1_NAME'];	// "My Sugar"


	$pages[1]['columns'] = $salesColumns;
	$pages[1]['numColumns'] = '2';
	$pages[1]['pageTitle'] = $mod_strings['LBL_HOME_PAGE_2_NAME'];	// "Sales Page"

	$pages[2]['columns'] = $marketingColumns;
	$pages[2]['numColumns'] = '3';
	$pages[2]['pageTitle'] = $mod_strings['LBL_HOME_PAGE_3_NAME'];	// "Marketing & Support Page"	

	$current_user->setPreference('pages', $pages, 0, 'Home');

    $_COOKIE[$current_user->id . '_activePage'] = '0';
    setcookie($current_user->id . '_activePage','0',3000);

    $activePage = 0;	
}


if(isset($_COOKIE[$current_user->id . '_activePage']) && $_COOKIE[$current_user->id . '_activePage'] != '' && isset($pages[$_COOKIE[$current_user->id . '_activePage']]))
    $activePage = $_COOKIE[$current_user->id . '_activePage'];
else{
    $_COOKIE[$current_user->id . '_activePage'] = '0';
    setcookie($current_user->id . '_activePage','0',3000);

    $activePage = 0;

}


$divPages[] = $activePage;

$numCols = $pages[$activePage]['numColumns'];


foreach($pages as $pageNum => $page){
    //grab the now viewed pages to render the <div> foreach
    if($pageNum != $activePage)
        $divPages[] = $pageNum;

    $pageData[$pageNum]['pageTitle'] = $page['pageTitle'];

    if($pageNum == $activePage){
        $pageData[$pageNum]['tabClass'] = 'current';
        $pageData[$pageNum]['visibility'] = 'inline';
    }
    else{
        $pageData[$pageNum]['tabClass'] = '';
        $pageData[$pageNum]['visibility'] = 'none';
    }
}    


$count = 0;
//$columns = array(0 => array('dashlets' => array(), 'width' => '60%'), 1 => array('dashlets' => array(), 'width' => '40%'));
$dashletIds = array(); // collect ids to pass to javascript
$display = array();

foreach($pages[$activePage]['columns'] as $colNum => $column) {
	if ($colNum == $numCols){
		break;
	}	
    $display[$colNum]['width'] = $column['width'];
    $display[$colNum]['dashlets'] = array(); 
    foreach($column['dashlets'] as $num => $id) {
        if(!empty($id) && isset($dashlets[$id]) && is_file($dashlets[$id]['fileLocation'])) {
        	require_once($dashlets[$id]['fileLocation']);

        	if ($dashlets[$id]['className'] == 'ChartsDashlet'){
        		$dashlet = new $dashlets[$id]['className']($id, $dashlets[$id]['reportId'], (isset($dashlets[$id]['options']) ? $dashlets[$id]['options'] : array()));
        	}
            else{

	            $dashlet = new $dashlets[$id]['className']($id, (isset($dashlets[$id]['options']) ? $dashlets[$id]['options'] : array()));

            }

            array_push($dashletIds, $id);

            $dashlet->process();
            $display[$colNum]['dashlets'][$id]['display'] = $dashlet->display();
            if($dashlet->hasScript) {
                $display[$colNum]['dashlets'][$id]['script'] = $dashlet->displayScript();
            }
        }
    }
}

$sugar_smarty = new Sugar_Smarty();
if(!empty($sugar_config['lock_homepage']) && $sugar_config['lock_homepage'] == true) $sugar_smarty->assign('lock_homepage', true);  


$sugar_smarty->assign('pages', $pageData);
$sugar_smarty->assign('numPages', sizeof($pages));
$sugar_smarty->assign('loadedPage', 'pageNum_' . $activePage .'_div');


$sugar_smarty->assign('sugarVersion', $sugar_version);
$sugar_smarty->assign('sugarFlavor', $sugar_flavor);
$sugar_smarty->assign('currentLanguage', $GLOBALS['current_language']);
$sugar_smarty->assign('serverUniqueKey', $GLOBALS['server_unique_key']);
$sugar_smarty->assign('imagePath', $GLOBALS['image_path']);

$sugar_smarty->assign('jsCustomVersion', $sugar_config['js_custom_version']);
$sugar_smarty->assign('maxCount', empty($sugar_config['max_dashlets_homepage']) ? 15 : $sugar_config['max_dashlets_homepage']);
$sugar_smarty->assign('dashletCount', $count);
$sugar_smarty->assign('dashletIds', '["' . implode('","', $dashletIds) . '"]');
$sugar_smarty->assign('columns', $display);

global $theme;
$sugar_smarty->assign('theme', $theme);

$sugar_smarty->assign('divPages', $divPages);
$sugar_smarty->assign('activePage', $activePage);

$sugar_smarty->assign('numCols', $pages[$activePage]['numColumns']);
$sugar_smarty->assign('default', $defaultHomepage);


$sugar_smarty->assign('current_user', $current_user->id);

$sugar_smarty->assign('lblAddDashlets', $GLOBALS['app_strings']['LBL_ADD_DASHLETS']);
$sugar_smarty->assign('lblLnkHelp', $GLOBALS['app_strings']['LNK_HELP']);

$sugar_smarty->assign('lblAddPage', $GLOBALS['app_strings']['LBL_ADD_PAGE']);
$sugar_smarty->assign('lblPageName', $GLOBALS['app_strings']['LBL_PAGE_NAME']);
$sugar_smarty->assign('lblChangeLayout', $GLOBALS['app_strings']['LBL_CHANGE_LAYOUT']);
$sugar_smarty->assign('lblNumberOfColumns', $GLOBALS['app_strings']['LBL_NUMBER_OF_COLUMNS']);
$sugar_smarty->assign('lbl1Column', $GLOBALS['app_strings']['LBL_1_COLUMN']);
$sugar_smarty->assign('lbl2Column', $GLOBALS['app_strings']['LBL_2_COLUMN']);
$sugar_smarty->assign('lbl3Column', $GLOBALS['app_strings']['LBL_3_COLUMN']);


$sugar_smarty->assign('module', 'Home');
echo $sugar_smarty->fetch('include/MySugar/tpls/MySugar.tpl');

?>
