<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Professional Subscription
 * Agreement ("License") which can be viewed at
 * http://www.sugarcrm.com/crm/products/sugar-professional-eula.html
 * By installing or using this file, You have unconditionally agreed to the
 * terms and conditions of the License, and You may not use this file except in
 * compliance with the License.  Under the terms of the license, You shall not,
 * among other things: 1) sublicense, resell, rent, lease, redistribute, assign
 * or otherwise transfer Your rights to the Software, and 2) use the Software
 * for timesharing or service bureau purposes such as hosting the Software for
 * commercial gain and/or for the benefit of a third party.  Use of the Software
 * may be subject to applicable fees and any use of the Software without first
 * paying applicable fees is strictly prohibited.  You do not have the right to
 * remove SugarCRM copyrights from the source code or user interface.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *  (i) the "Powered by SugarCRM" logo and
 *  (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * Your Warranty, Limitations of liability and Indemnity are expressly stated
 * in the License.  Please refer to the License for the specific language
 * governing these rights and limitations under the License.  Portions created
 * by SugarCRM are Copyright (C) 2004-2007 SugarCRM, Inc.; All Rights Reserved.
 ********************************************************************************/
/*********************************************************************************

 * Description:  TODO: To be written.
 ********************************************************************************/



require_once('modules/Manufacturers/Manufacturer.php');
require_once('modules/ProductTemplates/ProductTemplate.php');
require_once('modules/ProductCategories/ProductCategory.php');
require_once('modules/ProductTypes/ProductType.php');
require_once('modules/Import/UsersLastImport.php');

global $app_list_strings;

class ImportProductType extends ProductType {
	// these are fields that may be set on import
	// but are to be processed and incorporated
	// into fields of the parent class
	var $db;

       // This is the list of the functions to run when importing
        var $special_functions =  array(
	);

	//module prefix used by ImportSteplast when calling ListView.php
	var $list_view_prefix = 'PRODUCTTYPE';

	//columns to be displayed in listview for displaying user's last import in ImportSteplast.php
	var $list_fields = Array(
					  'id'
					, 'name'
					, 'description'
					, 'list_order'
					);

	//this list defines what beans get populated during an import of product types
	var $related_modules = array("ProductTypes",); 
		
	function ImportProductType() {
		parent::ProductType();
	}

	function create_list_query($order_by, $where, $show_deleted = 0)
	{
		global $current_user;
		$query = '';
		
                        $query = "SELECT product_types.*
                                FROM users_last_import,product_types
                        	WHERE
				users_last_import.assigned_user_id=
					'{$current_user->id}'
				AND users_last_import.bean_type='ProductTypes'
				AND users_last_import.bean_id=product_types.id
				AND users_last_import.deleted=0
                                AND product_types.deleted=0 ";
		if(! empty($order_by))
		{
			$query .= " ORDER BY $order_by";
		}

		return $query;


	}
}


?>
