<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Professional Subscription
 * Agreement ("License") which can be viewed at
 * http://www.sugarcrm.com/crm/products/sugar-professional-eula.html
 * By installing or using this file, You have unconditionally agreed to the
 * terms and conditions of the License, and You may not use this file except in
 * compliance with the License.  Under the terms of the license, You shall not,
 * among other things: 1) sublicense, resell, rent, lease, redistribute, assign
 * or otherwise transfer Your rights to the Software, and 2) use the Software
 * for timesharing or service bureau purposes such as hosting the Software for
 * commercial gain and/or for the benefit of a third party.  Use of the Software
 * may be subject to applicable fees and any use of the Software without first
 * paying applicable fees is strictly prohibited.  You do not have the right to
 * remove SugarCRM copyrights from the source code or user interface.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *  (i) the "Powered by SugarCRM" logo and
 *  (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * Your Warranty, Limitations of liability and Indemnity are expressly stated
 * in the License.  Please refer to the License for the specific language
 * governing these rights and limitations under the License.  Portions created
 * by SugarCRM are Copyright (C) 2004-2007 SugarCRM, Inc.; All Rights Reserved.
 ********************************************************************************/
require_once('modules/InboundEmail/InboundEmail.php');
require_once('include/DetailView/DetailView.php');
require_once('modules/Emails/Email.php');
require_once('include/SugarFolders/SugarFolders.php');

global $mod_strings;
global $app_strings;
global $sugar_config;
global $timedate;
global $theme;

/* start standard DetailView layout process */
$GLOBALS['log']->info("InboundEmails DetailView");
$focus = new InboundEmail();
$focus->retrieve($_REQUEST['record']);
$focus->checkImap();
$detailView = new DetailView();
$offset=0;

echo "\n<p>\n";
echo get_module_title($mod_strings['LBL_MODULE_TITLE'], $mod_strings['LBL_MODULE_NAME'].": ".$focus->name, true);
echo "\n</p>\n";

$theme_path="themes/".$theme."/";
$image_path=$theme_path."images/";
/* end standard DetailView layout process */
$exServ = explode('::',$focus->service);
if($focus->delete_seen == 1) {
	$delete_seen = $mod_strings['LBL_MARK_READ_NO'];
} else {
	$delete_seen = $mod_strings['LBL_MARK_READ_YES'];
}

// deferred
//$r = $focus->db->query("SELECT id, name FROM queues WHERE owner_id = '".$focus->id."'");
//$a = $focus->db->fetchByAssoc($r);
//$queue = '<a href="index.php?module=Queues&action=EditView&record='.$a['id'].'">'.$a['name'].'</a>';
$groupName = '';
if($focus->group_id) {
	require_once('modules/Groups/Group.php');
	$group = new Group();
	$group->retrieve($focus->group_id);
	$groupName = $group->user_name;
}

if($focus->template_id) {
	require_once('modules/EmailTemplates/EmailTemplate.php');
	$et = new EmailTemplate();
	$et->retrieve($focus->template_id);
	$emailTemplate = $et->name;
} else {
	$emailTemplate = $mod_strings['LBL_NONE'];
}
if($focus->tls == 'tls') {
	$tls = $app_list_strings['dom_email_bool']['bool_true'];
} else {
	$tls = $app_list_strings['dom_email_bool']['bool_false'];
}
if($focus->ssl == 'ssl') {
	$ssl = $app_list_strings['dom_email_bool']['bool_true'];
} else {
	$ssl = $app_list_strings['dom_email_bool']['bool_false'];
}
if($focus->ca == 'validate-cert') {
	$ca = $app_list_strings['dom_email_bool']['bool_true'];
} else {
	$ca = $app_list_strings['dom_email_bool']['bool_false'];
}


// FROM NAME FROM ADDRESS STRINGS
$email = new Email();
$from = $email->getSystemDefaultEmail();
$fromName = $from['name'];
$fromNameAddr = $fromName.' &lt;'.$from['email'].'&gt; <br><em>('.$mod_strings['LBL_SYSTEM_DEFAULT'].')</em>';
$replyNameAddr = $mod_strings['LBL_SAME_AS_ABOVE'];
$onlySince = $mod_strings['LBL_ONLY_SINCE_NO'];

if(!empty($focus->stored_options)) {
	// FROM NAME and Address
	$storedOptions = unserialize(base64_decode($focus->stored_options));
	if(!empty($storedOptions['from_name']) && !empty($storedOptions['from_addr'])) {
		$fromName = $storedOptions['from_name'];
		$fromNameAddr = $storedOptions['from_name'].' &lt;'.$storedOptions['from_addr'].'&gt;';
	}
	
	// Reply-to Name/addr
	if(isset($storedOptions['reply_to_addr']) && !empty($storedOptions['reply_to_addr'])) {
		$fromName = (!empty($storedOptions['reply_to_name'])) ? $storedOptions['reply_to_name'] : $fromName;
		$replyNameAddr = $fromName.' &lt;'.$storedOptions['reply_to_addr'].'&gt;';
	}
	// only-since option
	if($storedOptions['only_since']) {
		$onlySince = $mod_strings['LBL_ONLY_SINCE_YES'];
	} else {
		$onlySince = $mod_strings['LBL_ONLY_SINCE_NO'];
	}
	// filter-domain
	if(isset($storedOptions['filter_domain']) && !empty($storedOptions['filter_domain'])) {
		$filterDomain = $storedOptions['filter_domain'];
	} else {
		$filterDomain = $app_strings['NTC_NO_ITEMS_DISPLAY'];
	}
}	

$xtpl = new XTemplate('modules/InboundEmail/DetailView.html');
////	ERRORS from Save
if(isset($_REQUEST['error'])) {
	$xtpl->assign('ERROR', "<div class='error'>".$mod_strings['ERR_NO_OPTS_SAVED']."</div>");	
}
$xtpl->assign('MOD', $mod_strings);
$xtpl->assign('APP', $app_strings);
$xtpl->assign('CREATED_BY', $focus->created_by_name);
$xtpl->assign('MODIFIED_BY', $focus->modified_by_name);
$xtpl->assign('THEME', $theme);
$xtpl->assign('GRIDLINE', $gridline);
$xtpl->assign('IMAGE_PATH', $image_path);$xtpl->assign('PRINT_URL', 'index.php?'.$GLOBALS['request_string']);
$xtpl->assign('ID', $focus->id);
$xtpl->assign('STATUS', $focus->status);
$xtpl->assign('SERVER_URL', $focus->server_url);
$xtpl->assign('USER', $focus->email_user);
$xtpl->assign('NAME', $focus->name);
$xtpl->assign('MAILBOX', $focus->mailbox);
$xtpl->assign('SERVER_TYPE', $app_list_strings['dom_email_server_type'][$focus->protocol]);
$xtpl->assign('SSL', $ssl);
$xtpl->assign('TLS', $tls);
$xtpl->assign('CERT', $ca);
$xtpl->assign('MARK_READ', $delete_seen);
// deferred
//$xtpl->assign('QUEUE', $queue);
if ($focus->is_personal) {
	$xtpl->assign('EDIT_GROUP_FOLDER_STYLE', "display:none");
} else {
	$groupFolderName = "None";
	$folder = new SugarFolder();
	if (!empty($focus->groupfolder_id)) {
		$folder->retrieve($focus->groupfolder_id);
		$groupFolderName = $folder->name;
	} // if
	$xtpl->assign('ASSIGN_TO_FOLDER', $groupFolderName);
	$xtpl->assign('EDIT_GROUP_FOLDER_STYLE', "display:''");
}
$xtpl->assign('GROUP_NAME', $groupName);
$xtpl->assign('MAILBOX_TYPE', $app_list_strings['dom_mailbox_type'][$focus->mailbox_type]);
$xtpl->assign('EMAIL_TEMPLATE', $emailTemplate);
$xtpl->assign('FROM_NAME_ADDR', $fromNameAddr);
$xtpl->assign('REPLY_NAME_ADDR', $replyNameAddr);
$xtpl->assign('ONLY_SINCE', $onlySince);
$xtpl->assign('FILTER_DOMAIN', $filterDomain);

if(!empty($focus->team_id)) {
	$r = $focus->db->query("SELECT name FROM teams WHERE id = '$focus->team_id'");
	while($a = $focus->db->fetchByAssoc($r)) {
		$team_name = $a['name'];
	}
	
	if(!isset($team_name) || empty($team_name)) {
		$team_name = $app_strings['NTC_NO_ITEMS_DISPLAY'];
	}
	$xtpl->assign('TEAM_NAME', $team_name);
}

if($focus->handleIsPersonal()) {
	$xtpl->assign('LBL_GROUP_QUEUE', $mod_strings['LBL_ASSIGN_TO_USER']);
} else {
	$xtpl->assign('LBL_GROUP_QUEUE', $mod_strings['LBL_GROUP_QUEUE']);
}
$xtpl->parse('main');
$xtpl->out('main');
?>
