<?php
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Professional Subscription
 * Agreement ("License") which can be viewed at
 * http://www.sugarcrm.com/crm/products/sugar-professional-eula.html
 * By installing or using this file, You have unconditionally agreed to the
 * terms and conditions of the License, and You may not use this file except in
 * compliance with the License.  Under the terms of the license, You shall not,
 * among other things: 1) sublicense, resell, rent, lease, redistribute, assign
 * or otherwise transfer Your rights to the Software, and 2) use the Software
 * for timesharing or service bureau purposes such as hosting the Software for
 * commercial gain and/or for the benefit of a third party.  Use of the Software
 * may be subject to applicable fees and any use of the Software without first
 * paying applicable fees is strictly prohibited.  You do not have the right to
 * remove SugarCRM copyrights from the source code or user interface.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *  (i) the "Powered by SugarCRM" logo and
 *  (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * Your Warranty, Limitations of liability and Indemnity are expressly stated
 * in the License.  Please refer to the License for the specific language
 * governing these rights and limitations under the License.  Portions created
 * by SugarCRM are Copyright (C) 2004-2007 SugarCRM, Inc.; All Rights Reserved.
 ********************************************************************************/
$viewdefs['Meetings']['EditView'] = array(
    'templateMeta' => array('maxColumns' => '2', 
                            'form' => array('hidden'=>array('<input type="hidden" name="isSaveAndNew" value="false">'),
											'buttons' => array(
                                             array('customCode'=>'<input title="{$APP.LBL_SAVE_BUTTON_TITLE}" accessKey="{$APP.LBL_SAVE_BUTTON_KEY}" class="button" onclick="fill_invitees();this.form.action.value=\'Save\'; this.form.return_action.value=\'DetailView\'; return check_form(\'EditView\') && isValidDuration();" type="submit" name="button" value="{$APP.LBL_SAVE_BUTTON_LABEL}">'), 
                                             'CANCEL',
                                             array('customCode'=>'<input title="{$MOD.LBL_SEND_BUTTON_TITLE}" class="button" onclick="this.form.send_invites.value=\'1\';fill_invitees();this.form.action.value=\'Save\';this.form.return_action.value=\'EditView\';this.form.return_module.value=\'{$RETURN_MODULE}\';return check_form(\'EditView\') && isValidDuration();" type="submit" name="button" value="{$MOD.LBL_SEND_BUTTON_LABEL}">'),
                                             array('customCode'=>'{if $fields.status.value != "Held"}' .
                                             		'<input title="{$APP.LBL_CLOSE_AND_CREATE_BUTTON_TITLE}" ' .
                                             		'accessKey="{$APP.LBL_CLOSE_AND_CREATE_BUTTON_KEY}" ' .
                                             		'class="button" ' .
                                             		'onclick="fill_invitees(); document.getElementById(\'status\').value=\'Held\'; this.form.action.value=\'Save\'; this.form.return_module.value=\'Meetings\'; this.form.isDuplicate.value=true; this.form.isSaveAndNew.value=true; this.form.return_action.value=\'EditView\'; this.form.return_id.value=\'{$fields.id.value}\'; return check_form(\'EditView\') && isValidDuration();" ' .
                                             		'type="submit" name="button" ' .
                                             		'value="{$APP.LBL_CLOSE_AND_CREATE_BUTTON_LABEL}">{/if}'),
                                            ),
                                            'headerTpl'=>'modules/Meetings/tpls/header.tpl',
                                            'footerTpl'=>'modules/Meetings/tpls/footer.tpl'),
                            'widths' => array(
                                            array('label' => '10', 'field' => '30'), 
                                            array('label' => '10', 'field' => '30')
                                            ),
    						'javascript' => '<script type="text/javascript" src="include/JSON.js?s={$SUGAR_VERSION}&c={$JS_CUSTOM_VERSION}"></script>
<script type="text/javascript" src="include/jsolait/init.js?s={$SUGAR_VERSION}&c={$JS_CUSTOM_VERSION}"></script>
<script type="text/javascript" src="include/jsolait/lib/urllib.js?s={$SUGAR_VERSION}&c={$JS_CUSTOM_VERSION}"></script>
<script type="text/javascript">{$JSON_CONFIG_JAVASCRIPT}</script>
<script type="text/javascript" src="include/javascript/jsclass_base.js?s={$SUGAR_VERSION}&c={$JS_CUSTOM_VERSION}"></script>
<script type="text/javascript" src="include/javascript/jsclass_async.js?s={$SUGAR_VERSION}&c={$JS_CUSTOM_VERSION}"></script>
<script type="text/javascript" src="modules/Meetings/jsclass_scheduler.js?s={$SUGAR_VERSION}&c={$JS_CUSTOM_VERSION}"></script>
<script>toggle_portal_flag();function toggle_portal_flag()  {literal} { {/literal} {$TOGGLE_JS} {literal} } {/literal} </script>',
),
 'panels' =>array (
  'default' => array (
 				array (
      				 array('name'=>'name', 'displayParams'=>array('required'=>true)),
					 array (
        				'name' => 'status',
        				'fields' => 
        					array (
          						array('name'=>'direction'),
          						array('name'=>'status'),
        					),
      				),
    			),
    			array(
    				'location',

    				array('name'=>'team_name','displayParams'=>array('required'=>true)),

    			),
    			array (
      				array('name'=>'date_start',
            			  'type'=>'datetimecombo',
            			  'displayParams'=>array('required' => true, 'updateCallback'=>'SugarWidgetScheduler.update_time();'),
                    ),
      				'assigned_user_name',
    			),   
    			array (
      				array (
        				'name' => 'duration_hours',
        				'label' => 'LBL_DURATION',
        				'customCode' => '{literal}<script type="text/javascript">function isValidDuration() { form = document.getElementById(\'EditView\'); if ( form.duration_hours.value + form.duration_minutes.value <= 0 ) { alert("Duration time must be greater than 0"); return false; } return true; }</script>{/literal}<input name="duration_hours" size="2" maxlength="2" type="text" value="{$fields.duration_hours.value}" onkeyup="SugarWidgetScheduler.update_time();"/>{$fields.duration_minutes.value} {$MOD.LBL_HOURS_MINS}',
      				),
					'parent_name',
    			),
				array (
      				array('name' => 'reminder_time',
            			'customCode' => '{if $fields.reminder_checked.value == "1"}' .
            	 	        '{assign var="REMINDER_TIME_DISPLAY" value="inline"}' .
            	 	        '{assign var="REMINDER_CHECKED" value="checked"}' .
            	 	        '{else}' .
            	 	        '{assign var="REMINDER_TIME_DISPLAY" value="none"}' .
            	 	        '{assign var="REMINDER_CHECKED" value=""}' .
            	 	        '{/if}' .
            	 	        '<input name="reminder_checked" type="hidden" value="0"><input name="reminder_checked" onclick=\'toggleDisplay("should_remind_list");\' type="checkbox" class="checkbox" value="1" {$REMINDER_CHECKED}><div id="should_remind_list" style="display:{$REMINDER_TIME_DISPLAY}">{$fields.reminder_time.value}</div>',
            			'label' => 'LBL_REMINDER'),
    			),
				array (
     	 			'description',
    			),
  			),
		)
);
?>
