<?php
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Professional Subscription
 * Agreement ("License") which can be viewed at
 * http://www.sugarcrm.com/crm/products/sugar-professional-eula.html
 * By installing or using this file, You have unconditionally agreed to the
 * terms and conditions of the License, and You may not use this file except in
 * compliance with the License.  Under the terms of the license, You shall not,
 * among other things: 1) sublicense, resell, rent, lease, redistribute, assign
 * or otherwise transfer Your rights to the Software, and 2) use the Software
 * for timesharing or service bureau purposes such as hosting the Software for
 * commercial gain and/or for the benefit of a third party.  Use of the Software
 * may be subject to applicable fees and any use of the Software without first
 * paying applicable fees is strictly prohibited.  You do not have the right to
 * remove SugarCRM copyrights from the source code or user interface.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *  (i) the "Powered by SugarCRM" logo and
 *  (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * Your Warranty, Limitations of liability and Indemnity are expressly stated
 * in the License.  Please refer to the License for the specific language
 * governing these rights and limitations under the License.  Portions created
 * by SugarCRM are Copyright (C) 2004-2007 SugarCRM, Inc.; All Rights Reserved.
 ********************************************************************************/
require_once('include/ytree/Tree.php');
require_once('include/ytree/Node.php');
class MBPackageTree{
	
	function MBPackageTree(){
		$this->tree = new Tree('package_tree');
		$this->tree->id = 'package_tree';
		$this->mb = new ModuleBuilder();
		$this->populateTree($this->mb->getNodes(), $this->tree);
	}
	
	function getName(){
		return 'Packages';
	}
	
	function populateTree($nodes, &$parent){
//	    _pp($nodes);
		foreach($nodes as $node){
			if(empty($node['label']))$node['label'] = $node['name'];
			$yn = new Node($parent->id . '/' . $node['name'],$node['label']);
			if(!empty($node['action']))
				$yn->set_property('action', $node['action']);
			$yn->set_property('href', 'javascript:void(0);');
			$yn->id = $node['name'];
			if(!empty($node['children']))$this->populateTree($node['children'], $yn);
			$parent->add_node($yn);
		}
	}
	
	function fetch(){
		//return $this->tree->generate_header() . $this->tree->generate_nodes_array();
		return $this->tree->generate_nodes_array();
	}
	
	function fetchNodes(){
		return $this->tree->generateNodesRaw();
	}
	
	
	
	
	
}
?>
