/**
 * The contents of this file are subject to the SugarCRM Professional Subscription
 * Agreement ("License") which can be viewed at
 * http://www.sugarcrm.com/crm/products/sugar-professional-eula.html
 * By installing or using this file, You have unconditionally agreed to the
 * terms and conditions of the License, and You may not use this file except in
 * compliance with the License.  Under the terms of the license, You shall not,
 * among other things: 1) sublicense, resell, rent, lease, redistribute, assign
 * or otherwise transfer Your rights to the Software, and 2) use the Software
 * for timesharing or service bureau purposes such as hosting the Software for
 * commercial gain and/or for the benefit of a third party.  Use of the Software
 * may be subject to applicable fees and any use of the Software without first
 * paying applicable fees is strictly prohibited.  You do not have the right to
 * remove SugarCRM copyrights from the source code or user interface.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *  (i) the "Powered by SugarCRM" logo and
 *  (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * Your Warranty, Limitations of liability and Indemnity are expressly stated
 * in the License.  Please refer to the License for the specific language
 * governing these rights and limitations under the License.  Portions created
 * by SugarCRM are Copyright (C) 2004-2007 SugarCRM, Inc.; All Rights Reserved.
 */

 Studio2.ListDD = function(id, sGroup, fromOnly) {
 	if (Ext.get(id)) {
		Studio2.ListDD.superclass.constructor.call(this, id, sGroup);
		Ext.get(this.getDragEl()).applyStyles({
			borderColor: "#FF0000",
			backgroundColor: "#e5e5e5",
			opacity: 0.76,
			filter: "alpha(opacity=76)"
		});
		this.fromOnly = fromOnly;
	}
};

Ext.extend(Studio2.ListDD, Ext.dd.DDProxy, {
	
    startDrag: function(x, y){
		var dragEl = this.getDragEl();
		var clickEl = this.getEl();
		
		this.parentID = clickEl.parentNode.id;
		dragEl.innerHTML = clickEl.innerHTML;
		dragElObjects = dragEl.getElementsByTagName('object');
		
		dragEl.className = clickEl.className;
		dragEl.style.color = clickEl.style.color;
		dragEl.style.border = "1px solid #aaa";
		
		// save the style of the object 
		this.clickContent = clickEl.innerHTML;
		this.clickBorder = clickEl.style.border;
		this.clickHeight = clickEl.style.height;
		
		clickElRegion = Ext.get(clickEl).getRegion();
		//clickEl.style.height = (clickElRegion.bottom - clickElRegion.top) + 'px';
		Ext.get(clickEl).applyStyles({
			opacity : 0.5,
			filter : "alpha(opacity=10)",
			border : '2px dashed #cccccc'
		});
	},
	
	updateTabs: function(){
		studiotabs.moduleTabs = [];
		for (j = 0; j < studiotabs.slotCount; j++) {
		
			var ul = document.getElementById('ul' + j);
			studiotabs.moduleTabs[j] = [];
			items = ul.getElementsByTagName("li");
			for (i = 0; i < items.length; i++) {
				if (items.length == 1) {
					items[i].innerHTML = SUGAR.language.get('ModuleBuilder', 'LBL_DROP_HERE');
				}
				else if (items[i].innerHTML == SUGAR.language.get('ModuleBuilder', 'LBL_DROP_HERE')) {
					items[i].innerHTML = '';
				}
				studiotabs.moduleTabs[ul.id.substr(2, ul.id.length)][studiotabs.subtabModules[items[i].id]] = true;
			}	
		}	
	},
	
	endDrag: function(e){
		ModuleBuilder.state.isDirty=true;
		var clickEl = this.getEl();
		clickEl.innerHTML = this.clickContent;
		var p = clickEl.parentNode;
		if (p.id == 'trash') {
			p.removeChild(clickEl);
			this.lastNode = false;
			this.updateTabs();
			return;
		}
		if (this.clickHeight) {
			clickEl.style.height = this.clickHeight;
			if (this.lastNode) 
				this.lastNode.style.height = this.clickHeight;
		}
		else {
			clickEl.style.height = '';
			if (this.lastNode) 
				this.lastNode.style.height = '';
		}
		
		if (this.clickBorder) {
			clickEl.style.border = this.clickBorder;
			if (this.lastNode) 
				this.lastNode.style.border = this.clickBorder;
		}
		else {
			clickEl.style.border = '';
			if (this.lastNode) 
				this.lastNode.style.border = '';
		}
		clickEl.style.opacity = 1;
		clickEl.style.filter = "alpha(opacity=100)";
		clickEl.style.border = "1px solid";
		if (this.lastNode) {
			this.lastNode.id = 'addLS' + addListStudioCount;
			studiotabs.subtabModules[this.lastNode.id] = this.lastNode.module;
			yahooSlots[this.lastNode.id] = new Studio2.ListDD(this.lastNode.id, 'subTabs', false);
			addListStudioCount++;
			this.lastNode.style.opacity = 1;
			this.lastNode.style.filter = "alpha(opacity=100)";
		}
		this.lastNode = false;
		this.updateTabs();
	},
	onDragOver: function(e, id){
		// this.logger.debug(this.id.toString() + " onDragOver " + id);
		var el;
		if (this.lastNode) {
			this.lastNode.parentNode.removeChild(this.lastNode);
			this.lastNode = false;
		}
		if (id.substr(0, 7) == 'modSlot') {
			return;
		}
		el = Ext.get(id);
		dragEl = Ext.get(this.getDragEl());
		elRegion = el.getRegion();
		
		var mid = el.getCenterXY()[1];
		var el2 = this.getEl();
		var p = el.dom.parentNode;
		if ((this.fromOnly || (el.id != 'trashcan' && el2.parentNode.id != p.id && el2.parentNode.id == this.parentID))) {
			if (typeof(studiotabs.moduleTabs[p.id.substr(2, p.id.length)][studiotabs.subtabModules[el2.id]]) != 'undefined') 
				return;
		}
		
		if (this.fromOnly && el.id != 'trashcan') {
			el2 = el2.cloneNode(true);
			el2.module = studiotabs.subtabModules[el2.id];
			el2.id = 'addListStudio' + addListStudioCount;
			this.lastNode = el2;
			this.lastNode.clickContent = el2.clickContent;
			this.lastNode.clickBorder = el2.clickBorder;
			this.lastNode.clickHeight = el2.clickHeight
		}
		if (dragEl.getY() < mid) { // insert on top triggering item
			p.insertBefore(el2, el.dom);
		}
		else { // insert below triggered item
			p.insertBefore(el2, el.dom.nextSibling);
		}
	}
});
