<?php
if (! defined('sugarEntry') || ! sugarEntry)
	die('Not A Valid Entry Point');
/**
 * The contents of this file are subject to the SugarCRM Professional Subscription
 * Agreement ("License") which can be viewed at
 * http://www.sugarcrm.com/crm/products/sugar-professional-eula.html
 * By installing or using this file, You have unconditionally agreed to the
 * terms and conditions of the License, and You may not use this file except in
 * compliance with the License.  Under the terms of the license, You shall not,
 * among other things: 1) sublicense, resell, rent, lease, redistribute, assign
 * or otherwise transfer Your rights to the Software, and 2) use the Software
 * for timesharing or service bureau purposes such as hosting the Software for
 * commercial gain and/or for the benefit of a third party.  Use of the Software
 * may be subject to applicable fees and any use of the Software without first
 * paying applicable fees is strictly prohibited.  You do not have the right to
 * remove SugarCRM copyrights from the source code or user interface.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *  (i) the "Powered by SugarCRM" logo and
 *  (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * Your Warranty, Limitations of liability and Indemnity are expressly stated
 * in the License.  Please refer to the License for the specific language
 * governing these rights and limitations under the License.  Portions created
 * by SugarCRM are Copyright (C) 2004-2007 SugarCRM, Inc.; All Rights Reserved.
 */

class ParserFactory
{
	
	/*
     * Create a new parser
     * 
     * var $newModule	If true then return a variant of the parser that works with modules that are under construction. If false, then the parser works from pre-existing module files
     * 
     * @return ModuleBuilderParser
     */
	
	function getParser ($parser, $newModule = null)
	{
		$prefix = '';
		if (! is_null($newModule))
		{
			$prefix = ($newModule) ? 'build' : 'modify';
		}
		$parser = ucfirst($parser);
		$fileName = "modules/ModuleBuilder/parsers/parser." . strtolower($prefix . $parser) . ".php";
		if (file_exists($fileName))
		{
			require_once ($fileName);
			$class = 'Parser' . $prefix . $parser;
			if (class_exists($class))
			{
				$GLOBALS ['log']->debug('Using ModuleBuilder Parser ' . $fileName);
				return new $class();
			}
		
		}
		$GLOBALS ['log']->fatal('Cannot create ModuleBuilder Parser ' . $fileName);
	
	}
	
/*
	function getParser($module,$view,$fromModuleBuilder,$submittedLayout){		
		switch($fromModuleBuilder){
			case true:
				require_once('modules/ModuleBuilder/parsers/MBEditDetailViewParser.php');
				return new MBEditDetailViewParser($module,$view,$submittedLayout);				
			case false:
				require_once('modules/ModuleBuilder/parsers/EditDetailViewParser.php');
				return new EditDetailViewParser($module,$view,$submittedLayout);
		}
	}

*/

}
?>
