<?php
if (! defined('sugarEntry') || ! sugarEntry)
die('Not A Valid Entry Point');
/**
 * The contents of this file are subject to the SugarCRM Professional Subscription
 * Agreement ("License") which can be viewed at
 * http://www.sugarcrm.com/crm/products/sugar-professional-eula.html
 * By installing or using this file, You have unconditionally agreed to the
 * terms and conditions of the License, and You may not use this file except in
 * compliance with the License.  Under the terms of the license, You shall not,
 * among other things: 1) sublicense, resell, rent, lease, redistribute, assign
 * or otherwise transfer Your rights to the Software, and 2) use the Software
 * for timesharing or service bureau purposes such as hosting the Software for
 * commercial gain and/or for the benefit of a third party.  Use of the Software
 * may be subject to applicable fees and any use of the Software without first
 * paying applicable fees is strictly prohibited.  You do not have the right to
 * remove SugarCRM copyrights from the source code or user interface.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *  (i) the "Powered by SugarCRM" logo and
 *  (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * Your Warranty, Limitations of liability and Indemnity are expressly stated
 * in the License.  Please refer to the License for the specific language
 * governing these rights and limitations under the License.  Portions created
 * by SugarCRM are Copyright (C) 2004-2007 SugarCRM, Inc.; All Rights Reserved.
 */

require_once ('modules/ModuleBuilder/parsers/parser.modifylayoutview.php');
require_once ('modules/ModuleBuilder/MB/ModuleBuilder.php');

class ParserBuildLayoutView extends ParserModifyLayoutView
{

    /**
     * Constructor
     */
    function init ($module, $view, $submittedLayout = false)
    {

        $this->_package = $_REQUEST ['package'];
        
       
        $this->_view = ucfirst($view);
        
        $mb = new ModuleBuilder();
        $mbmodule = & $mb->getPackageModule($this->_package, $module);
   		$this->_module = $mbmodule->key_name;
        $file = $mbmodule->getModuleDir() . "/metadata/" . strtolower($view) . "defs.php";
        $this->_customFile = $file;
        $this->_originalFile = $file;
        $this->_sourceFile = $file;
        $this->_sourceView = $this->_view; // bug 18062 - sourceView required
        
        //add in the modules strings to the global set
//        $GLOBAL['mod_strings'][$module] = $mbmodule->getModStrings();
		global $mod_strings;
		$mod_strings = array_merge($mod_strings, $mbmodule->getModStrings());
		$this->language_module = ''; // set to empty so that sugar_translate in the smarty template uses the $GLOBAL modstrings and not a non-existent language file for this new package

        //get the fieldDefs from ModuleBuilder
        $fields = $mbmodule->getVardefs();
        $this->_fieldDefs = & $fields ['fields'];

        $this->loadModule($this->_module, $this->_view);
        $this->_viewdefs ['panels'] = $this->_parseData($this->_viewdefs['panels']); // put into a canonical format
		$this->maxColumns = $this->_viewdefs ['templateMeta'] ['maxColumns'];
	
        if ($submittedLayout)
        {
            // replace the definitions with the new submitted layout
            $this->_loadLayoutFromRequest();
        } else
        {
            $this->_padFields(); // destined for a View, so we want to add in (empty) fields
        }
    }
    
    /*
     * Nothing to do for ModuleBuilder created layouts
     */
    function writeWorkingFile ()
    {
    }
    

}

?>
