<?php
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Professional Subscription
 * Agreement ("License") which can be viewed at
 * http://www.sugarcrm.com/crm/products/sugar-professional-eula.html
 * By installing or using this file, You have unconditionally agreed to the
 * terms and conditions of the License, and You may not use this file except in
 * compliance with the License.  Under the terms of the license, You shall not,
 * among other things: 1) sublicense, resell, rent, lease, redistribute, assign
 * or otherwise transfer Your rights to the Software, and 2) use the Software
 * for timesharing or service bureau purposes such as hosting the Software for
 * commercial gain and/or for the benefit of a third party.  Use of the Software
 * may be subject to applicable fees and any use of the Software without first
 * paying applicable fees is strictly prohibited.  You do not have the right to
 * remove SugarCRM copyrights from the source code or user interface.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *  (i) the "Powered by SugarCRM" logo and
 *  (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * Your Warranty, Limitations of liability and Indemnity are expressly stated
 * in the License.  Please refer to the License for the specific language
 * governing these rights and limitations under the License.  Portions created
 * by SugarCRM are Copyright (C) 2004-2007 SugarCRM, Inc.; All Rights Reserved.
 ********************************************************************************/

require_once ("modules/ModuleBuilder/parsers/parser.modifysearchview.php");
require_once ("data/SugarBean.php");
require_once ('modules/ModuleBuilder/MB/ModuleBuilder.php');

class ParserBuildSearchView extends ParserModifySearchView
{
	
	function init ($module_name, $searchlayout)
	{
		$package_name = $_REQUEST['package'];
		
		$this->searchlayout = $searchlayout;
		
		//get the bean from ModuleBuilder
		$mb = new ModuleBuilder();
		$this->module = & $mb->getPackageModule($package_name, $module_name);
		$this->module->mbvardefs->updateVardefs();
		$this->module->module_dir = $module_name;
		
		$this->customFile = 'custom/modulebuilder/packages/' . $package_name . '/modules/' . $module_name . '/metadata/searchdefs.php';		
//		include ($this->customFile);

		$loaded = $this->_loadFromFile('SearchView',$this->customFile,$module_name);
		$this->_variables = $loaded['variables'];
		
		$this->searchViewDefs = $loaded['viewdefs'][$module_name];
		$this->listViewDefs = $loaded['viewdefs'][$module_name]['layout'][$this->searchlayout];
				
		//Load the listviewdefs from the templates as originals
/*		foreach ($this->module->config ['templates'] as $temp => $key)
		{
			$orig = MB_TEMPLATES . '/' . $temp . '/metadata/searchdefs.php';
			if (file_exists($orig))
			{
				include ($orig);
				$this->originalListViewDefs = & $searchdefs ['<module_name>']['layout'][$this->searchlayout];
			}
		}
*/
		$this->fixKeys($this->listViewDefs);
		$this->originalListViewDefs = $this->listViewDefs;
		$this->module->field_defs = & $this->module->mbvardefs->vardefs ['fields'];
		
		global $mod_strings;
		$mod_strings = array_merge($mod_strings, $this->module->getModStrings());
		$this->language_module = ''; // set this to empty for utils.php->translate to get the mod_strings from $GLOBALS. If it is set to the modulename as usual translate attempts to load a language file
		
	}
}

?>
