<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
/**
 * The contents of this file are subject to the SugarCRM Professional Subscription
 * Agreement ("License") which can be viewed at
 * http://www.sugarcrm.com/crm/products/sugar-professional-eula.html
 * By installing or using this file, You have unconditionally agreed to the
 * terms and conditions of the License, and You may not use this file except in
 * compliance with the License.  Under the terms of the license, You shall not,
 * among other things: 1) sublicense, resell, rent, lease, redistribute, assign
 * or otherwise transfer Your rights to the Software, and 2) use the Software
 * for timesharing or service bureau purposes such as hosting the Software for
 * commercial gain and/or for the benefit of a third party.  Use of the Software
 * may be subject to applicable fees and any use of the Software without first
 * paying applicable fees is strictly prohibited.  You do not have the right to
 * remove SugarCRM copyrights from the source code or user interface.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *  (i) the "Powered by SugarCRM" logo and
 *  (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * Your Warranty, Limitations of liability and Indemnity are expressly stated
 * in the License.  Please refer to the License for the specific language
 * governing these rights and limitations under the License.  Portions created
 * by SugarCRM are Copyright (C) 2004-2007 SugarCRM, Inc.; All Rights Reserved.
 */
 
require_once('modules/ModuleBuilder/parsers/ModuleBuilderParser.php');

 class ParserDropDown extends ModuleBuilderParser {
    
    /**
     * Takes in the request params from a save request and processes 
     * them for the save.
     *
     * @param REQUEST params  $params
     */
    function saveDropDown($params){
        require_once('modules/Administration/Common.php');
		$selected_lang = (!empty($params['dropdown_lang'])?$params['dropdown_lang']:$_SESSION['authenticated_user_language']);
		$type = $_REQUEST['view_package'];
		$dir = '';
		$dropdown_name = $params['dropdown_name'];
		$json = getJSONobj();

		$list_value = str_replace('&quot;&quot;:&quot;&quot;', '&quot;__empty__&quot;:&quot;&quot;', $params['list_value']);
		$dropdown = $json->decode(html_entity_decode(rawurldecode($list_value)));

		if(array_key_exists('__empty__', $dropdown)){
			$dropdown['__empty__'] = '';
			$dropdown = array_flip($dropdown); // horrible hack - flip to remove the __empty__
			$dropdown[''] = '';
			$dropdown = array_flip($dropdown); // bug - need to restore the original orientation
		}
		if($type != 'studio'){
			$mb = new ModuleBuilder();
			$module =& $mb->getPackageModule($params['view_package'], $params['view_module']);
			//$package =& $mb->getPackage($params['view_package']);
			//$dir = $package->getPackageDir().'/include/language';
			//$contents = return_custom_app_list_strings_file_contents($selected_lang,$dir.'/'.$selected_lang.'.lang.php');
			$module->mblanguage->appListStrings[$selected_lang.'.lang.php'][$dropdown_name] = $dropdown;
			$module->mblanguage->save($module->key_name); // tyoung - key is required parameter as of 
		}else{
			$contents = return_custom_app_list_strings_file_contents($selected_lang);			
			$my_list_strings = return_app_list_strings_language($selected_lang);
			if($selected_lang == $GLOBALS['current_language']){
	           $GLOBALS['app_list_strings'][$dropdown_name] = $dropdown;
	        }
			//write to contents
			$contents = str_replace("?>", '', $contents);
			if(empty($contents))$contents = "<?php";
	        //add new drop down to the bottom
	        if(!empty($params['use_push'])){
	        	//this is for handling moduleList and such where nothing should be deleted or anything but they can be renamed
	        	foreach($dropdown as $key=>$value){
	        		//only if the value has changed or does not exist do we want to add it this way
	        		if(!isset($my_list_strings[$dropdown_name][$key]) || strcmp($my_list_strings[$dropdown_name][$key], $value) != 0 ){
		        		//clear out the old value
		        		$pattern_match = '/\s*\$app_list_strings\s*\[\s*\''.$dropdown_name.'\'\s*\]\[\s*\''.$key.'\'\s*\]\s*=\s*[\'\"]{1}.*?[\'\"]{1};\s*/ism';
		        		$contents = preg_replace($pattern_match, "\n", $contents);
		        		//add the new ones
		        		$contents .= "\n\$GLOBALS['app_list_strings']['$dropdown_name']['$key']=" . var_export_helper($value) . ";";
	        		}
	        	}
	        }else{
	        	//clear out the old value
	        	$pattern_match = '/\s*\$GLOBALS\s*\[\s*\'app_list_strings\s*\'\s*\]\[\s*\''.$dropdown_name.'\'\s*\]\s*=\s*array\s*\([^\)]*\)\s*;\s*/ism';
	        	$contents = preg_replace($pattern_match, "\n", $contents);
	        	//add the new ones
	        	
	        	$GLOBALS['log']->debug(var_export_helper($dropdown));
	        	$contents .= "\n\$GLOBALS['app_list_strings']['$dropdown_name']=" . var_export_helper($dropdown) . ";";
	        	$GLOBALS['log']->debug($contents);
	        }
	        
		    if($type != 'studio' && !empty($dir) && !is_dir($dir))
		    {
		     	$continue = mkdir_recursive($dir);
		    }
			save_custom_app_list_strings_contents($contents, $selected_lang, $dir);
		}
		sugar_cache_reset();
    }
}
?>
