<?php
if (! defined('sugarEntry') || ! sugarEntry)
	die('Not A Valid Entry Point');
/**
 * The contents of this file are subject to the SugarCRM Professional Subscription
 * Agreement ("License") which can be viewed at
 * http://www.sugarcrm.com/crm/products/sugar-professional-eula.html
 * By installing or using this file, You have unconditionally agreed to the
 * terms and conditions of the License, and You may not use this file except in
 * compliance with the License.  Under the terms of the license, You shall not,
 * among other things: 1) sublicense, resell, rent, lease, redistribute, assign
 * or otherwise transfer Your rights to the Software, and 2) use the Software
 * for timesharing or service bureau purposes such as hosting the Software for
 * commercial gain and/or for the benefit of a third party.  Use of the Software
 * may be subject to applicable fees and any use of the Software without first
 * paying applicable fees is strictly prohibited.  You do not have the right to
 * remove SugarCRM copyrights from the source code or user interface.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *  (i) the "Powered by SugarCRM" logo and
 *  (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * Your Warranty, Limitations of liability and Indemnity are expressly stated
 * in the License.  Please refer to the License for the specific language
 * governing these rights and limitations under the License.  Portions created
 * by SugarCRM are Copyright (C) 2004-2007 SugarCRM, Inc.; All Rights Reserved.
 */



require_once ('modules/ModuleBuilder/parsers/ModuleBuilderParser.php');

class ParserLabel extends ModuleBuilderParser
{

	/**
	 * Takes in the request params from a save request and processes
	 * them for the save.
	 *
	 * @param REQUEST params  $params
	 */
	function handleSave ($params, $module, $language)
	{

//		if ((($params ['module'] == 'ModuleBuilder') || (isset($params ['MB']) && $params ['MB'] == '1' && $params ['subpanel'] == "")) && (empty($params ['view_package']) || $params ['view_package'] != 'studio'))

	    if (!empty($params['MB']) && isset($params['view_package']) && $params['view_package']!='studio') //we are in Module builder && empty($params['subpanel']) && ( isset($params['view_package']) && ( empty($params ['view_package']) || $params ['view_package'] != 'studio')) )
		{
		    if($params['view_package'])
				$dirname = "custom/modulebuilder/packages/{$params['view_package']}/modules/$module/language";
			else
			    $dirname = "custom/modulebuilder/packages/{$params['package']}/modules/$module/language";
		}
		else //we are in studio
		{
			$dirname = "custom/modules/$module/language";
			if (!is_dir($dirname))
			{
			    require_once('modules/Administration/Common.php');
			    create_module_lang_dir($module);
			}
		}
		$filename = "$dirname/$language.lang.php";
		$dir_exists = is_dir($dirname);
//		require_once ('modules/Administration/Common.php');
//		if (! $dir_exists)
//		{
//			require_once ('include/utils.php');
//			$dir_exists = mkdir_recursive($dirname, true);

//		}

		if ($dir_exists)
		{
			if (file_exists($filename))
			{
				include ($filename);
			}
		} else
		{
			return false;
		}
		$changed = false;
		foreach ($params as $key => $value)
		{
			if (preg_match('/^label_/', $key) && strcmp($value, 'no_change') != 0)
			{
				$key = substr($key, 6);
				if (! isset($mod_strings [$key]) || strcmp($value, $mod_strings [$key]) != 0)
				{
					$mod_strings [$key] = html_entity_decode($value);
					$changed = true;
				}
			}
		}
		if ($changed)
		{
			$cache_key = "module_language." . $language . $module;
			sugar_cache_clear($cache_key);
			if (! write_array_to_file("mod_strings", $mod_strings, $filename))
			{
				$GLOBALS ['log']->fatal("Could not write $filename");
			}else{
				LanguageManager::clearLanguageCache($module, $language);
			}
		}
		return true;
	}
}

?>
