<?php
if (! defined('sugarEntry') || ! sugarEntry)
    die('Not A Valid Entry Point');
/**
 * The contents of this file are subject to the SugarCRM Professional Subscription
 * Agreement ("License") which can be viewed at
 * http://www.sugarcrm.com/crm/products/sugar-professional-eula.html
 * By installing or using this file, You have unconditionally agreed to the
 * terms and conditions of the License, and You may not use this file except in
 * compliance with the License.  Under the terms of the license, You shall not,
 * among other things: 1) sublicense, resell, rent, lease, redistribute, assign
 * or otherwise transfer Your rights to the Software, and 2) use the Software
 * for timesharing or service bureau purposes such as hosting the Software for
 * commercial gain and/or for the benefit of a third party.  Use of the Software
 * may be subject to applicable fees and any use of the Software without first
 * paying applicable fees is strictly prohibited.  You do not have the right to
 * remove SugarCRM copyrights from the source code or user interface.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *  (i) the "Powered by SugarCRM" logo and
 *  (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * Your Warranty, Limitations of liability and Indemnity are expressly stated
 * in the License.  Please refer to the License for the specific language
 * governing these rights and limitations under the License.  Portions created
 * by SugarCRM are Copyright (C) 2004-2007 SugarCRM, Inc.; All Rights Reserved.
 */




require_once ('modules/ModuleBuilder/parsers/parser.modifylistview.php');

class ParserModifySearchView extends ParserModifyListView
{

    var $columns = array('LBL_DEFAULT' => 'getDefaultFields', 'LBL_HIDDEN' => 'getAvailableFields');
    var $searchlayout;

    function init ($module_name, $searchlayout)
    {
		global $app_list_strings;

		$this->searchlayout = $searchlayout;
//		$this->mod_strings = return_module_language($GLOBALS['current_language'], $module_name);
		$class = $GLOBALS['beanList'][$module_name];
		require_once($GLOBALS['beanFiles'][$class]);
		$this->module = new $class();

//		$defsFile = 'modules/' . $module_name . '/metadata/searchdefs.php';
//		include($defsFile);

		$loaded = $this->_loadFromFile('SearchView','modules/' . $module_name . '/metadata/searchdefs.php',$module_name);
		$this->originalListViewDefs = $loaded['viewdefs'][$module_name]['layout'][$this->searchlayout];
		$this->_variables = $loaded['variables'];

		$this->customFile = 'custom/modules/' . $module_name . '/metadata/searchdefs.php';
		if (file_exists($this->customFile))
		{
			$loaded = $this->_loadFromFile('SearchView',$this->customFile,$module_name);
			$this->_variables = $loaded['variables'];
		}

		$this->searchViewDefs = $loaded['viewdefs'][$module_name];
		$this->listViewDefs = $loaded['viewdefs'][$module_name]['layout'][$this->searchlayout];
		$this->fixKeys($this->originalListViewDefs);
		$this->fixKeys($this->listViewDefs);

		$this->language_module = $module_name;
    }

	function getDefaultFields ()
	{
		$this->defaults = array();

		foreach ($this->listViewDefs as $key => $value)
		{
			if (! isset($value['label']))
			{
			    $value['label'] = isset($this->module->field_defs[$key]) ? $this->module->field_defs[$key]['vname'] : $key;
			}
			$this->defaults[$key] = $value;
		}
		return $this->defaults;
	}

	function handleSave ()
	{
//		global $mod_strings;
		$module_name = $this->module->module_dir;
		$fields = array();
			foreach ($_POST ['group_0'] as $field)
			{
				if (isset($this->listViewDefs[$field])) // in the default fields list
				{
					$fields[$field] = $this->listViewDefs[$field];
				}
				else if (isset($this->module->field_defs[$field])) // in the available fields list
				{
					$fields[$field] = array('label' => $this->module->field_defs [$field] ['vname']); // note that this is unsafe if the label might have been edited - here we just get the old label...
				}

				if (isset($_REQUEST [strtolower($field) . 'width']))
				{
					$width = substr($_REQUEST [strtolower($field) . 'width'], 6, 3);
					if (strpos($width, "%") != false)
					{
						$width = substr($width, 0, 2);
					}
					if ($width < 101 && $width > 0)
					{
						$fields [$field] ['width'] = $width;
					}
				} else if (isset($this->listViewDefs [$field] ['width']))
				{
					$fields [$field] ['width'] = $this->listViewDefs [$field] ['width'];
				}
				if(!isset($fields[$field]['name']))$fields[$field]['name'] = $field;
				if(substr($field,-2)=="_c") //nsingh: bug#17828 set default value to none
					$fields[$field]['default_value']="";
			}

		$this->searchViewDefs['layout'][$this->searchlayout] = $fields;

//		if (! write_array_to_file("searchdefs['$module_name']", $this->searchViewDefs, $this->customFile))

		$this->_writeToFile($this->customFile,'SearchView',$module_name,$this->searchViewDefs,$this->_variables);

		$GLOBALS ["searchDefs"] [$module_name] = $fields;
        // now clear the cache so that the results are immediately visible
		include_once('include/TemplateHandler/TemplateHandler.php');
		TemplateHandler::clearCache($module_name,"SearchForm_{$this->searchlayout}.tpl");
	}

}

?>
