<?php
if (! defined('sugarEntry') || ! sugarEntry)
	die('Not A Valid Entry Point');
/**
 * The contents of this file are subject to the SugarCRM Professional Subscription
 * Agreement ("License") which can be viewed at
 * http://www.sugarcrm.com/crm/products/sugar-professional-eula.html
 * By installing or using this file, You have unconditionally agreed to the
 * terms and conditions of the License, and You may not use this file except in
 * compliance with the License.  Under the terms of the license, You shall not,
 * among other things: 1) sublicense, resell, rent, lease, redistribute, assign
 * or otherwise transfer Your rights to the Software, and 2) use the Software
 * for timesharing or service bureau purposes such as hosting the Software for
 * commercial gain and/or for the benefit of a third party.  Use of the Software
 * may be subject to applicable fees and any use of the Software without first
 * paying applicable fees is strictly prohibited.  You do not have the right to
 * remove SugarCRM copyrights from the source code or user interface.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *  (i) the "Powered by SugarCRM" logo and
 *  (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * Your Warranty, Limitations of liability and Indemnity are expressly stated
 * in the License.  Please refer to the License for the specific language
 * governing these rights and limitations under the License.  Portions created
 * by SugarCRM are Copyright (C) 2004-2007 SugarCRM, Inc.; All Rights Reserved.
 */





require_once ('modules/ModuleBuilder/parsers/parser.modifylistview.php');

class ParserPortalListView extends ParserModifyListView
{
	
	var $listViewDefs = false;
	var $defaults = array();
	var $additional = array();
	var $available = array();
	var $language_module;
    var $columns = array('LBL_DEFAULT' => 'getDefaultFields', 'LBL_AVAILABLE' => 'getAvailableFields');
	
	function init ($module_name)
	{
		global $app_list_strings;
		$this->module_name = $module_name;
		$this->mod_strings = return_module_language($GLOBALS ['current_language'], $this->module_name);
		$class = $GLOBALS ['beanList'] [$this->module_name];
		require_once ($GLOBALS ['beanFiles'] [$class]);
		$this->module = new $class();
		
		include ('portal/modules/' . $this->module_name . '/metadata/listviewdefs.php');
		$this->originalListViewDefs = $viewdefs [$this->module_name]['listview'];
		$this->fixKeys($this->originalListViewDefs);
		$this->customFile = 'custom/portal/modules/' . $this->module_name . '/metadata/listviewdefs.php';
		if (file_exists($this->customFile))
		{
			include ($this->customFile);
			$this->listViewDefs = $viewdefs [$this->module_name]['listview'];
			$this->fixKeys($this->listViewDefs);
		} else
		{
			$this->listViewDefs = & $this->originalListViewDefs;
		}
		
		$this->_fromNewToOldMetaData();

		$this->language_module = $this->module_name;
	}
	
	function _fromNewToOldMetaData()
	{
	    foreach($this->listViewDefs as $key=>$value)
	    {
	        $value['default'] = 'true';
	        $this->listViewDefs[$key] = $value;
	    }
	}
	
    function handleSave ()
    {

        $requestfields = $this->_loadLayoutFromRequest();
        $fields = array();
        foreach($requestfields as $key=>$value)
        {
            if ($value['default'] == 'true')
            {
                unset($value['default']);
                $fields[$key] = $value;
            }
        }
        
        mkdir_recursive(dirname($this->customFile), true);
        if (! write_array_to_file("viewdefs['{$this->module_name}']['listview']", $fields, $this->customFile))
        {
            $GLOBALS ['log']->fatal("Could not write $newFile");
        }

        // now clear the cache so that the results are immediately visible
//        include_once('include/TemplateHandler/TemplateHandler.php');
//       TemplateHandler::clearCache($this->module_name,"ListView.tpl"); // not currently cached, but here for the future
    }

}

?>
