{*

/**
 * The contents of this file are subject to the SugarCRM Professional Subscription
 * Agreement ("License") which can be viewed at
 * http://www.sugarcrm.com/crm/products/sugar-professional-eula.html
 * By installing or using this file, You have unconditionally agreed to the
 * terms and conditions of the License, and You may not use this file except in
 * compliance with the License.  Under the terms of the license, You shall not,
 * among other things: 1) sublicense, resell, rent, lease, redistribute, assign
 * or otherwise transfer Your rights to the Software, and 2) use the Software
 * for timesharing or service bureau purposes such as hosting the Software for
 * commercial gain and/or for the benefit of a third party.  Use of the Software
 * may be subject to applicable fees and any use of the Software without first
 * paying applicable fees is strictly prohibited.  You do not have the right to
 * remove SugarCRM copyrights from the source code or user interface.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *  (i) the "Powered by SugarCRM" logo and
 *  (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * Your Warranty, Limitations of liability and Indemnity are expressly stated
 * in the License.  Please refer to the License for the specific language
 * governing these rights and limitations under the License.  Portions created
 * by SugarCRM are Copyright (C) 2004-2007 SugarCRM, Inc.; All Rights Reserved.
 */


*}

<table id='layoutEditorButtons' cellspacing='2'>
	<tr>
	{$buttons}
	</tr>
</table>
<div id='layoutEditor' style='width:800px;'>
<input type='hidden' id='fieldwidth' value='{$fieldwidth}'>
<input type='hidden' id='maxColumns' value='{$maxColumns}'>
<div id='toolbox' style='float:left';>
	<h2 style='margin-bottom:20px;'>{$mod.LBL_TOOLBOX}</h2>
	<div id='delete'>
	{sugar_image name=Delete width=48 height=48}
	</div>

	{if ! isset($fromPortal)}	
	<div id='panelproxy'></div>
	{/if}
	<div id='rowproxy'></div>
	<div id='availablefields'>
	<p id='fillerproxy'></p>

	{counter name='idCount' assign='idCount' start='1'}	
	{foreach from=$available_fields item='col' key='id'}
		<div class='le_field' id='{$idCount}'>
			{if ! $fromModuleBuilder && ($col.name != '(filler)')}
				<img class='le_edit' src="themes/Sugar/images/edit_inline.gif" style='float:right; cursor:pointer;' onclick="var value_label = document.getElementById('le_label_{$idCount}').innerHTML; var value_tabindex = document.getElementById('le_tabindex_{$idCount}').innerHTML;ModuleBuilder.getContent('module=ModuleBuilder&action=editProperty&editModule={$module}&view={$view}&id_label=le_label_{$idCount}&name_label=label_{$col.label}&title_label={sugar_translate label='LBL_LABEL_TITLE' module='ModuleBuilder'}&value_label=' + value_label + '&id_tabindex=le_tabindex_{$idCount}&title_tabindex={sugar_translate label='LBL_TAB_ORDER' module='ModuleBuilder'}&name_tabindex=tabindex&value_tabindex=' + value_tabindex );" />
			{/if}
			{if isset($col.type) && ($col.type == 'address')}
				{$icon_address}
			{/if}
			{if isset($col.type) && ($col.type == 'phone')}
				{$icon_phone}
			{/if}
			<span id='le_label_{$idCount}'>{if !empty($translate) && !empty($col.label)}{sugar_translate label=$col.label module=$language}{else}{$col.label}{/if}</span>
			<span class='field_name'>{$col.name}</span>
			<span class='field_label'>{$col.label}</span>
			<span id='le_tabindex_{$idCount}' class='field_tabindex'>{$col.tabindex}</span>
		</div>
		{counter name='idCount' assign='idCount' print=false}
	{/foreach}
	</div>	
</div>

<div id='panels' style='float:right;'>

<h3>{$layouttitle}</h3>

{foreach from=$layout item='panel' key='panelid'}

	<div class='le_panel' id='{$idCount}'>
	{if $panelid ne ''}
		<h3 id='le_panellabel_{$idCount}'>{if !empty($translate)}{sugar_translate label=$panelid module=$language}{else}{$panelid}{/if}</h3>	
		<img class='le_edit' src="themes/Sugar/images/edit_inline.gif" style='cursor:pointer;' onclick="var value_label = document.getElementById('le_panellabel_{$idCount}').innerHTML;ModuleBuilder.getContent('module=ModuleBuilder&action=editProperty&editModule={$module}&view={$view}&id_label=le_panellabel_{$idCount}&name_label={$col.label}&title_label={sugar_translate label='LBL_LABEL_TITLE' module='ModuleBuilder'}&value_label=' + value_label );" />
	{/if}
		{counter name='idCount' assign='idCount' print=false}
			
		{foreach from=$panel item='row' key='rid'}
			<div class='le_row' id='{$idCount}'>
			{counter name='idCount' assign='idCount' print=false}	
			
			{foreach from=$row item='col' key='cid'}
				<div class='le_field' id='{$idCount}'>
			{if ! $fromModuleBuilder && ($col.name != '(filler)')}
						<img class='le_edit' src="themes/Sugar/images/edit_inline.gif" style='float:right; cursor:pointer;' onclick="var value_label = document.getElementById('le_label_{$idCount}').innerHTML; var value_tabindex = document.getElementById('le_tabindex_{$idCount}').innerHTML;ModuleBuilder.getContent('module=ModuleBuilder&action=editProperty&editModule={$module}&view={$view}&id_label=le_label_{$idCount}&name_label=label_{$col.label}&title_label={sugar_translate label='LBL_LABEL_TITLE' module='ModuleBuilder'}&value_label=' + value_label + '&id_tabindex=le_tabindex_{$idCount}&title_tabindex={sugar_translate label='LBL_TAB_ORDER' module='ModuleBuilder'}&name_tabindex=tabindex&value_tabindex=' + value_tabindex );" />
					{/if}
	
					{if isset($col.type) && ($col.type == 'address')}
						{$icon_address}
					{/if}
					{if isset($col.type) && ($col.type == 'phone')}
						{$icon_phone}
					{/if}
					<span id='le_label_{$idCount}'>{if !empty($translate) && !empty($col.label)}{sugar_translate label=$col.label module=$language}{else}{$col.label}{/if}</span>
					<span class='field_name'>{$col.name}</span>
					<span class='field_label'>{$col.label}</span>
					<span id='le_tabindex_{$idCount}' class='field_tabindex'>{$col.tabindex}</span>
				</div>
				{counter name='idCount' assign='idCount' print=false}
			{/foreach}
					
		</div>	
	{/foreach}
	
	</div>
{/foreach}

</div>
<input type='hidden' id='idCount' value='{$idCount}'>
</div>

<form name='prepareForSave' id='prepareForSave' action='index.php'>
<input type='hidden' name='module' value='ModuleBuilder'>
<input type='hidden' name='editModule' value='{$module}'>
<input type='hidden' name='view' value='{$view}'>
{if $fromPortal}
	<input type='hidden' name='PORTAL' value='1'>
{/if}
{if $fromModuleBuilder}
	<input type='hidden' name='MB' value='1'>
	<input type='hidden' name='package' value='{$package}'>
{/if}
<input type='hidden' name='to_pdf' value='1'>
</form>

{literal}
	<script>	
	Studio2.init();
	</script>
{/literal}
