<?php
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Professional Subscription
 * Agreement ("License") which can be viewed at
 * http://www.sugarcrm.com/crm/products/sugar-professional-eula.html
 * By installing or using this file, You have unconditionally agreed to the
 * terms and conditions of the License, and You may not use this file except in
 * compliance with the License.  Under the terms of the license, You shall not,
 * among other things: 1) sublicense, resell, rent, lease, redistribute, assign
 * or otherwise transfer Your rights to the Software, and 2) use the Software
 * for timesharing or service bureau purposes such as hosting the Software for
 * commercial gain and/or for the benefit of a third party.  Use of the Software
 * may be subject to applicable fees and any use of the Software without first
 * paying applicable fees is strictly prohibited.  You do not have the right to
 * remove SugarCRM copyrights from the source code or user interface.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *  (i) the "Powered by SugarCRM" logo and
 *  (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * Your Warranty, Limitations of liability and Indemnity are expressly stated
 * in the License.  Please refer to the License for the specific language
 * governing these rights and limitations under the License.  Portions created
 * by SugarCRM are Copyright (C) 2004-2007 SugarCRM, Inc.; All Rights Reserved.
 ********************************************************************************/
require_once('modules/ModuleBuilder/MB/AjaxCompose.php');
require_once('modules/DynamicFields/FieldViewer.php');
 class ViewModulefield extends SugarView{
 	function ViewModulefield(){
 		parent::SugarView();
 	}

 	function display(){
		$ac = $this->fetch();
		echo $ac->getJavascript();
 	}

 	function fetch($ac=false){

 		$type = $_REQUEST['view_package'];
 		$fv = new FieldViewer();
		if(empty($_REQUEST['field'])&& !empty($_REQUEST['name']))$_REQUEST['field'] = $_REQUEST['name'];
		$field_name = '';
		if(!empty($this->view_object_map['field_name']))
			$field_name = $this->view_object_map['field_name'];
		elseif(!empty($_REQUEST['field']))
			$field_name = $_REQUEST['field'];
		else
			$field_name = '';

		$action = 'saveField'; // tyoung bug 17606: default action is to save as a dynamic field; but for standard OOB fields we override this so don't create a new dynamic field instead of updating the existing field

		$isClone = false;
		if(!empty($this->view_object_map['is_clone']) && $this->view_object_map['is_clone'])
			$isClone = true;

		$field_types =  array('varchar'=>'TextField', 'int'=>'Integer', 'float'=>'Decimal','bool'=>'Checkbox','enum'=>'DropDown',
				'date'=>'Date', 'phone' => 'Phone', 'currency' => 'Currency', 'html' => 'HTML', 'radioenum' => 'Radio',
				'relate' => 'Relate', 'address' => 'Address', 'text' => 'TextArea', 'url' => 'Link');
 		if($type == 'studio') {
 			$studioClass = new stdClass;
 			$moduleName = $_REQUEST['view_module'];

			global $beanList;

			$objectName = $beanList[$moduleName];
			if($objectName == 'aCase') // Bug 17614 - renamed aCase as Case in vardefs for backwards compatibililty with 451 modules
            	$objectName = 'Case';
			require_once('include/SugarObjects/VardefManager.php');
			VardefManager::loadVardef($moduleName, $objectName);
			global $dictionary;
			$studioClass->mbvardefs->vardefs =  $dictionary[$objectName];
//			$GLOBALS['log']->debug('vardefs from dictionary = '.print_r($studioClass->mbvardefs->vardefs,true));
			$studioClass->name = $moduleName;
			if(!$ac){
				$ac = new AjaxCompose();
			}
			$vardef = (!empty($studioClass->mbvardefs->vardefs['fields'][$field_name]))? $studioClass->mbvardefs->vardefs['fields'][$field_name]: array();
//			$GLOBALS['log']->debug('vardefs after loading = '.print_r($vardef,true));
			if($isClone){
				unset($vardef['name']);
			}
			if(empty($vardef['name'])){
				if(!empty($_REQUEST['type']))$vardef['type'] = $_REQUEST['type'];
					$fv->ss->assign('hideLevel', 0);
			}elseif(isset($vardef['custom_module'])){
				$fv->ss->assign('hideLevel', 2);
			}else{
			    $action = 'saveLabel'; // tyoung - for OOB fields we currently only support modifying the label
				$fv->ss->assign('hideLevel', 10);
			}
			$GLOBALS['log']->warn('view.modulefield: hidelevel '.$fv->ss->get_template_vars('hideLevel')." ".print_r($vardef,true));
 			if(!empty($vardef['vname'])){
 				$fv->ss->assign('lbl_value', translate($vardef['vname'], $moduleName));
 			}
			$package = new stdClass;
			$package->name = 'studio';
			$fv->ss->assign('package', $package);
			$fv->ss->assign('module', $studioClass);
			$field_types['multienum'] = 'MultiSelect';
			if(empty($studioClass->mbvardefs->vardefs['fields']['parent_name']) || (isset($vardef['type']) && $vardef['type'] == 'parent'))
				$field_types['parent'] = 'Flex Relate';
 		} else {
	 		require_once('modules/ModuleBuilder/MB/ModuleBuilder.php');
			$mb = new ModuleBuilder();
			$this->module =& $mb->getPackageModule($_REQUEST['view_package'], $_REQUEST['view_module']);
			$package =& $mb->packages[$_REQUEST['view_package']];
			$this->module->getVardefs();
			if(!$ac){
				$ac = new AjaxCompose();
			}
			$vardef = (!empty($this->module->mbvardefs->vardefs['fields'][$field_name]))? $this->module->mbvardefs->vardefs['fields'][$field_name]: array();
			if($isClone){
				unset($vardef['name']);
			}

			if(empty($vardef['name'])){
				if(!empty($_REQUEST['type']))$vardef['type'] = $_REQUEST['type'];
					$fv->ss->assign('hideLevel', 0);
			}else{
				if(!empty($this->module->mbvardefs->vardef['fields'][$vardef['name']])){
					$fv->ss->assign('hideLevel', 1);
				}elseif(isset($vardef['custom_module'])){
					$fv->ss->assign('hideLevel', 2);
				}else{
				    $action = 'saveLabel'; // tyoung - for template fields we currently only support modifying the label
					$fv->ss->assign('hideLevel', 10); // tyoung bug 17350 - effectively mark template derived fields as readonly
				}
			}

			$fv->ss->assign('module', $this->module);
			$fv->ss->assign('package', $package);
			$fv->ss->assign('MB','1');

			if(isset($vardef['vname']))
				$fv->ss->assign('lbl_value', $this->module->getLabel('en_us',$vardef['vname']));
			$field_types['multienum'] = 'MultiSelect';
			if(empty($this->module->mbvardefs->vardefs['fields']['parent_name']) || (isset($vardef['type']) && $vardef['type'] == 'parent'))
				$field_types['parent'] = 'Flex Relate';
 		}

		if($_REQUEST['action'] == 'RefreshField'){
				require_once('modules/DynamicFields/FieldCases.php');
				$field = get_widget($_POST['type']);
				$field->populateFromPost();
				$vardef = $field->get_field_def();
				$vardef['options'] = $_REQUEST['new_dropdown'];
				$fv->ss->assign('lbl_value', $_REQUEST['label_value']);
			}

		$fv->ss->assign('action',$action);
		$fv->ss->assign('isClone', ($isClone ? 1 : 0));
		$json = getJSONobj();
		$arr = array('int1', 'int2', 'int3', 'int4', 'int8');
		$arr = $json->encode($arr);
		$fv->ss->assign('field_name_exceptions', $arr);
		ksort($field_types);
		$fv->ss->assign('field_types',$field_types);
		$fv->ss->assign('duplicate_merge_options', $GLOBALS['app_list_strings']['custom_fields_merge_dup_dom']);
		//_ppd($GLOBALS['app_list_strings']['custom_fields_merge_dup_dom']);
		$layout = $fv->getLayout($vardef);
		//_ppd($vardef);
		$fv->ss->assign('fieldLayout', $layout);
		if(empty($vardef['type']))
			$vardef['type'] = 'varchar';
		$fv->ss->assign('vardef', $vardef);
		$fv->ss->assign('mod_strings',$GLOBALS['mod_strings']);
		$body = $fv->ss->fetch('modules/ModuleBuilder/tpls/MBModule/field.tpl');
		$ac->addSection('east', translate('LBL_SECTION_FIELDEDITOR','ModuleBuilder'), $body );
		$ac->addSection('east2', 'no_change', '', 'deactivate' );
 		return $ac;
 	}

 }
?>
