<?php
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Professional Subscription
 * Agreement ("License") which can be viewed at
 * http://www.sugarcrm.com/crm/products/sugar-professional-eula.html
 * By installing or using this file, You have unconditionally agreed to the
 * terms and conditions of the License, and You may not use this file except in
 * compliance with the License.  Under the terms of the license, You shall not,
 * among other things: 1) sublicense, resell, rent, lease, redistribute, assign
 * or otherwise transfer Your rights to the Software, and 2) use the Software
 * for timesharing or service bureau purposes such as hosting the Software for
 * commercial gain and/or for the benefit of a third party.  Use of the Software
 * may be subject to applicable fees and any use of the Software without first
 * paying applicable fees is strictly prohibited.  You do not have the right to
 * remove SugarCRM copyrights from the source code or user interface.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *  (i) the "Powered by SugarCRM" logo and
 *  (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * Your Warranty, Limitations of liability and Indemnity are expressly stated
 * in the License.  Please refer to the License for the specific language
 * governing these rights and limitations under the License.  Portions created
 * by SugarCRM are Copyright (C) 2004-2007 SugarCRM, Inc.; All Rights Reserved.
 ********************************************************************************/
require_once('modules/ModuleBuilder/MB/AjaxCompose.php');
require_once('modules/ModuleBuilder/views/view.modulefield.php');
 class ViewModulefields extends SugarView{
 	function ViewModulefields(){
 		parent::SugarView();
 	}
 	
 	function display(){
 		$smarty = new Sugar_Smarty();
        global $mod_strings;
        $bak_mod_strings=$mod_strings;
        $smarty->assign('mod_strings', $mod_strings);
 		$type = $_REQUEST['view_package'];
 		$module_name = $_REQUEST['view_module'];
 		///////////////////////////
			//ASSISTANT
			$assistant=array('group'=>'module', 'key'=>'viewfields');
			$smarty->assign('assistant',$assistant);
			//////////////////////////
			//ASSISTANT
 		if($type == 'studio') {
 		    $this->loadPackageHelp($module_name);
			$studioClass = new stdClass;
			$studioClass->name = $module_name;
			require_once('include/SugarObjects/VardefManager.php');
			global $beanList;
			$objectName = $beanList[$module_name];
			if($objectName == 'aCase') // Bug 17614 - renamed aCase as Case in vardefs for backwards compatibililty with 451 modules
            	$objectName = 'Case';

			VardefManager::loadVardef($module_name, $objectName);
			global $dictionary;
			$f = array($mod_strings['LBL_HCUSTOM']=>array(), $mod_strings['LBL_HDEFAULT']=>array());
			$def = $this->cullFields($dictionary[$objectName]['fields']);
			
			foreach($dictionary[$objectName]['fields'] as $def) {
				if ((!empty($def['studio']) && $def['studio'] == 'visible') 
            		|| (empty($def['studio']) &&  
            		(empty($def ['source']) 
            		|| $def ['source'] == 'db' || $def ['source'] == 'custom_fields') && $def ['type'] != 'id' && (empty($def ['dbType']) || $def ['dbType'] != 'id') && (empty($def ['dbtype']) || $def ['dbtype'] != 'id')))
            	{

				   
				    if(isset($def['source']) && $def['source'] == 'custom_fields' || !empty($def['studio'])) {
				       $f[$mod_strings['LBL_HCUSTOM']][$def['name']] = $def;	
				    } else {
				       $f[$mod_strings['LBL_HDEFAULT']][$def['name']] = $def;
				    }
            	}
			}
			$studioClass->mbvardefs->vardefs['fields'] = $f; //$dictionary[$objectName]['fields']; 
			$smarty->assign('module', $studioClass);
			
			$package = new stdClass;
			$package->name = 'studio';
			$smarty->assign('package', $package);
			$ajax = new AjaxCompose();
			$ajax->addCrumb($mod_strings['LBL_STUDIO'], 'ModuleBuilder.getContent("module=ModuleBuilder&action=wizard")');
			$ajax->addCrumb(ucwords($module_name), 'ModuleBuilder.getContent("module=ModuleBuilder&action=wizard&editModule='.$module_name.'")');
			$ajax->addCrumb($mod_strings['LBL_FIELDS'], '');
			$ajax->addSection('center', $mod_strings['LBL_EDIT_FIELDS'],$smarty->fetch('modules/ModuleBuilder/tpls/MBModule/fields.tpl'));
			$_REQUEST['field'] = '';
	
			echo $ajax->getJavascript();
 		} else {
			require_once('modules/ModuleBuilder/MB/ModuleBuilder.php');
			$mb = new ModuleBuilder();
			$mb->getPackage($_REQUEST['view_package']);
			$package = $mb->packages[$_REQUEST['view_package']];
			
			$package->getModule($module_name);
			$this->module = $package->modules[$module_name];
			$this->loadPackageHelp($module_name);
			$this->module->getVardefs(true);
			$this->module->mbvardefs->vardefs['fields'] = array_reverse($this->module->mbvardefs->vardefs['fields'], true);
			foreach($this->module->mbvardefs->vardefs['fields'] as $k=>$v){
				if($k != $module_name)
				    $titleLBL[$k]=translate("LBL_".strtoupper($k),'ModuleBuilder');
				else{
					$titleLBL[$k]=$k;
				}
			}
			$this->module->mbvardefs->vardefs['fields'][$module_name] = $this->cullFields($this->module->mbvardefs->vardefs['fields'][$module_name]);
 		    if(file_exists($this->module->path. '/language/'.$GLOBALS['current_language'].'.lang.php')){
                include($this->module->path .'/language/'. $GLOBALS['current_language'].'.lang.php');
                $this->module->setModStrings($GLOBALS['current_language'],$mod_strings);
            }
			elseif(file_exists($this->module->path. '/language/en_us.lang.php')){
				include($this->module->path .'/language/en_us.lang.php');
				$this->module->setModStrings('en_us',$mod_strings);
			}
			$smarty->assign('title', $titleLBL);
			$smarty->assign('package', $package);
			$smarty->assign('module', $this->module);
			$smarty->assign('editLabelsMb','1'); //need to merge MB labels and studio labels. quick fix for now.
			
			
			$ajax = new AjaxCompose();
			$ajax->addCrumb($bak_mod_strings['LBL_MODULEBUILDER'], 'ModuleBuilder.main("mb")');
			$ajax->addCrumb($package->name,'ModuleBuilder.getContent("module=ModuleBuilder&action=package&package='.$package->name.'")');
			$ajax->addCrumb($module_name, 'ModuleBuilder.getContent("module=ModuleBuilder&action=module&view_package='.$package->name.'&view_module='. $module_name . '")');
			$ajax->addCrumb($bak_mod_strings['LBL_FIELDS'], '');
			$ajax->addSection('center', 'no_change',$smarty->fetch('modules/ModuleBuilder/tpls/MBModule/fields.tpl'));
			$_REQUEST['field'] = '';
	
			echo $ajax->getJavascript();


 		}
 	}
 	
 	function loadPackageHelp($name){
 			$this->module->help['default'] = (empty($name))?'create':'modify';
 			$this->module->help['group'] = 'module';
 	}
 	
 	function cullFields($def){
 		 if(!empty($def['parent_id']))
			unset($def['parent_id']);
		if(!empty($def['parent_type']))
			unset($def['parent_type']);
		if(!empty($def['currency_id']))
			unset($def['currency_id']);
		return $def;
 	}
 }
?>
