<?php
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Professional Subscription
 * Agreement ("License") which can be viewed at
 * http://www.sugarcrm.com/crm/products/sugar-professional-eula.html
 * By installing or using this file, You have unconditionally agreed to the
 * terms and conditions of the License, and You may not use this file except in
 * compliance with the License.  Under the terms of the license, You shall not,
 * among other things: 1) sublicense, resell, rent, lease, redistribute, assign
 * or otherwise transfer Your rights to the Software, and 2) use the Software
 * for timesharing or service bureau purposes such as hosting the Software for
 * commercial gain and/or for the benefit of a third party.  Use of the Software
 * may be subject to applicable fees and any use of the Software without first
 * paying applicable fees is strictly prohibited.  You do not have the right to
 * remove SugarCRM copyrights from the source code or user interface.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *  (i) the "Powered by SugarCRM" logo and
 *  (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * Your Warranty, Limitations of liability and Indemnity are expressly stated
 * in the License.  Please refer to the License for the specific language
 * governing these rights and limitations under the License.  Portions created
 * by SugarCRM are Copyright (C) 2004-2007 SugarCRM, Inc.; All Rights Reserved.
 ********************************************************************************/
require_once('modules/ModuleBuilder/MB/AjaxCompose.php');
require_once('modules/ModuleBuilder/MB/ModuleBuilder.php');
require_once('modules/ModuleBuilder/views/view.relationship.php');
 class ViewRelationship extends SugarView{
 	function ViewRelationship(){
 		parent::SugarView();
 	}
 	
 	function display(){
 		$mb = new ModuleBuilder();
 		$this->module =& $mb->getPackageModule($_REQUEST['view_package'], $_REQUEST['view_module']);
 		$ac = $this->fetch();
 		echo $ac->getJavascript();
 	}
 	
 	function fetch($ac = false){
 		$smarty = new Sugar_Smarty();
		$this->module->mbrelationship->findRelatableModules();
		$rel = $this->module->mbrelationship->relationshipFromPost();
		$smarty->assign('mod_strings', $GLOBALS['mod_strings']);
		$smarty->assign('package', $_REQUEST['view_package']);
		$smarty->assign('module', $this->module);
		$smarty->assign('relatable', array_keys($this->module->mbrelationship->relatableModules));
		if(empty($rel['relate'])){
			$keys = array_keys($this->module->mbrelationship->relatableModules);
			$rel['relate'] = $keys[0];
		}
		if(!empty($rel['relate'])){
			$rel['name'] = strtolower( $rel['relate']);
			$smarty->assign('relatablePanels', $this->module->mbrelationship->relatableModules[$rel['relate']]);
			$smarty->assign('availablePanels', $this->module->mbrelationship->relatableModules[$this->module->key_name]);
		}
		$smarty->assign('rel', $rel);
		if(empty($ac))$ac = new AjaxCompose();
		$ac->addSection('east', $this->module->name . ' '.$GLOBALS['mod_strings']['LBL_RELATIONSHIPS'],$smarty->fetch('modules/ModuleBuilder/tpls/MBRelationship/relationship.tpl'));
		return $ac;
 		
 	}
 	
 }
