<?php
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Professional Subscription
 * Agreement ("License") which can be viewed at
 * http://www.sugarcrm.com/crm/products/sugar-professional-eula.html
 * By installing or using this file, You have unconditionally agreed to the
 * terms and conditions of the License, and You may not use this file except in
 * compliance with the License.  Under the terms of the license, You shall not,
 * among other things: 1) sublicense, resell, rent, lease, redistribute, assign
 * or otherwise transfer Your rights to the Software, and 2) use the Software
 * for timesharing or service bureau purposes such as hosting the Software for
 * commercial gain and/or for the benefit of a third party.  Use of the Software
 * may be subject to applicable fees and any use of the Software without first
 * paying applicable fees is strictly prohibited.  You do not have the right to
 * remove SugarCRM copyrights from the source code or user interface.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *  (i) the "Powered by SugarCRM" logo and
 *  (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * Your Warranty, Limitations of liability and Indemnity are expressly stated
 * in the License.  Please refer to the License for the specific language
 * governing these rights and limitations under the License.  Portions created
 * by SugarCRM are Copyright (C) 2004-2007 SugarCRM, Inc.; All Rights Reserved.
 ********************************************************************************/
require_once('modules/ModuleBuilder/MB/AjaxCompose.php');
require_once('modules/ModuleBuilder/MB/ModuleBuilder.php');
require_once('modules/ModuleBuilder/views/view.relationship.php');
 class ViewRelationships extends SugarView{
 	function ViewRelationships(){
 		parent::SugarView();
 	}
 	
 	function display(){
 		$smarty = new Sugar_Smarty();
		$module_name = $_REQUEST['view_module'];
		$mb = new ModuleBuilder();
		$this->module =& $mb->getPackageModule($_REQUEST['view_package'], $_REQUEST['view_module']);
		$package = $mb->packages[$_REQUEST['view_package']];
		$this->loadRelationshipHelp($_REQUEST['view_module']);
		$ajax = new AjaxCompose();
		$smarty->assign('module', $this->module);
		$smarty->assign('mod_strings', $GLOBALS['mod_strings']);
		//////////////////////////////////////////
		//ASSISTANT
		$smarty->assign('assistant', array('group'=>'module', 'key'=>'viewrelationships'));
		////////////////////////////////////////
		//ASSISTANT
		
		$ajax->addCrumb($GLOBALS['mod_strings']['LBL_MODULEBUILDER'], 'ModuleBuilder.main("mb")');
		$ajax->addCrumb($package->name,'ModuleBuilder.getContent("module=ModuleBuilder&action=package&package='.$package->name.'")');
		$ajax->addCrumb($module_name, 'ModuleBuilder.getContent("module=ModuleBuilder&action=module&view_package='.$package->name.'&view_module='. $module_name . '")');
		$ajax->addCrumb($GLOBALS['mod_strings']['LBL_RELATIONSHIPS'], '');
		$ajax->addSection('center', $this->module->name.' '.$GLOBALS['mod_strings']['LBL_RELATIONSHIPS'],$smarty->fetch('modules/ModuleBuilder/tpls/MBRelationship/relationships.tpl'));
		echo $ajax->getJavascript();
 	}
 	
 	function loadRelationshipHelp($name){
 			$this->module->help['default'] = (empty($name))?'create':'modify';
 			$this->module->help['group'] = 'module';
 	}
 }
?>
