<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
/**
 * The contents of this file are subject to the SugarCRM Professional Subscription
 * Agreement ("License") which can be viewed at
 * http://www.sugarcrm.com/crm/products/sugar-professional-eula.html
 * By installing or using this file, You have unconditionally agreed to the
 * terms and conditions of the License, and You may not use this file except in
 * compliance with the License.  Under the terms of the license, You shall not,
 * among other things: 1) sublicense, resell, rent, lease, redistribute, assign
 * or otherwise transfer Your rights to the Software, and 2) use the Software
 * for timesharing or service bureau purposes such as hosting the Software for
 * commercial gain and/or for the benefit of a third party.  Use of the Software
 * may be subject to applicable fees and any use of the Software without first
 * paying applicable fees is strictly prohibited.  You do not have the right to
 * remove SugarCRM copyrights from the source code or user interface.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *  (i) the "Powered by SugarCRM" logo and
 *  (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * Your Warranty, Limitations of liability and Indemnity are expressly stated
 * in the License.  Please refer to the License for the specific language
 * governing these rights and limitations under the License.  Portions created
 * by SugarCRM are Copyright (C) 2004-2007 SugarCRM, Inc.; All Rights Reserved.
 */



require_once('modules/ModuleBuilder/views/view.listview.php');
require_once('include/Sugar_Smarty.php');

class ViewSearchView extends ViewListView {

    function ViewSearchView()
    {
        $this->init();
    }

    function init()
    {
        $this->searchlayout = $_REQUEST['searchlayout'];
        parent::init();
    }

	// DO NOT REMOVE - overrides parent ViewEdit preDisplay() which attempts to load a bean for a non-existent module
	function preDisplay() {
	}

    function display() {

        require_once('modules/ModuleBuilder/parsers/ParserFactory.php');
        $parser = ParserFactory::getParser("SearchView",$this->fromModuleBuilder);
        $parser->init($this->editModule, $this->searchlayout);

        $smarty = $this->constructSmarty($parser);

        $ajax = $this->constructAjax();
        $ajax->addSection('center', 'no_change', $smarty->fetch("modules/ModuleBuilder/tpls/listView.tpl") );
       // $ajax->addSection('east', 'no_change', "");

        echo $ajax->getJavascript();

    }
    function constructAjax()
    {
        require_once('modules/ModuleBuilder/MB/AjaxCompose.php');
        $ajax = new AjaxCompose();
        $searchLabel = ($this->searchlayout == 'basic_search') ? translate('LBL_BASIC_SEARCH', 'ModuleBuilder') : translate('LBL_ADVANCED_SEARCH', 'ModuleBuilder');
        if ($this->fromModuleBuilder)
        {
            $ajax->addCrumb(translate('LBL_MODULEBUILDER', 'ModuleBuilder'), 'ModuleBuilder.main("mb")');
            $ajax->addCrumb($_REQUEST['package'],'ModuleBuilder.getContent("module=ModuleBuilder&action=package&package='.$_REQUEST['package'].'")');
            $ajax->addCrumb($_REQUEST['editModule'], 'ModuleBuilder.getContent("module=ModuleBuilder&action=module&view_package='.$_REQUEST['package'].'&view_module='. $_REQUEST['editModule'] . '")');
            $ajax->addCrumb(translate('LBL_LAYOUTS', 'ModuleBuilder'), 'ModuleBuilder.getContent("module=ModuleBuilder&MB=true&action=wizard&editModule='.$_REQUEST['editModule'].'&package='.$_REQUEST['package'].'")');
            if($this->subpanel != "")
            {
                $ajax->addCrumb(translate('LBL_SUBPANELS', 'ModuleBuilder'), '');
                $ajax->addCrumb($this->subpanel, '');
            }
            else
            {
                $ajax->addCrumb(translate('LBL_SEARCH_FORMS', 'ModuleBuilder'), 'ModuleBuilder.getContent("module=ModuleBuilder&MB=true&action=wizard&search=1&editModule='.$this->editModule.'&package='.$_REQUEST['package'].'")');
                $ajax->addCrumb($searchLabel, 'ModuleBuilder.getContent("module=ModuleBuilder&MB=true&action=editLayout&view=SearchView&searchlayout='.$this->searchlayout.'&editModule='.$this->editModule.'&package='.$_REQUEST['package'].'")');
            }
        }
        else
        {
            $ajax->addCrumb(translate('LBL_STUDIO', 'ModuleBuilder'), 'ModuleBuilder.getContent("module=ModuleBuilder&action=wizard")');
            $ajax->addCrumb($this->translatedEditModule, 'ModuleBuilder.getContent("module=ModuleBuilder&action=wizard&editModule='.$this->editModule.'")');

            if($this->subpanel)
            {
                $ajax->addCrumb(translate('LBL_SUBPANELS', 'ModuleBuilder'), 'ModuleBuilder.getContent("module=ModuleBuilder&action=wizard&subpanels=1&editModule='.$this->editModule.'")');
                $ajax->addCrumb($this->subpanel, 'ModuleBuilder.getContent("module=ModuleBuilder&action=editLayout&view=ListView&editModule='.$this->editModule.'&subpanel='.$this->subpanel.'")');
            }
            else
            {
                //$ajax->addCrumb(translate('LBL_SEARCH_FORMS', 'ModuleBuilder'), 'ModuleBuilder.getContent("module=ModuleBuilder&action=wizard&search=1&editModule='.$this->editModule.'")');
                $ajax->addCrumb(translate('LBL_LAYOUTS', 'ModuleBuilder'), 'ModuleBuilder.getContent("module=ModuleBuilder&action=wizard&layouts=1&editModule='.$this->editModule.'")');
                $ajax->addCrumb($searchLabel, 'ModuleBuilder.getContent("module=ModuleBuilder&action=editLayout&view=SearchView&searchlayout='.$this->searchlayout.'&editModule='.$this->editModule.'")');
            }
        }
        return $ajax;
    }

   function constructSmarty($parser) {
       $smarty = parent::constructSmarty($parser);
       $smarty->assign('action', 'searchViewSave');
       $smarty->assign('view', 'searchView');
       $smarty->assign('searchlayout', $this->searchlayout);
       $smarty->assign('helpName', 'searchViewEditor');
       $smarty->assign('helpDefault', 'modify');
       $smarty->assign('assistant', array('key'=>'multiselect_field_warning', 'group'=>'searchViewEditor'));
       return $smarty;
   }


}

?>
