<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
/**
 * Table definition file for the project table
 *
 * The contents of this file are subject to the SugarCRM Professional Subscription
 * Agreement ("License") which can be viewed at
 * http://www.sugarcrm.com/crm/products/sugar-professional-eula.html
 * By installing or using this file, You have unconditionally agreed to the
 * terms and conditions of the License, and You may not use this file except in
 * compliance with the License.  Under the terms of the license, You shall not,
 * among other things: 1) sublicense, resell, rent, lease, redistribute, assign
 * or otherwise transfer Your rights to the Software, and 2) use the Software
 * for timesharing or service bureau purposes such as hosting the Software for
 * commercial gain and/or for the benefit of a third party.  Use of the Software
 * may be subject to applicable fees and any use of the Software without first
 * paying applicable fees is strictly prohibited.  You do not have the right to
 * remove SugarCRM copyrights from the source code or user interface.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *  (i) the "Powered by SugarCRM" logo and
 *  (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * Your Warranty, Limitations of liability and Indemnity are expressly stated
 * in the License.  Please refer to the License for the specific language
 * governing these rights and limitations under the License.  Portions created
 * by SugarCRM are Copyright (C) 2004-2007 SugarCRM, Inc.; All Rights Reserved.
 */



$dictionary['ProjectResource'] = array ( 
	'table' => 'project_resources', 
	'fields' => array (
		'id' => array(
			'name' => 'id',
			'vname' => 'LBL_ID',
			'required' => true,
			'type' => 'id',
			'reportable'=>false,
			'comment' => 'Unique identifier'
		),
		'date_modified' => array(
			'name' => 'date_modified',
			'vname' => 'LBL_DATE_MODIFIED',
			'type' => 'datetime',
			'required' => true,
			'comment' => 'Date record last modified'
		),
		'modified_user_id' => array(
			'name' => 'modified_user_id',
			'rname' => 'user_name',
			'id_name' => 'modified_user_id',
			'vname' => 'LBL_MODIFIED_USER_ID',
			'type' => 'assigned_user_name',
			'table' => 'users',
			'isnull' => 'false',
			'dbType' => 'id',
			'reportable'=>true,
			'comment' => 'User who last modified record'
		),
		'created_by' => array(
			'name' => 'created_by',
			'rname' => 'user_name',
			'id_name' => 'modified_user_id',
			'vname' => 'LBL_CREATED_BY',
			'type' => 'assigned_user_name',
			'table' => 'users',
			'isnull' => 'false',
			'dbType' => 'id',
			'comment' => 'User who created record'
		),
  		array (
    		'name' => 'project_id',
    		'vname' => 'LBL_PROJECT_ID',
    		'reportable'=>false,
    		'dbtype' => 'id',
    		'type' => 'id',
		),
  		array (
    		'name' => 'resource_id',
    		'vname' => 'LBL_RESOURCE_ID',
    		'reportable'=>false,
    		'dbtype' => 'id',
    		'type' => 'id',
		),
  		array (
    		'name' => 'resource_type',
    		'vname' => 'LBL_RESOURCE_TYPE',
    		'reportable'=>false,
    		'type' => 'varchar',
    		'len' => '20',
		),
		'deleted' => array(
			'name' => 'deleted',
			'vname' => 'LBL_DELETED',
			'type' => 'bool',
			'required' => true,
			'default' => '0',
			'comment' => 'Record deletion indicator'
		),			
	),
    'indices' => array (
       	array('name' =>'project_resources_pk', 'type' =>'primary', 'fields'=>array('id')),
	),
    'relationships' => array(
        'projects_users_resources' => array(
            'lhs_module'        => 'Project', 
            'lhs_table'         => 'project', 
            'lhs_key'           => 'id',
            'rhs_module'        => 'Users', 
            'rhs_table'         => 'users', 
            'rhs_key'           => 'id',
            'relationship_type' => 'many-to-many',
            'join_table'        => 'project_resources', 
            'join_key_lhs'      => 'project_id', 
            'join_key_rhs'      => 'resource_id',
			'relationship_role_column'=>'resource_type',
			'relationship_role_column_value'=>'Users',            
        ),
        'projects_contacts_resources' => array(
            'lhs_module'        => 'Project', 
            'lhs_table'         => 'project', 
            'lhs_key'           => 'id',
            'rhs_module'        => 'Contacts', 
            'rhs_table'         => 'contacts', 
            'rhs_key'           => 'id',
            'relationship_type' => 'many-to-many',
            'join_table'        => 'project_resources', 
            'join_key_lhs'      => 'project_id', 
            'join_key_rhs'      => 'resource_id',
			'relationship_role_column'=>'resource_type',
			'relationship_role_column_value'=>'Contacts',            
        ),        
    ),
);
?>
