<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');

/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Professional Subscription
 * Agreement ("License") which can be viewed at
 * http://www.sugarcrm.com/crm/products/sugar-professional-eula.html
 * By installing or using this file, You have unconditionally agreed to the
 * terms and conditions of the License, and You may not use this file except in
 * compliance with the License.  Under the terms of the license, You shall not,
 * among other things: 1) sublicense, resell, rent, lease, redistribute, assign
 * or otherwise transfer Your rights to the Software, and 2) use the Software
 * for timesharing or service bureau purposes such as hosting the Software for
 * commercial gain and/or for the benefit of a third party.  Use of the Software
 * may be subject to applicable fees and any use of the Software without first
 * paying applicable fees is strictly prohibited.  You do not have the right to
 * remove SugarCRM copyrights from the source code or user interface.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *  (i) the "Powered by SugarCRM" logo and
 *  (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * Your Warranty, Limitations of liability and Indemnity are expressly stated
 * in the License.  Please refer to the License for the specific language
 * governing these rights and limitations under the License.  Portions created
 * by SugarCRM are Copyright (C) 2004-2007 SugarCRM, Inc.; All Rights Reserved.
 ********************************************************************************/
require_once('modules/Reports/SavedReport.php');
require_once('XTemplate/xtpl.php');

require_once('include/contextMenus/contextMenu.php');
require_once('modules/Reports/schedule/ReportSchedule.php');
require_once('modules/Reports/ListViewReports.php');
if(file_exists('custom/modules/Reports/metadata/listviewdefs.php')){
    require_once('custom/modules/Reports/metadata/listviewdefs.php');  
}else{
    require_once('modules/Reports/metadata/listviewdefs.php');
}
require_once('modules/SavedSearch/SavedSearch.php');
require_once('include/SearchForm/SearchForm.php');
require_once('include/ListView/ListViewSmarty.php');


global $published_report_titles;
global $my_report_titles;
global $current_user;
global $modules_report;
global $mod_strings;
global $module_map;
global $report_modules;

$savedReportsSeed = new SavedReport();
$lv = new ListViewReports();

require_once('modules/MySettings/StoreQuery.php');
$storeQuery = new StoreQuery();

if(!isset($_REQUEST['query'])){
    $storeQuery->loadQuery($currentModule);
    $storeQuery->populateRequest();
}else{
    $storeQuery->saveFromGet($currentModule);   
}

// setup for search form
$thisMod = 'Reports';
$searchForm = new SearchForm($thisMod, $savedReportsSeed);
$searchForm->tabs = array(array('title'  => $app_strings['LNK_BASIC_SEARCH'],
                          'link'   => $thisMod . '|basic_search',
                          'key'    => $thisMod . '|basic_search'),
                    array('title'  => $app_strings['LNK_ADVANCED_SEARCH'],
                          'link'   => $thisMod . '|advanced_search',
                          'key'    => $thisMod . '|advanced_search'));

$searchForm->populateFromRequest();
$searchForm->searchFields['module'] = $searchForm->searchFields['report_module'];
unset($searchForm->searchFields['report_module']);
$where_clauses = $searchForm->generateSearchWhere();
include('include/modules.php');
$ACLAllowedModules = getACLAllowedModules();
$ACLAllowedModulesKeys = array_keys($ACLAllowedModules);

foreach($moduleList as $module) {
    if(!in_array($module, $ACLAllowedModulesKeys)) {
        array_push($where_clauses, "saved_reports.module != '$module'");
    }
}

$reportModules = array();

foreach($ACLAllowedModules as $key => $module) {
    $reportModules[$key] = $app_list_strings['moduleList'][$key];
} 
asort($reportModules);
if(!empty($_REQUEST['search_form_only']) && $_REQUEST['search_form_only']) { // handle ajax requests for search forms only
    switch($_REQUEST['search_form_view']) {
        case 'basic_search':
            $searchForm->setup();
		    $searchForm->xtpl->assign('MODULES', get_select_options_with_id($reportModules,  (empty($_REQUEST['report_module']) ? '' : $_REQUEST['report_module'])));
			$searchForm->xtpl->assign('USER_FILTER', get_select_options_with_id(get_user_array(FALSE), (empty($_REQUEST['assigned_user_id']) ? '' : $_REQUEST['assigned_user_id'])));
			$searchForm->xtpl->assign('TEAM_FILTER', get_select_options_with_id(get_team_array(FALSE), (empty($_REQUEST['team_id']) ? '' : $_REQUEST['team_id'])));
			$searchForm->xtpl->assign('REPORT_TYPES', get_select_options_with_id($app_list_strings['dom_report_types'], (empty($_REQUEST['report_type']) ? '' : $_REQUEST['report_type'])));
            
            $searchForm->displayBasic(false);
            break;
        case 'advanced_search':
            $searchForm->setup();
		    $searchForm->xtpl->assign('MODULES', get_select_options_with_id($reportModules,  (empty($_REQUEST['report_module']) ? '' : $_REQUEST['report_module'])));
			$searchForm->xtpl->assign('USER_FILTER', get_select_options_with_id(get_user_array(FALSE), (empty($_REQUEST['assigned_user_id']) ? '' : $_REQUEST['assigned_user_id'])));
			$searchForm->xtpl->assign('TEAM_FILTER', get_select_options_with_id(get_team_array(FALSE), (empty($_REQUEST['team_id']) ? '' : $_REQUEST['team_id'])));
			$searchForm->xtpl->assign('REPORT_TYPES', get_select_options_with_id($app_list_strings['dom_report_types'], (empty($_REQUEST['report_type']) ? '' : $_REQUEST['report_type'])));

            $searchForm->displayAdvanced(false, false, $listViewDefs, $lv);
            break;
        case 'saved_views':
            echo $searchForm->displaySavedViews($listViewDefs, $lv, false);
            break;
    }
    return;
}
if(!empty($_REQUEST['view'])) { // backwards compatibility support for menu links from other modules
    array_push($where_clauses, 'saved_reports.module = \'' . ucwords(clean_string($_REQUEST['view'])) . '\'');
}
if(!empty($_REQUEST['favorite'])) { // handle favorite requests
    $current_favorites = $current_user->getPreference('favorites', 'Reports');
    if(is_array($current_favorites) && !empty($current_favorites))
        array_push($where_clauses, 'saved_reports.id IN (\'' . implode("','", array_keys($current_favorites)) . '\')');
    else {
        array_push($where_clauses, 'saved_reports.id IN (\'-1\')');
    }
}
$displayColumns = array();
if(!empty($_REQUEST['displayColumns'])) {
    foreach(explode('|', $_REQUEST['displayColumns']) as $num => $col) {
        if(!empty($listViewDefs['Reports'][$col])) 
            $displayColumns[$col] = $listViewDefs['Reports'][$col];
    }    
}
elseif(!empty($savedDisplayColumns)) {
    $displayColumns = $savedDisplayColumns;
}
else {
    foreach($listViewDefs['Reports'] as $col => $p) {
        if(!empty($p['default']) && $p['default'])
            $displayColumns[$col] = $p;
    }
}
$lv->export = false;
$lv->displayColumns = $displayColumns;

if(empty($_REQUEST['favorite'])) { // display search form for non-favorite views
	if(!isset($_REQUEST['search_form']) || $_REQUEST['search_form'] != 'false') {
	    $searchForm->setup();
	    if(isset($_REQUEST['searchFormTab']) && $_REQUEST['searchFormTab'] == 'advanced_search') {
		    $searchForm->xtpl->assign('MODULES', get_select_options_with_id($reportModules,  (empty($_REQUEST['report_module']) ? '' : $_REQUEST['report_module'])));
			$searchForm->xtpl->assign('TEAM_FILTER', get_select_options_with_id(get_team_array(FALSE), (empty($_REQUEST['team_id']) ? '' : $_REQUEST['team_id'])));
			$searchForm->xtpl->assign('USER_FILTER', get_select_options_with_id(get_user_array(FALSE), (empty($_REQUEST['assigned_user_id']) ? '' : $_REQUEST['assigned_user_id'])));
			$searchForm->xtpl->assign('REPORT_TYPES', get_select_options_with_id($app_list_strings['dom_report_types'], (empty($_REQUEST['report_type']) ? '' : $_REQUEST['report_type'])));
	        $searchForm->displayAdvanced(true, false, $listViewDefs, $lv);
	    }else {
		    $searchForm->xtpl->assign('MODULES', get_select_options_with_id($reportModules,  (empty($_REQUEST['report_module_basic']) ? '' : $_REQUEST['report_module_basic'])));
			$searchForm->xtpl->assign('USER_FILTER', get_select_options_with_id(get_user_array(FALSE), (empty($_REQUEST['assigned_user_id_basic']) ? '' : $_REQUEST['assigned_user_id_basic'])));
			$searchForm->xtpl->assign('REPORT_TYPES', get_select_options_with_id($app_list_strings['dom_report_types'], (empty($_REQUEST['report_type_basic']) ? '' : $_REQUEST['report_type_basic'])));
	        $searchForm->displayBasic();
	    }
	}
}
$params = array('massupdate' => true, 'handleMassupdate' => false);

// handle add to favorites request
$favoritesText = '';
if((!empty($_POST['addtofavorites']) || !empty($_POST['delete'])) && !empty($_POST['mass'])) {
    $report = new SavedReport();
    if(isset($_POST['Delete'])) {
        foreach($_POST['mass'] as $id) {
            $report->retrieve($id);
            if($report->ACLAccess('Delete')){
                $report->mark_deleted($id);
            }
        }
    }
    elseif(!empty($_POST['addtofavorites']) && $_POST['addtofavorites']) {
        $current_favorites = $current_user->getPreference('favorites', 'Reports');
        if(empty($current_favorites)) $current_favorites = array();
        foreach($_POST['mass'] as $id) {
            $current_favorites[$id] = true;
        }
        $current_user->setPreference('favorites', $current_favorites, 0, 'Reports');
        $favoritesText = '<span style="color: red">' . count($_POST['mass']) . $mod_strings['LBL_ADDED_FAVORITES'] . '</span>';
    }
    elseif(!empty($_POST['removefromfavorites']) && $_POST['removefromfavorites']) {
        $current_favorites = $current_user->getPreference('favorites', 'Reports');
        if(empty($current_favorites)) $current_favorites = array();
        foreach($_POST['mass'] as $id) {
            if(isset($current_favorites[$id]))
                unset($current_favorites[$id]);
        }
        $current_user->setPreference('favorites', $current_favorites, 0, 'Reports');
	    if(is_array($current_favorites) && !empty($current_favorites))
	        array_push($where_clauses, 'saved_reports.id IN (\'' . implode("','", array_keys($current_favorites)) . '\')');
	    else {
	        array_push($where_clauses, 'saved_reports.id IN (\'-1\')');
	    }        
        $favoritesText = '<span style="color: red">' . count($_POST['mass']) . $mod_strings['LBL_REMOVED_FAVORITES'] . '</span>';
    }
    
}

if(!empty($_REQUEST['orderBy'])) {
    if(trim($_REQUEST['orderBy']) == 'REPORT_TYPE_TRANS'){
        $_REQUEST['orderBy'] = 'REPORT_TYPE'; 
    }elseif(trim($_REQUEST['orderBy']) == 'TEAM_NAME'){
        $_REQUEST['orderBy'] = 'TEAM_ID'; 
    }elseif(trim($_REQUEST['orderBy']) == 'ASSIGNED_USER_NAME'){
        $_REQUEST['orderBy'] = 'ASSIGNED_USER_ID'; 
    }
    $params['orderBy'] = $_REQUEST['orderBy'];
    $params['overrideOrder'] = true;
    if(!empty($_REQUEST['sortOrder'])) $params['sortOrder'] = $_REQUEST['sortOrder'];
}

$lv->quickViewLinks = false;

echo $favoritesText;

$params['custom_select'] = ', report_schedules.id as schedule_id, report_schedules.active as active';
$params['custom_from'] = " LEFT JOIN report_schedules ON saved_reports.id = report_schedules.report_id AND report_schedules.user_id = '{$current_user->id}' AND report_schedules.deleted = 0 ";

$lv->setup($savedReportsSeed, 'include/ListView/ListViewGeneric.tpl', implode(' AND ', $where_clauses), $params);

// display
if(empty($_REQUEST['favorite'])) { // display search form for non-favorite views
	// start display
	// which tab of search form to display
    echo get_form_header($mod_strings['LBL_SEARCH_FORM_TITLE'], "", false);
    $lv->displayEndTpl = 'modules/Reports/tpls/MassUpdate.tpl';

}
else { // display different ending (with remove from my favorites button);
    $lv->displayEndTpl = 'modules/Reports/tpls/FavoritesEnd.tpl';
}

echo $lv->display();

$savedSearch = new SavedSearch();
$json = getJSONobj();
// fills in saved views select box on shortcut menu
$savedSearchSelects = $json->encode(array($GLOBALS['app_strings']['LBL_SAVED_SEARCH_SHORTCUT'] . '<br>' . $savedSearch->getSelect('Reports')));
$str = "<script>
YAHOO.util.Event.addListener(window, 'load', SUGAR.util.fillShortcuts, $savedSearchSelects);
</script>";
echo $str;
echo <<<EOQ
<script>
function schedulePOPUP(id){
            window.open("index.php?module=Reports&action=add_schedule&to_pdf=true&id=" + id ,"test","width=400,height=250,resizable=1,scrollbars=1")
}
</script>
EOQ;
?>
