<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Professional Subscription
 * Agreement ("License") which can be viewed at
 * http://www.sugarcrm.com/crm/products/sugar-professional-eula.html
 * By installing or using this file, You have unconditionally agreed to the
 * terms and conditions of the License, and You may not use this file except in
 * compliance with the License.  Under the terms of the license, You shall not,
 * among other things: 1) sublicense, resell, rent, lease, redistribute, assign
 * or otherwise transfer Your rights to the Software, and 2) use the Software
 * for timesharing or service bureau purposes such as hosting the Software for
 * commercial gain and/or for the benefit of a third party.  Use of the Software
 * may be subject to applicable fees and any use of the Software without first
 * paying applicable fees is strictly prohibited.  You do not have the right to
 * remove SugarCRM copyrights from the source code or user interface.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *  (i) the "Powered by SugarCRM" logo and
 *  (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * Your Warranty, Limitations of liability and Indemnity are expressly stated
 * in the License.  Please refer to the License for the specific language
 * governing these rights and limitations under the License.  Portions created
 * by SugarCRM are Copyright (C) 2004-2007 SugarCRM, Inc.; All Rights Reserved.
 ********************************************************************************/
require_once('modules/Reports/config.php');


class Report
{
	var $result;
	var $summary_result;
	var $total_result;
	var $row_start = 0;
	var $row_end = 0;
	var $row_count = 0;
	var $summary_row_start = 0;
	var $summary_row_end = 0;
	var $summary_row_count = 0;
	var $current_summary_row_count = 0;
	var $requested_fields_map = array();
	var $group_fields_map = array();
	var $summary_fields_map = array();
    var $full_table_list = array();
    var $full_table_beans = array();
	var $where;
	var $order_by;
	var $order_by_arr = array();
	var $summary_order_by_arr = array();
	var $order_by_special;
	var $group_by;
	var $group_order_by = '';
    var $module = 'Accounts';
	var $focus;
	var $currency_symbol;
	var $currency_obj;
	var $name;
	var $select_fields = array();
	var $summary_select_fields = array();
	var $total_select_fields = array();
	var $report_def = array();
	var $do_export = false;
	var $report_type = 'tabular';
	var $show_columns = false;
	var $enable_paging = true;

	var $query_list = array();
	var $query = '';
	var $summary_query = '';
	var $total_query = '';

	var $module_dir = 'Reports';
	var $time_date_obj = null;
	var $is_saved_report = false;
	var $saved_report_id = '';
	var $saved_report = null;

	var $dbManager;

	var $all_fields = array();
	var $relationships = array();
	var $loaded_links = array();
	var $selected_loaded_links = array();
	var $selected_loaded_custom_links = array();
	var $layout_manager = null;
	var $plain_text_output = false;
    var $obj_array = array();//array to store the object reference in get_next_row()
	var $default_report_def_str = '{"report_type":"tabular","display_columns":[],"summary_columns":[],"order_by":[{"name":"","sort_dir":""}],"filters_def":[],"group_defs":[],"links_def":[],"module":"Accounts","chart_type":"hBarF","chart_description":""}';

	var $select_already_defined_hash = array();

  var $do_chart = true;
  var $chart_header_row = array();
  var $chart_rows = array();
  var $chart_type = 'vBarF';
  var $table_name = 'saved_reports';
  var $chart_description = '';
  var $chart_group_position = array();
	var $chart_numerical_position = 0;
  var $group_header;
  var $group_column_is_invisible = 0;
  var $chart_total_header_row = array();


	function Report($report_def_str='') {
		global $current_user, $current_language;
		if(!isset($current_user) || empty($current_user)) {
			require_once('modules/Users/User.php');
			$current_user = new User();
			$current_user->retrieve('1');
		}

		if ($_REQUEST['module'] == 'Reports'){
			Report::cache_modules_def_js();
		}

		$mod_strings = return_module_language($current_language, 'Reports'); 
		
		$this->report_max = (!empty($GLOBALS['sugar_config']['list_report_max_per_page']))?$GLOBALS['sugar_config']['list_report_max_per_page']:100;
		$this->report_offset = (!empty($_REQUEST['report_offset']))?$_REQUEST['report_offset']:0;
		if($this->report_offset < 0)$this->report_offset = 0;
		$this->time_date_obj =  new TimeDate();
		$this->name = $mod_strings['LBL_UNTITLED'];
		$this->db = PearDatabase::getInstance();
		$this->dbManager = DBManagerFactory::getInstance();
		if ( Report::is_old_content($report_def_str))
		{
			sugar_die('this report was created with an older version of reports. please upgrade');
		}

		$json = getJSONobj();
		if ( empty($report_def_str))
		{
			$this->report_def_str = $this->default_report_def_str;
			$this->report_def = $json->decode($this->report_def_str);
		} else {
			$this->report_def_str = $report_def_str;
			$this->report_def = $json->decode($this->report_def_str);
		}

		if ( ! empty($this->report_def['report_name']))
		{
			$this->name = $this->report_def['report_name'];
		}
		if ( ! empty($this->report_def['module']))
		{
			$this->module = $this->report_def['module'];
		}
		if(! empty($this->report_def['report_type']))
		{
			$this->report_type = $this->report_def['report_type'];
		}
			if (! empty($this->report_def['display_columns']) && count($this->report_def['display_columns']) > 0 && $this->report_type == 'summary')
			{
				$this->show_columns = true;
			}
		if ( ! empty($this->report_def['chart_type']))
		{
			$this->chart_type = $this->report_def['chart_type'];
		} else
		{
			$this->report_def['chart_type'] = 'none';
			$this->chart_type = $this->report_def['chart_type'];
		}
		if ( ! empty($this->report_def['chart_description']))
		{
			$this->chart_description = $this->report_def['chart_description'];
		}

        if ( ! empty($this->report_def['full_table_list']) )
        {
            $this->full_table_list = $this->report_def['full_table_list'];
        }
        else
        {
            $this->full_table_list['self']['value'] = $this->module;
            $this->full_table_list['self']['module'] = $this->module;
            $this->full_table_list['self']['label'] = $this->module;
            $this->full_table_list['self']['parent'] = '';
            $this->full_table_list['self']['children'] = array();
        }

        global $beanList;
        global $beanFiles;
        // Dynamically convert the old reports (upgrade)
        if ( ! empty($this->report_def['links_def']) )
        {
            $tmpBeanName = $beanList[$this->full_table_list['self']['module']];

            require_once($beanFiles[$tmpBeanName]);

            $tmpBean = new $tmpBeanName();
            $linked_fields = $tmpBean->get_linked_fields();

//          echo("<pre>");
//          print_r($linked_fields);
//          die();

            foreach($this->report_def['links_def'] as $old_link )
            {
                // Make sure that this table is actually used.
                $is_used = false;
                $check_list = array('display_columns','filters_def','summary_columns','group_defs','order_by');
                foreach($check_list as $def_to_check )
                {
                    if (empty($this->report_def[$def_to_check]) || !is_array($this->report_def[$def_to_check]) )
                    {
                        // Skip this report_def, it's empty
                        continue;
                    }
                    foreach($this->report_def[$def_to_check] as $col )
                    {
                        if ( $col['table_key'] == $old_link )
                        {
                            $is_used = true;
                            break;
                        }
                    }
                    if ( $is_used == true )
                    {
                        break;
                    }
                }

                if ( ! $is_used )
                {
                    // This table is not actually used
                    continue;
                }

                $tmpBean->load_relationship($old_link);
                $relationship = $tmpBean->$old_link->_relationship;

                $this->full_table_list[$old_link]['value'] = $old_link;
                $this->full_table_list[$old_link]['label'] = translate($linked_fields[$old_link]['vname']);
                $this->full_table_list[$old_link]['link_def']['relationship_name'] = $linked_fields[$old_link]['relationship'];
                $this->full_table_list[$old_link]['link_def']['name'] = $linked_fields[$old_link]['relationship'];
                $this->full_table_list[$old_link]['link_def']['link_type'] = $relationship->relationship_type;
                $this->full_table_list[$old_link]['link_def']['label'] = $this->full_table_list[$old_link]['label'];
                $this->full_table_list[$old_link]['link_def']['table_key'] = $old_link;

                $this->full_table_list[$old_link]['parent'] = 'self';
                $this->full_table_list[$old_link]['children'] = array();

                if ( isset($this->report_def['link_joins']) && is_array($this->report_def['link_joins']) && in_array($old_link,$this->report_def['link_joins']) || $relationship->relationship_type == 'one-to-many' )
                {
                    $this->full_table_list[$old_link]['optional'] = 1;
                }
                else
                {
                    $this->full_table_list[$old_link]['optional'] = 0;
                }


                //Update the parent with one of us children
                $this->full_table_list['self']['children'][$old_link] = $old_link;

                $tmpBean_is_left = $tmpBean->$old_link->_get_bean_position();
                if ( $tmpBean_is_left == true )
                {
                    $this->full_table_list[$old_link]['link_def']['bean_is_lhs'] = 1;
                    $this->full_table_list[$old_link]['module'] = translate($relationship->rhs_module);
                }
                else
                {
                    $this->full_table_list[$old_link]['link_def']['bean_is_lhs'] = 0;
                    $this->full_table_list[$old_link]['module'] = translate($relationship->lhs_module);
                }
            }

            $this->report_def['full_table_list'] = $this->full_table_list;
            unset($this->report_def['links_def']);
            unset($this->report_def['link_joins']);
            unset($tmpBean);

            // Re-encode the report definition
            $this->report_def_str = $json->encode($this->report_def);
        }


//      echo("<pre>DEBUG:\n".print_r($this->report_def,true)."</pre>");
//      die();

        // Load all the necessary beans, and populate the full_table_beans array
        foreach ( $this->full_table_list as $table_key => $table_data )
        {
            // Set this to a reasonable default
            $beanLabel = 'Accounts';
            if ( isset($table_data['module']) )
            {
                // We will take this value, because 'self' doesn't typically pass the label through
                $beanLabel = $table_data['module'];
            }

            if ( empty($beanList[$beanLabel]) )
            {
                die("beanList[".$beanLabel."] is empty!<br>\n");
            }
            $beanName = $beanList[$beanLabel];
            // Store this for later, in case we want it.
            $this->full_table_list[$table_key]['bean_label'] = $beanLabel;
            $this->full_table_list[$table_key]['bean_name'] = $beanName;

            require_once($beanFiles[$beanName]);

            $this->full_bean_list[$table_key] = new $beanName();

            if ( $table_key == 'self' )
            {
                // Alias that to $this->focus, because it is very commonly used
                $this->focus = &$this->full_bean_list[$table_key];
            }
        }
        //$this->linked_fields = $this->focus->get_linked_fields();
        //  $this->_check_user_permissions();

		$this->_load_all_fields();
		$this->_load_currency();

		require_once('include/generic/LayoutManager.php');
		global $image_path;
		if ( $this->layout_manager == null)
		{
			$this->layout_manager = new LayoutManager();
			$this->layout_manager->default_widget_name = 'ReportField';
			$this->layout_manager->setAttribute('image_path',$image_path);
			$this->layout_manager->setAttributePtr('reporter',$this);
		}


	}

	// gets rid of fields that user shouldn't see
	// assumes all_fields only contains viewable fields
	function clean_report_def()
	{
		$fields = array('display_columns','summary_columns','order_by','filters_def','group_defs');
		foreach($fields as $field)
		{
			if ( count($this->report_def[$field]))
			{
				continue;
			}
		for($i = 0; $i < count($this->report_def[$field] ) ; $i++)
		{
			$def = $this->report_def[$field][$i];
			if ( empty($def['table_key']) && empty($def['name']))
			{
				continue;
			}

			$key = $this->_get_full_key($def);
			if ( empty($this->all_fields[$key]))
			{
				unset($def);
			}
		}
		}

		global $report_modules;
		if ( empty($report_modules[$this->module]))
		{
			sugar_die("you are not allowed to report on this module:".$this->module);
		}
	}

// make sure this user can report on this module

function _check_user_permissions()
{
	global $current_user;
	if(isset($current_user))
	{
        require_once('modules/MySettings/TabController.php');
        $tabs = new TabController();
        $tabArray = $tabs->get_user_tabs($current_user);

        $moduleMap = array();

        foreach($tabArray as $user_module){

                $moduleMap[$user_module] = 1;

        }

        if( isset($moduleMap["Calendar"]) || isset($moduleMap["Activities"])){
                //also include reports that are in the following modules
                $moduleMap['Tasks'] = 1;
                $moduleMap['Calls'] = 1;
                $moduleMap['Meetings'] = 1;
                $moduleMap['Notes'] = 1;
        }
        if( isset($moduleMap["Project"]) )
			{
                $moduleMap['ProjectTask'] = 1;
			}
        if ( empty($moduleMap[$this->module_dir]))
        {
                die ("you do not have access to report this module");
        }

	} else
	{
               die ("you shouldn't be here");
	}
}

	function isVisibleModule($related_module)
	{
		global $report_modules;
		if (empty($report_modules[$related_module]))
		{
			return false;
		}
		return true;
	}

	function _load_all_fields(){
		foreach( $this->full_table_list as $table_key => $table_data ) {
        	foreach ( $this->full_bean_list[$table_key]->field_defs as $field_def )
            {
            	$field_def['module'] = $this->full_table_list[$table_key]['bean_label'];
                $field_def['real_table'] = $this->full_bean_list[$table_key]->table_name;
				if ( ! empty($field_def['source']) && $field_def['source'] == 'custom_fields' ) {
                    $field_def['real_table'] .= '_cstm';
                }
                $this->all_fields[$table_key.':'.$field_def['name']] = $field_def;
            }
        }
    }



	function _load_currency()
	{

		require_once('modules/Currencies/Currency.php');
		$this->currency_obj = new Currency();
		$this->currency_symbol = '$';
		global $current_user;

		if($current_user->getPreference('currency') )
		{
			$this->currency_obj->retrieve($current_user->getPreference('currency'));
			$this->currency_symbol = $this->currency_obj->symbol;
		}
		else
		{
			$this->currency_obj->retrieve('-99');
			$this->currency_symbol = $this->currency_obj->symbol;
		}
	}

	function clear_results()
	{
		$this->where = null;
		$this->order_by = null;
		$this->group_by = null;
		$this->select_fields = array();
		$this->query = null;
		$this->result = null;
		$this->summary_result = null;
		$this->total_result = null;
		$this->row_count = 0;
		$this->row_end = 0;
		$this->summary_row_count = 0;
		$this->summary_row_end = 0;
	}

	function run_summary_combo_query($run_main_query= true)
	{
		if($run_main_query)$this->run_query();

		$this->run_summary_query();
		if ($this->has_summary_columns())
		{
			$this->run_total_query();
		}
	}

	function run_summary_child_query(){
		$this->clear_group_by();
		$this->create_order_by();
		$this->create_select();
		// false means don't
		$this->create_where();
		$this->create_group_by(false);
		$this->create_from();
		$this->create_query();

		 if(empty($this->child_filter_by)){
			return false;
		}

		$query = $this->query;
		if(!empty($this->group_order_by)){
			$queries = explode( "ORDER BY", $query);
			$query = $queries[0] . " AND  $this->child_filter= '$this->child_filter_by'";
		}
		$query_name = $this->child_filter;
		$this->$query_name = $query;
		$this->create_order_by();
		if(!empty($this->order_by_arr)){
			$this->$query_name .= " ORDER BY ". implode( ',', $this->order_by_arr);
		}
		$this->execute_query($query_name,'child_result', '', '','' );

		return 'child_result';
	}



	function create_summary_select()
	{
		$this->create_select('summary_columns','summary_select_fields');
	}

	function create_total_select()
	{
		$this->create_select('summary_columns','total_select_fields');
	}

	function create_total_query()
	{
		$this->create_query('total_query','total_select_fields');
	}

	function create_summary_query()
	{
		$this->create_query('summary_query','summary_select_fields');
	}


	function run_summary_query()
	{
		$this->create_group_by();
		$this->create_order_by();
		$this->create_summary_select();
		$this->create_where();
		$this->create_from();
		$this->create_summary_query();
		$this->execute_summary_query();

	}

	function run_total_query()
	{
		$this->create_order_by();
		$this->create_total_select();
		$this->create_where();
		$this->create_from();
		$this->create_total_query();
		$this->execute_total_query();
	}

	function run_query($do_group_by=false)
	{
		$this->clear_group_by();
		$this->create_order_by();
		$this->create_select();
		// false means don't
		$this->create_where();
		$this->create_group_by(false);
		$this->create_from();
		$this->create_query();
		$limit = false;
		if($this->report_type == 'tabular' && $this->enable_paging){
			$this->total_count = $this->execute_count_query();
			$limit = true;
		}
		$this->execute_query('query', 'result', 'row_count', 'row_start', 'row_end', $limit);

	}
	function execute_count_query($query_name='query'){

		$query = $this->$query_name;
		$queries = explode('FROM',$query, 2);
		if(count($queries) == 1){
			$queries = explode('from',$query, 2);
		}
		if(count($queries) == 2){
			$queries = explode('ORDER BY', $queries[1]);
				$result = $GLOBALS['db']->query("SELECT count(*) as total_count FROM ". $queries[0]);

			if( $row =  $GLOBALS['db']->fetchByAssoc($result)){
				return $row['total_count'];
			}

		}
		return 0;
	}
	function execute_total_query()
	{
		$this->execute_query('total_query',
				'total_result',
				'',
				'',
				'');
	}


	function execute_summary_query()
	{
		$this->execute_query('summary_query',
				'summary_result',
				'summary_row_count',
				'summary_row_start',
				'summary_row_end');
	}


	function execute_query($query_name='query',
				$result_name='result',
				$row_count_name='row_count',
				$row_start_name='row_start',
				$row_end_name='row_end',
				$limit=false)
	{
/*
print "<BR>QUERY:";
print $this->$query_name;
print "<BR>";
print "<BR>";
*/
	if($limit){
		$start_offset = $this->report_offset;
		if ($this->db->dbType == 'oci8'){
			if($start_offset > 0)$start_offset++;
		}
		$this->$result_name = $this->db->limitQuery($this->$query_name,$start_offset , $this->report_max,true,
				"Error executing query ");
	}else{
		$this->$result_name = $this->db->query(
				$this->$query_name,
				true,
				"Error executing query ");
	}
		if (!empty($row_count_name) && empty($this->$row_count_name))
		{
			if ($this->db->dbType == 'oci8'){
				$this->$row_count_name = $this->report_offset;
				$this->$row_end_name = $this->report_max;

				if($limit && $this->total_count < $this->$row_end_name + $this->$row_count_name){
					$this->$row_end_name = $this->total_count - $this->$row_count_name;
				}
			}else{
				$this->$row_count_name =  $this->db->getRowCount($this->$result_name);
				$this->$row_end_name =  $this->$row_count_name;
			}
			if ($this->$row_count_name > 0)
			{
				$this->$row_start_name =  1;
			}
		}
	}


	function getTableFromField(&$layout_def)
	{

		$field = $this->getFieldDefFromLayoutDef($layout_def);

		$custom_table = '';
		if ( ! empty($field['table']))
		{
      // truncate because oracle doesn't like long alias names
      $custom_table = substr($field['table'],0,8);
			$custom_table .= '_';
		}

		if ( empty($layout_def['table_key']))
		{
		  $linked_field = 'self';
		} else {
		  $linked_field =$layout_def['table_key'];
		}

		if ($linked_field != 'self')
		{
			$field_table = $custom_table .$this->getRelatedAliasName($linked_field);
		} else {
			$field_table = $custom_table .$this->focus->table_name;
		}
		return $field_table;
	}


	// used mainly to register the join if this column needs it
  function register_field_for_query(&$layout_def)
	{
			$layout_def['table_alias'] = $this->getTableFromField($layout_def);
			$field_def = $this->getFieldDefFromLayoutDef($layout_def);
			
			if ( ! empty($field_def['source']) && $field_def['source'] == 'custom_fields' && ! empty($field_def['real_table']))
			{
				$layout_def['table_alias'] .= '_cstm';
				
		      $params = array(
          'join_table_alias'=>$layout_def['table_alias'],
          
          'base_table'=>$this->focus->table_name);

          if ( $layout_def['table_key'] != 'self' ) 
          {
            $params['base_table'] =  $this->getRelatedAliasName($layout_def['table_key']);
          }

				$this->selected_loaded_custom_links[$field_def['real_table']] = $params;
				
			}

			$layout_def['column_key'] = $this->_get_full_key($layout_def);

			if (!empty($layout_def['name'])&& ($layout_def['name'] == 'weighted_amount' ||   $layout_def['name'] == 'weighted_sum'))
			{
				$field_def['type'] = 'currency';
			}
			$layout_def['type'] = $field_def['type'];
			if (isset($field_def['rel_field'])) {
				$layout_def['rel_field'] = $field_def['rel_field'];		
			}
//print "REGISTER:".$layout_def['name'].":". $layout_def['type']."<BR>";
	}

	function create_where()
	{
		$this->layout_manager->setAttribute('context', 'Filter');
		$where_arr = array();


		for($i=0; $i < count($this->report_def['filters_def']) ; $i++)
		{
			$filter_def = $this->report_def['filters_def'][$i];

			$this->register_field_for_query($filter_def);

		 	 $select_piece = $this->layout_manager->widgetQuery($filter_def);
			array_push($where_arr,$select_piece);
		}
        if(!empty($this->report_def['filters_combiner']) && $this->report_def['filters_combiner'] == 'OR') {
            $combiner = 'OR';
        }
        else {
            $combiner = 'AND';
        }
		$this->where = implode(" $combiner ",$where_arr);
	}

	function getFieldDefFromLayoutDef(&$layout_def)
	{
		$field = null;
    if ( ! empty($this->all_fields[$this->_get_full_key($layout_def)]))
		{
    	$field = $this->all_fields[$this->_get_full_key($layout_def)];
		}
		return $field;
	}

	function _get_full_key(&$layout_def)
	{
		if ( empty($layout_def['table_key']))
		{
			$table_key = 'self';
		} else {
			$table_key = $layout_def['table_key'];
		}
        if(empty($layout_def['name']))
            return $table_key;

        // workaround for Bug Number: 7635
        // column_key returns as             [column_key] => self:weighted_amount:weighted_amount
        if($layout_def['name'] == 'weighted_sum' || $layout_def['name'] == 'weighted_amount') {
            return 'self';
        }
		return $table_key.":".$layout_def['name'];
	}

	function parseLinkedField($fieldname)
	{
		preg_match('/^(\w+):/',$fieldname,$match);
                return  $match[1];
	}

	function getRelatedAliasName($linked_field)
	{
        return str_replace('link_','l',
                           str_replace('self_','',$linked_field));
	}

	function getRelatedLinkAliasName($linked_field)
	{
        return str_replace('link_','l',
                           str_replace('self_','',$linked_field)).'_l';
	}

	function has_summary_columns()
	{
	$key='summary_columns';


	$got_summary = 0;
	  foreach($this->report_def[$key] as $index=>$display_column)
          {

                        if ( $display_column['name'] == 'count')
                        {
                                $got_summary = 1;
                        } else if ( ! empty($display_column['group_function'] ))
                        {
                                $got_summary = 1;
                        }
	 }
	 return $got_summary;
	}

	function is_group_column(&$display_column)
  {
		$qualifier = '';

		if ( ! empty($display_column['column_function']))
		{
			$qualifier = $display_column['column_function'];
		}


		for( $i = 0;$i < count($this->report_def['group_defs']); $i++)
		{
			$def_qualifier = '';
			if ( ! empty($this->report_def['group_defs'][$i]['qualifier']))
			{
				$def_qualifier = $this->report_def['group_defs'][$i]['qualifier'];
			}

			if ( $this->report_def['group_defs'][$i]['table_key']."_".$this->report_def['group_defs'][$i]['name']."_".$def_qualifier ==
					$display_column['table_key']."_".$display_column['name']."_".$qualifier)
			{
				return 1;

			}

		}
		return 0;
  }

    function create_select($key = 'display_columns', $field_list_name = 'select_fields')
    {
        $this->layout_manager->setAttribute('context', 'Select');
        $got_count = 0;
        $got_join = array();
        foreach($this->report_def[$key] as $index=>$display_column) {
            if($display_column['name'] == 'count') {
                $select_piece = 'COUNT(*) count';
                $got_count = 1;
            }
            else {
                if($field_list_name=='total_select_fields' && empty($display_column['group_function'])) {
                    continue;
                }
                $this->register_field_for_query($display_column);

                // this hack is so that the id field for every table is always selected
                if(empty($display_column['table_key'])) {
                    sugar_die('table_key doesnt exist for '.$display_column['name']);
                }

                if(empty($got_join[$display_column['table_key']])) {
                    $id_column = array();
                    $got_join[$display_column['table_key']] = 1;

                    if(!empty($display_column['column_key']) && !empty($this->all_fields[$display_column['column_key']]) && !empty($this->all_fields[$display_column['column_key']]['custom_type'])) {
                        $do_id = 0;
                    }
                    else {
                        $do_id = 1;
                    }

                    if(($field_list_name!='total_select_fields' && $field_list_name != 'summary_select_fields') && $do_id) {
						if (preg_match('/_cstm/', $display_column['table_alias']) > 0)
                        	$id_column['name'] = 'id_c';
                        else
                        	$id_column['name'] = 'id';
                        $id_column['type'] = 'id';
                        $id_column['table_key'] = $display_column['table_key'];
                        $id_column['table_alias'] = $display_column['table_alias'];
                        $id_column['column_key'] = $id_column['table_key'].':'.$id_column['name'];
                        $select_piece = $this->layout_manager->widgetQuery($id_column);
                        array_push($this->$field_list_name,$select_piece);
                    }
                }
                $select_piece = $this->layout_manager->widgetQuery($display_column);
            }

            if(!$this->select_already_defined($select_piece,$field_list_name)) {
                array_push($this->$field_list_name,$select_piece);
            }
        }

        // 'register' the joins for the other column defs since we need to join all for summary to work.. else the count and maybe other group functions won't work.
        if ( $key == 'display_columns') {
            $key = 'summary_columns';
        }
        else {
            $key = 'display_columns';
        }

        if ($got_count == 0 && $field_list_name=='summary_select_fields') {
            array_push($this->$field_list_name,'count(*) count');
        }
    } // end create_select

	function clear_group_by()
	{
		$this->group_by='';
	}

	function create_order_by()
	{

		$this->layout_manager->setAttribute('context', 'OrderBy');
		$this->order_by='';
		$this->order_by_arr= array();
		$this->summary_order_by_arr= array();
		if(!empty($this->report_def['order_by'][0]))
		{
			$order_by = $this->report_def['order_by'][0];

			$this->register_field_for_query($order_by);

			array_push($this->order_by_arr, $this->layout_manager->widgetQuery($order_by));

		}
		$this->summary_order_by='';
		//$this->summary_order_by_arr= array();
		if(!empty($this->report_def['summary_order_by'][0]))
		{
			$summary_order_by = $this->report_def['summary_order_by'][0];

			$this->register_field_for_query($summary_order_by);

			array_push($this->summary_order_by_arr,$this->layout_manager->widgetQuery($summary_order_by));
        }


	}

	function select_already_defined($select,$which='select_fields')
	{
		if ( empty($this->select_already_defined_hash[$which]))
		{
			$this->select_already_defined_hash[$which] = array();
		}

		if ( empty($this->select_already_defined_hash[$which][$select]))
    {
		 $this->select_already_defined_hash[$which][$select] = 1;
			return false;
    }
		return true;

	}

    function create_group_by($register_group_by = true)
    {

        if(!empty($this->report_def['group_defs'])&&is_array($this->report_def['group_defs']))
        {
            $this->group_by_arr = array();
            $this->group_order_by_arr = array();
            // $group_column = $this->report_def['group_defs'][0];
            foreach ( $this->report_def['group_defs'] as $group_column )
        {
                $this->layout_manager->setAttribute('context', 'GroupBy');
            $this->register_field_for_query($group_column);
            $group_by = $this->layout_manager->widgetQuery($group_column);
            $this->layout_manager->setAttribute('context', 'OrderBy');
            $order_by = $this->layout_manager->widgetQuery($group_column);
            $this->layout_manager->setAttribute('context', 'Select');

            if (! empty($group_column['qualifier']))
            {
                $group_column['column_function'] = $group_column['qualifier'];
            }

          $select = $this->layout_manager->widgetQuery($group_column);

            if (! $this->select_already_defined($select,'select_fields'))
            {
                array_push($this->select_fields,$select);
            }

            if (! $this->select_already_defined($select,'summary_select_fields'))
      {
                array_push($this->summary_select_fields,$select);
      }

                if (! empty($register_group_by))
            {
                    $this->group_by_arr[] = $group_by;
                    //$this->child_filter_arr[] = array('column' => $group_column['table_alias'] . '.' . $group_column['name'],
                    //                                'name' => $group_column['table_alias'] . '_' . $group_column['name']);
                }
                //$this->group_order_by_arr[] = $order_by;
                // Changed the sort order, so it would sort by the initial options first
                array_unshift($this->group_order_by_arr,$order_by);
            }
            //$this->group_by = $group_by;
            //$this->child_filter = $group_column['table_alias'] . '.' . $group_column['name'];
            //$this->child_filter_name = $group_column['table_alias'] . '_' . $group_column['name'];
        }
    }

    function create_from()
    {
            global $beanFiles;

            foreach($this->full_table_list as $linkKey => $def) {
                if($linkKey != 'self' && isset($def['link_def'])) {
                    $params = array('join_table_alias'=> $this->getRelatedAliasName($def['link_def']['table_key']),
                                    'join_table_link_alias'=> $this->getRelatedLinkAliasName($def['link_def']['table_key']));

                    $this->full_table_list[$def['link_def']['table_key']]['params'] = $params;
                    // Be sure to load in the parents

                    $curr_parent = $this->full_table_list[$def['link_def']['table_key']]['parent'];

                    while($curr_parent != '' && $curr_parent != 'self' && ! isset($this->full_table_list[$curr_parent]['params'])) {
                        // The parent is not loaded.
                        $params = array('join_table_alias'=> $this->getRelatedAliasName($curr_parent),
                                        'join_table_link_alias'=> $this->getRelatedLinkAliasName($curr_parent));
                        $this->full_table_list[$curr_parent]['params'] = $params;
                        // Find out if my parent's parent is loaded or not
                        $curr_parent = $this->full_table_list[$curr_parent]['parent'];
                    }
                }
            }

            // Setup some data structures so they can be used later
            $this->full_table_list['self']['params']['join_table_alias'] = $this->focus->table_name;
            $this->full_table_list['self']['params']['join_table_link_alias'] = $this->focus->table_name."_l";

            $this->from = "\nFROM ".$this->focus->table_name."\n";

            $this->focus->add_team_security_where_clause($this->from,'','INNER');
            $jtcount=0;
            foreach ( $this->full_table_list as $table_key => $table_def)
            {
                // Increment the join table count
                $jtcount++;

                if ( $table_key == 'self') continue; // self table, no join required
                if(empty($table_def['params'])) { // always join on tables!
                        $table_def['params'] = array(
                          'join_table_alias'=> $this->getRelatedAliasName($table_key),
                          'join_table_link_alias'=> $this->getRelatedLinkAliasName($table_key),
                        );
                }
                $params = $table_def['params'];
                if(!isset($params['join_table_alias'])) {
                    $params['join_table_alias'] = "jt".$jtcount;
                }


                if(!isset($params['join_table_link_alias'])) {
                    $params['join_table_link_alias'] = "jtl".$jtcount;
                }
                $team_join_type = 'INNER';
                if ( isset($table_def['optional']) && $table_def['optional'] == 1 )
            {
                    $params['join_type'] = 'LEFT JOIN ';
                    $team_join_type = 'LEFT';
                }
                if ( is_object($this->full_bean_list[$table_def['parent']]) )
                {
                    // We need to find the exact link name that it is expecting.
                    $rel_name = $table_def['link_def']['relationship_name'];
                    $linked_fields = $this->full_bean_list[$table_def['parent']]->get_linked_fields();
                    $link_name = '';
                    foreach ( $linked_fields as $tmp_link_name => $link )
                    {
                        if ( $link['relationship'] == $rel_name )
                        {
                            $link_name = $tmp_link_name;
                        }
                    }
                    if ( $link_name != '' )
                    {
                        if ( !isset($params['bean_is_lhs']) || $params['bean_is_lhs'] != 1 )
                        {
                            $params['right_join_table_alias'] = $this->full_table_list[$table_def['parent']]['params']['join_table_alias'];
                            $params['right_join_table_link_alias'] = $this->full_table_list[$table_def['parent']]['params']['join_table_link_alias'];
                        }
                        $params['left_join_table_alias'] = $this->full_table_list[$table_def['parent']]['params']['join_table_alias'];
                        $params['left_join_table_link_alias'] = $this->full_table_list[$table_def['parent']]['params']['join_table_link_alias'];

                        $this->full_bean_list[$table_def['parent']]->load_relationships();
                        $params['primary_table_name'] = $this->full_table_list[$table_def['parent']]['params']['join_table_alias'];
                        $this->from .= $this->full_bean_list[$table_def['parent']]->$link_name->getJoin($params);
                        //echo("<br>Join for $link_name (parent: ".$table_def['parent']."):<br>".$this->from."<pre>".print_r($params,true)."</pre>");
                    }
                    else
                    {
                        die("Could not find link name, searching through for: ".$rel_name);
                    }
                }
                else
            {
                    die("table_def[parent] is not an object! (".$table_def['parent'].")<br>");
                }
                // Do not add team security on modules that opt out of row level security
                require_once($beanFiles[$table_def['bean_name']]);
                $focus = new $table_def['bean_name']();

                if(!$focus->disable_row_level_security) {
                    $this->focus->add_team_security_where_clause($this->from,$params['join_table_alias'],$team_join_type);
                }
            }

            foreach ( $this->selected_loaded_custom_links as $custom_table=>$params)
            {
        // "$this->focus->table_name" will need to change once we allow for all custom fields to be reported on
                $this->from .= "LEFT JOIN ". $custom_table." ".$params['join_table_alias']." ON ".$params['base_table'].".id = ".$params['join_table_alias'].".id_c\n";
            }

            //echo("<h1>The From:</h1>".$this->from."<br>");
    }

    function create_query($query_name='query',$field_list_name='select_fields')
    {

        $query = "SELECT ";

    // TODO: All this should be in sugarwidgetfield*.php
    if ( $this->db->dbType == 'mssql'){
        //make sure empty fields are returned as an empty string during concatenation, not a null
        //so for example, searching on an account with no first name name will return ' ' + 'smith' for the last name
        //instead of null + smith
        $field_list_name_array = $this->$field_list_name;
        $arrCount = count($field_list_name_array);
        $currCount = 0;

        //for each field
        while($currCount<$arrCount){
            $field = trim($field_list_name_array[$currCount]);
            //if it has a space, then it is aliased, let's process
            //to see if it has a period
            $has_space = strrpos($field, " ");
                    if($has_space){
                        $temp_field_name = substr($field,0,$has_space);
                        $has_period = strrpos($temp_field_name, ".");
						$aggregate_func = substr($temp_field_name, 0, 3);
						$is_aggregate = false;
						if ($aggregate_func == 'max' || $aggregate_func == 'min' || $aggregate_func == 'avg' || $aggregate_func == 'sum')
							$is_aggregate = true;
                        //has period, and is aliased, so wrap an "ISNULL function around it"
                        // get field type, and don't wrap numeric or date fields with ISNULL
                        $field_type = (empty($this->focus->field_name_map[substr($temp_field_name, $has_period + 1)]) ? '' : $this->focus->field_name_map[substr($temp_field_name, $has_period + 1)]['type']);
                        if($has_period && !$is_aggregate && $field_type != 'currency' && $field_type != 'float' && $field_type != 'decimal' && $field_type != 'int' && $field_type != 'date'){
                            $temp_field_alias  = substr($field,$has_space+1);
                            $field = "ISNULL(".$temp_field_name.",'') ".$temp_field_alias;
                            $field_list_name_array[$currCount] = "ISNULL(".$temp_field_name.",' ') ".$temp_field_alias;
                        }
                    }
                    $currCount = $currCount+1;
        }

       $this->$field_list_name = $field_list_name_array;

    }

        $query .= implode(",",$this->$field_list_name);

        $query .= $this->from ."\n";

        $where_auto = " " . $this->focus->table_name. ".deleted=0 \n";

        if(! empty($this->where))
                        $query .= " WHERE ($this->where) \nAND ".$where_auto;
        else
                        $query .= " WHERE ".$where_auto;

        if (! empty($this->group_order_by_arr) && is_array($this->group_order_by_arr) && $query_name != 'summary_query'  )
    {
            foreach ( $this->group_order_by_arr as $group_order_by )
  {
                array_unshift($this->order_by_arr, $group_order_by);
            }
        }
        else if (! empty($this->group_order_by_arr) && is_array($this->group_order_by_arr) && $query_name == 'summary_query'  && empty($this->summary_order_by_arr))
    {
            foreach ( $this->group_order_by_arr as $group_order_by )
  {
                array_unshift($this->summary_order_by_arr, $group_order_by);
            }
    }

        // if we are doing the details part of a summary query.. we need the details
    // to be sorted by the group by

    if(!empty($this->group_by_arr) && is_array($this->group_by_arr) && $query_name != 'total_query')
    {
            if ( $this->db->dbType == 'mssql'



                )
            {
                $query .= " GROUP BY ";
                foreach ( $this->group_by_arr as $group_by )
                {
                    $query .= " ".$group_by.",";
                }
                // Take out the extra comma from the end.
                $query = rtrim($query,',');
            }
            else
            {
                $query .= " GROUP BY ";
                foreach ( $this->group_by_arr as $group_by )
                {
                    $query .= " IFNULL(".$group_by.",''),";
                }
                // Take out the extra comma from the end.
                $query = rtrim($query,',');
            }
    }
    if ( $query_name == 'summary_query')
    {
      if(!empty($this->summary_order_by_arr))
      {
             if ($this->db->dbType == 'mssql'){
                $groupby = '';
                $ASC_DESC = '';
                    //set default order by
                    $summ_order_by_string = $this->group_by;
                    //process summary order by if not empty
                    if(!empty($this->summary_order_by_arr)){
                        //reset the summary order by string
                        $summ_order_by_string = "";
                        //parse each summary order by and create mssql friendly order by
                        foreach($this->summary_order_by_arr as $soba){
                            $summ_order_by = explode(",", $soba);
                            if (count($summ_order_by)>1){
                                //If more than one, then create string to use in conjunction
                                //with a charindex function.  This will make sure we can get
                                //the order list in the defined order
                                foreach($summ_order_by as $ob){
                                    if(empty($ASC_DESC)){$ASC_DESC = substr($ob,strrpos($ob," "));}
                                    if(empty($groupby)){$groupby = substr($ob,0,strrpos($ob,"="));}
                                    $ob = trim($ob);
                                    $beg_sing_pos = strpos($ob,"'");
                                    if($beg_sing_pos>0){
                                    $end_sing_pos = strrpos($ob,"'");
                                    $summ_order_by_string .= substr($ob,$beg_sing_pos+1,$end_sing_pos-$beg_sing_pos-1) ."``";
                                    }else{
                                        if(empty($order_by_string)) $order_by_string = '';
                                        $order_by_string .= $ob ."``";
                                    }
                                }
                            }
                        }//end foreach($this->summary_order_by_arr as $soba){
                        //if there is a group by, create the order by string with the Charindex function
                        if(!empty($groupby)) {
                            $summ_order_by_string = "CharIndex(".$groupby." + '``', '". $summ_order_by_string  ."') ". $ASC_DESC ;
                            $query .= " ORDER BY ".$summ_order_by_string;
                        }else{
                            //if no group by, then just define the order, no need to use charat function
                                $query .= " ORDER BY ". implode( ',', $this->summary_order_by_arr);
                        }

                    }//end if(!empty($this->summary_order_by_arr)){
             //end mssql
             }else{
                $query .= " ORDER BY ". implode( ',', $this->summary_order_by_arr);
             }


      }
    }
    else if ( $query_name == 'query')
    {
      if(!empty($this->order_by_arr))
      {
             if ($this->db->dbType == 'mssql'){
                    $order_by_string = $this->group_by;
                    //set default order by
                    $order_by_string = $this->group_by;
                    //process order by if not empty
                    if(!empty($this->order_by_arr)){
                        //reset the order by string
                        $order_by_string = "";
                        //keep track of whether there are multiple order by's in the array'
                        $multiple_order_bys = count($this->order_by_arr);
                        $multiple = 0;
                        //parse each order by and create mssql friendly order by
                        foreach($this->order_by_arr as $oba){

                            $order_by = explode(",", $oba);
                            $multiple = count($order_by);
                            //if we have more than one order by columns in the current Order By Array,
                            //then process each one, create a string to use in conjunction
                            //with a charindex function.  This will make sure we can get
                            //the order list in the defined order
                            if ($multiple>1 || $multiple_order_bys >1){
                                if(strpos($oba,'=')){
                                    foreach($order_by as $ob){
                                        if(empty($ASC_DESC)){$ASC_DESC = substr($ob,strrpos($ob," "));}
                                        if(empty($groupby)){$groupby = substr($ob,0,strrpos($ob,"="));}
                                        $ob = trim($ob);
                                        $beg_sing_pos = strpos($ob,"'");
                                        if($beg_sing_pos>0){
                                            $end_sing_pos = strrpos($ob,"'");
                                            $order_by_string .= substr($ob,$beg_sing_pos+1,$end_sing_pos-$beg_sing_pos-1) ."``";
                                        }else{
                                            $order_by_string .= $ob ."``";
                                        }

                                    }
                                }else{
                                    //there are multiple order by's, but order is not defined, so lets iterate through and
                                    //create the order by string

                                    $order_by_string ='';
                                    $first = true;
                                    foreach($order_by as $ob){
                                        $sep = strrpos($ob," ");
                                        if(empty($ASC_DESC) && ($sep)){$ASC_DESC = substr($ob,$sep);}
                                        $ob = trim($ob);
                                          if(!$first){$order_by_string .= ', ';}
                                          if($sep){
                                            $order_by_string .= substr($ob,0,$sep);
                                          }else{
                                             $order_by_string .= $ob;
                                          }
                                          $first = false;
                                    }
                                    $order_by_string .= ' '.$ASC_DESC;
                                }
                        }else{
                        //we are here because there are not more than one order by columns
                        //in the order by array, so just grab the entire string
                                    $order_by_string .= implode( ',', $this->order_by_arr);
                            }
                        }//end foreach($this->order_by_arr as $soba){
                //If there were multiple order by's and a group by in the array, then create the Order By
                //SQL string using the "CharAt" function.  If there were not, then
                //we don't need to process as it is already defaulted to the entire string
                if($multiple_order_bys>1 ||$multiple>1){
                    //check to see if there is a group by
                    if(isset($groupby)){
                        $order_by_string = "CharIndex(".$groupby." + '``', '". $order_by_string  ."') ". $ASC_DESC ;
                    }
                }
                    $query .= " ORDER BY ". $order_by_string;

                    }//end if(!empty($this->order_by_arr)){
             }else{
                $query .= " ORDER BY ". implode( ',', $this->order_by_arr);
             }
      }
    }


        $this->$query_name = $query;

        array_push($this->query_list,$this->$query_name);


    }


	function get_summary_header_row()
	{
		$this->layout_manager->setAttribute('list_type','summary');
		// this needs to be fixed.. turn on summary sorting
	//	$this->layout_manager->setAttribute('no_sort','1');
		$header_row = $this->get_header_row_generic('summary_columns');
		return  $header_row;
	}

	function get_total_header_row($exporting = false)
	{
		$this->layout_manager->setAttribute('list_type','summary');
		$this->layout_manager->setAttribute('no_sort','1');
		$header_row = $this->get_header_row_generic('summary_columns',true, $exporting);
		return  $header_row;
	}

	function get_header_row($column_field_name = 'display_columns',$skip_non_group=false, $exporting = false)
	{
		$this->layout_manager->setAttribute('list_type','columns');

		$header_row = $this->get_header_row_generic($column_field_name, $skip_non_group, $exporting);
		return  $header_row;
	}

    function get_header_row_generic($column_field_name = 'display_columns', $skip_non_group=false, $exporting = false)
    {
        if ( $this->plain_text_output == true) {
            $this->layout_manager->setAttribute('context', 'HeaderCellPlain');
        }
        else {
            $this->layout_manager->setAttribute('context', 'HeaderCell');
        }

        $header_row = array();
        $summary_count = 0;

        foreach($this->report_def[$column_field_name] as $display_column) {
            if($skip_non_group &&  empty($display_column['group_function'])) {
                if($exporting || $this->plain_text_output)
                    array_push($header_row,' ');
                else
                    array_push($header_row,'&nbsp;');
                continue;
            }

            $group_by_key = '';
            if(!empty($this->report_def['group_defs'][0])) {
                $group_by_key = $this->report_def['group_defs'][0]['table_key'].":".$this->report_def['group_defs'][0]['name'];
            }

            if(!empty($this->report_def['order_by'][0])) {
                $order_by_key = $this->report_def['order_by'][0]['table_key'].":".$this->report_def['order_by'][0]['name'];
                $column_key = $this->_get_full_key($display_column);

                if(!empty($display_column['group_function'])) {
                    $column_key .= ':'.$display_column['group_function'];
                }
                elseif(!empty($display_column['column_function'])) {
                    $column_key .= ':'.$display_column['column_function'];
                }

                if($group_by_key == $column_key) {
                    $display_column['no_sort'] = 1;
                }

                if($order_by_key == $column_key) {
                    if(empty($this->report_def['order_by'][0]['sort_dir']) || $this->report_def['order_by'][0]['sort_dir'] == 'a') {
                        $display_column['sort'] = '_down';
                    }
                    else {
                        $display_column['sort'] = '_up';
                    }
                }
            }

            $column_key = $this->_get_full_key($display_column);

            if(!empty($display_column['group_function']) && $display_column['group_function'] != 'count') {
                $column_key .= ":".$display_column['group_function'];
            }
            elseif(!empty($display_column['column_function']) && $display_column['column_function'] != 'count') {
                $column_key .= ":".$display_column['column_function'];
            }

            if($column_key == 'self:count') {
                $column_key = 'count';
            }

            if(!empty($this->report_def['summary_order_by'][0])) {
                if(!empty($this->report_def['summary_order_by'][0]['group_function']) && $this->report_def['summary_order_by'][0]['group_function'] == 'count') {
                    $order_by_key = 'count';
                }
                else {
                    $order_by_key = $this->report_def['summary_order_by'][0]['table_key'].":".$this->report_def['summary_order_by'][0]['name'];

                    if(!empty($this->report_def['summary_order_by'][0]['group_function'])) {
                        $order_by_key .= ":".$this->report_def['summary_order_by'][0]['group_function'];
                    }
                    elseif(!empty($this->report_def['summary_order_by'][0]['column_function'])) {
                        $order_by_key .= ":".$this->report_def['summary_order_by'][0]['column_function'];
                    }
                }

                if($order_by_key == $column_key) {
                    if(empty($this->report_def['summary_order_by'][0]['sort_dir']) || $this->report_def['summary_order_by'][0]['sort_dir'] == 'a') {
                        $display_column['sort'] = '_down';
                    }
                    else {
                        $display_column['sort'] = '_up';
                    }
                }
            }

            $display = $this->layout_manager->widgetDisplay($display_column);

            if($column_field_name == 'summary_columns' && ! empty($display_column['is_group_by'])) {
                if ($display_column['is_group_by'] != 'hidden') {
                    $this->group_column_is_invisible = 0;
                    array_push($header_row,$display);
                }
                else {
                    $this->group_column_is_invisible = 1;
                }
                $this->group_header = $display;
                $this->chart_group_position[] = $summary_count;
            }
            else {
                array_push($header_row,$display);
            }
            $summary_count++;

            //if summary, but not the total summary, and doing the chart
            if($skip_non_group == false && $column_field_name == 'summary_columns' && $this->do_chart == true) {
                $this->layout_manager->setAttribute('context', 'HeaderCellPlain');
                $chart_header = array();
                $chart_header['label'] = $this->layout_manager->widgetDisplay($display_column);
                $chart_header['column_key'] = $column_key;
                array_push($this->chart_header_row,$chart_header);
            }
            elseif($skip_non_group == true && $column_field_name == 'summary_columns' && $this->do_chart == true) {
                $this->layout_manager->setAttribute('context', 'HeaderCellPlain');
                $chart_header = array();
                $chart_header['label'] = $this->layout_manager->widgetDisplay($display_column);
                $chart_header['column_key'] = $column_key;
                array_push($this->chart_total_header_row,$chart_header);
            }

        } // END foreach

        return $header_row;
    }

	function get_summary_total_row($exporting = false)
	{
		$get_next_row = $this->get_next_row('total_result','summary_columns',true, $exporting);
		return $get_next_row;
	}

	function get_summary_next_row()
	{

		$get_next_row = $this->get_next_row('summary_result','summary_columns');
		$this->current_summary_row_count = $get_next_row['count'];
//print "<BR>SUMMAYR COUNT:".$this->current_summary_row_count."<BR>";
    //$get_next_row['anch'] = '';


		return $get_next_row;
	}

	function get_next_child_row($result_name){
		if(empty($this->child_filter ))return false;
		$db_row = $this->db->fetchByAssoc($this->$result_name);
		if(!$db_row)return false;
		$fields  = array();
		foreach($db_row as $key=>$value)
		{
			$fields[strtoupper($key)] = $value;
		}
			$this->_load_currency();
		// here we want to make copies, so use foreach
		$cells = array();
		foreach($this->report_def['display_columns'] as $display_column)
		{
			$display_column['table_alias'] = $this->getTableFromField($display_column);
			$display_column['fields'] = $fields;

			$this->register_field_for_query($display_column);



		if ( $this->plain_text_output == true)
		{
			$this->layout_manager->setAttribute('context', 'ListPlain');
		} else {
			$this->layout_manager->setAttribute('context', 'List');
		}
			$display = $this->layout_manager->widgetDisplay($display_column);
			$cells[] = $display;
		}


		return $cells;


	}

	function get_summary_group_count(){
		return $this->db->getRowCount($this->summary_result);
	}
	function get_next_row($result_field_name = 'result', $column_field_name = 'display_columns', $skip_non_summary_columns=false, $exporting = false) {
        $chart_cells = array();

		if ($this->do_export) {
			$db_row = $this->db->fetchByAssoc($this->$result_field_name,-1,false);
		}
		else {
			$db_row = $this->db->fetchByAssoc($this->$result_field_name);
		}

		if ( $db_row == 0 || sizeof($db_row) == 0 ) {
			return 0;
		}
		if($result_field_name == 'summary_result') {
			if(!empty($this->child_filter) && !empty($db_row[$this->child_filter_name])) {
				$this->child_filter_by =$db_row[$this->child_filter_name];
			}
            else {
				$this->child_filter = '';
				$this->child_filter_by = '';
				$this->child_filter_name = '';
			}
		}

		$row = array();
		$cells = array();
		$fields = array();

        global $beanFiles, $beanList;
		$bean_name = $beanList[$this->module];
		require_once($beanFiles[$bean_name]);
		$bean = new $bean_name();
		// is this necessary? why not just attach the db_row for fields?
		foreach($db_row as $key=>$value) {
			$fields[strtoupper($key)] = $value;
		}

        $this->_load_currency();
		// here we want to make copies, so use foreach

        foreach($this->report_def[$column_field_name] as $display_column) {
            $display_column['table_alias'] = $this->getTableFromField($display_column);

            $this->register_field_for_query($display_column);

			if($skip_non_summary_columns &&   empty($display_column['group_function'])) {
                if($exporting || $this->plain_text_output)
                    array_push($cells, ' ');
                else
                    array_push($cells, '&nbsp;');
                continue;
			}
			$display_column['fields'] = $fields;

    		if ( $this->plain_text_output == true) {
    			$this->layout_manager->setAttribute('context', 'ListPlain');
            }
            else {
                $this->layout_manager->setAttribute('context', 'List');
            }

            $display = $this->layout_manager->widgetDisplay($display_column);

            //  for charts
            if($column_field_name == 'summary_columns' && $this->do_chart) {
                $raw_display = preg_replace('/^\$/','',$display);
                $cell_arr = array('val'=>$raw_display,'key'=>$display_column['column_key']);
                array_push($chart_cells,$cell_arr);
            }

            if($exporting) {
                global $app_list_strings;
                // parse out checkboxes
                // TODO: wp this should be done in the widget
                if(preg_match('/type.*=.*checkbox/Uis', $display)) {
                    if(preg_match('/checked/i', $display)) $display = $app_list_strings['dom_switch_bool']['on'];
                    else $display = $app_list_strings['dom_switch_bool']['off'];
                }
            }
            array_push($cells,$display);
        } // END foreach

        $row['cells'] = $cells;

		if( ! empty($db_row['count'])) {
            $row['count'] = $db_row['count'];
        }

        // for charts
        if($column_field_name == 'summary_columns' && $this->do_chart) {
            $chart_row = 0;
            if(!empty($db_row['count'])) {
                $chart_row = array('cells'=>$chart_cells,'count' => $db_row['count']);
            }
            else {
                $chart_row = array('cells'=>$chart_cells);
            }
            array_push($this->chart_rows,$chart_row);
        }

        if($column_field_name == 'summary_columns' &&  isset($this->chart_group_position) && isset($this->group_header)) {
            $row['group_pos'] = $this->chart_group_position;
            $row['group_header'] = $this->group_header;
            $row['group_column_is_invisible'] = $this->group_column_is_invisible;
        }

        return $row;
    }

	function save($report_name){
		global $current_user;
		$saved_vars = array();

		$saved_report = new SavedReport();
		$report_type = 'tabular';
		$chart_type = 'none';
		
		if (isset($this->report_def['chart_type'])) {
			$chart_type = $this->report_def['chart_type'];
		}
		if ( $this->report_def['report_type'] == 'summary'){
  		 	$report_type = 'summary';
			if ( ! empty( $this->report_def['display_columns'])){
  		 	$report_type = 'detailed_summary';
			}
		}

	    if ( empty($_REQUEST['record'])){
	    	$_REQUEST['record'] = -1;
	    }
	    
		$result = $saved_report->save_report(
	        $_REQUEST['record'],
	        $_REQUEST['assigned_user_id'],
	        $report_name,
	        $this->module,
	        $report_type,
	        $this->report_def_str,
	        0,
	        $_REQUEST['team_id'],
	        $chart_type);
  		$this->saved_report = &$saved_report;

		return $result;

	}

	function cache_modules_def_js()
	{
		global $current_language, $current_user;
		if (!isset($_SESSION['reports_cache']) || !file_exists('cache/modules/modules_def_'.$current_language.'_'.md5($current_user->id).'.js'))
		{
			require_once('templates/templates_modules_def_js.php');
			ob_start();
			template_module_defs_js($args);

			$contents = ob_get_clean();
			$filename = 'cache/modules/modules_def_'.$current_language.'_'.md5($current_user->id).'.js';
			if (is_writable('cache/modules/'))
			{
				$fp =fopen($filename,'w+');
				fwrite($fp,$contents);
				fclose($fp);
			}
			// Only set this if we're not being called from the home page.
			// Charts on the home page go through this code as well and 
			// _SESSION hasn't been initialized completely and this causes errors with global vars.
			if ($_REQUEST['module'] != 'Home')
				$_SESSION['reports_cache'] = true;
		}

	}

	function is_old_content($content)
	{

		if ( preg_match('/report_type\=/', $content))
		{
			return true;
		}
		return false;

	}

	function run_chart_queries()
	{

		$this->run_summary_query();

		$this->get_summary_header_row();

		while (( $row = $this->get_summary_next_row() ) != 0 )
		{
		}
		$this->run_total_query();
		$this->get_summary_total_row();

	}

  // static function to return the modules associated to a report definition
  function &getModules(&$report_def)
  {
    $modules = array();
    $modules_hash[$report_def['module']] =1 ;
    global $beanFiles,$beanList;
    require_once($beanFiles[$beanList[$report_def['module']]]);
    $focus = new $beanList[$report_def['module']]();
    $linked_fields=$focus->get_linked_fields();

    foreach($report_def['links_def'] as $name) {
      $properties = $linked_fields[$name];
      $link = new Link($properties['relationship'], $focus, $properties);
      $module = $link->getRelatedModuleName();
      $modules_hash[$module] = 1;
    }

    $modules = array_keys($modules_hash);
    return $modules;
  }


}

?>
