<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');

/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Professional Subscription
 * Agreement ("License") which can be viewed at
 * http://www.sugarcrm.com/crm/products/sugar-professional-eula.html
 * By installing or using this file, You have unconditionally agreed to the
 * terms and conditions of the License, and You may not use this file except in
 * compliance with the License.  Under the terms of the license, You shall not,
 * among other things: 1) sublicense, resell, rent, lease, redistribute, assign
 * or otherwise transfer Your rights to the Software, and 2) use the Software
 * for timesharing or service bureau purposes such as hosting the Software for
 * commercial gain and/or for the benefit of a third party.  Use of the Software
 * may be subject to applicable fees and any use of the Software without first
 * paying applicable fees is strictly prohibited.  You do not have the right to
 * remove SugarCRM copyrights from the source code or user interface.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *  (i) the "Powered by SugarCRM" logo and
 *  (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * Your Warranty, Limitations of liability and Indemnity are expressly stated
 * in the License.  Please refer to the License for the specific language
 * governing these rights and limitations under the License.  Portions created
 * by SugarCRM are Copyright (C) 2004-2007 SugarCRM, Inc.; All Rights Reserved.
 ********************************************************************************/
require_once('templates_group_chooser.php');
require_once('templates_reports_functions_js.php');
require_once('templates_list_view.php');
//require_once('templates_modules_def_js.php');
require_once('templates_reports_request_js.php');
require_once('modules/Reports/SavedReport.php');
require_once('modules/Reports/config.php');
require_once('modules/ACLActions/ACLAction.php');
require_once('modules/Reports/schedule/ReportSchedule.php');
global $global_json;
$global_json = getJSONobj();



//////////////////////////////////////////////
// TEMPLATE:
//////////////////////////////////////////////
function template_reports_report(&$reporter,&$args)
{
global $current_user;
global $current_language;
global $mod_strings, $app_strings;

$sort_by = '';
$sort_dir = '';
$summary_sort_by = '';
$summary_sort_dir = '';
$report_type = '';

if (isset($reporter->report_def['order_by'][0]['name']) && isset($reporter->report_def['order_by'][0]['table_key']))
{
	$sort_by = $reporter->report_def['order_by'][0]['table_key'].":".$reporter->report_def['order_by'][0]['name'];
}
if ( isset($reporter->report_def['order_by'][0]['sort_dir']))
{
	$sort_dir = $reporter->report_def['order_by'][0]['sort_dir'];
}

if ( ! empty($reporter->report_def['summary_order_by'][0]['group_function']) && $reporter->report_def['summary_order_by'][0]['group_function'] == 'count')
{
  $summary_sort_by = 'count';
} else if ( isset($reporter->report_def['summary_order_by'][0]['name']))
{
	$summary_sort_by = $reporter->report_def['summary_order_by'][0]['table_key'].":".$reporter->report_def['summary_order_by'][0]['name'];

	if ( ! empty($reporter->report_def['summary_order_by'][0]['group_function'])) {
		$summary_sort_by .=":". $reporter->report_def['summary_order_by'][0]['group_function'];
	} else if ( ! empty($reporter->report_def['summary_order_by'][0]['column__function'])) {

                $summary_sort_by .=":". $reporter->report_def['summary_order_by'][0]['column_function'];
        } 
}

if ( isset($reporter->report_def['summary_order_by'][0]['sort_dir']))
{
	$summary_sort_dir = $reporter->report_def['summary_order_by'][0]['sort_dir'];
}
if ( isset($reporter->report_def['report_type']))
{
	$report_type = $reporter->report_def['report_type'];
}


?>

<?php

if (isset($args['save_result']))
{
	if ($args['save_result'])
	{
?>
<p>	<span><b><?php echo $mod_strings['LBL_SUCCESS_REPORT']; ?> "<?php echo $_REQUEST['save_report_as']; ?>" <?php echo $mod_strings['LBL_WAS_SAVED']; ?></b></span></p>
<?php
	}
	else
	{
?>
	<span><b><?php echo $mod_strings['LBL_FAILURE_REPORT']; ?> "<?php echo $_REQUEST['save_report_as']; ?>" <?php echo $mod_strings['LBL_WAS_NOT_SAVED']; ?></b></span></p>
<?php
	}

}

?><p>
<?php echo get_form_header( $mod_strings['LBL_TITLE'].": ".$reporter->name, "", false); ?>
<form action="index.php#main" method="post" name="EditView" onSubmit="return fill_form();">
<input type="hidden" name='report_offset' value ="<?php echo $reporter->report_offset; ?>">
<input type="hidden" name='sort_by' value ="<?php echo $sort_by; ?>">
<input type="hidden" name='sort_dir' value ="<?php echo $sort_dir; ?>">
<input type="hidden" name='summary_sort_by' value ="<?php echo $summary_sort_by; ?>">
<input type="hidden" name='summary_sort_dir' value ="<?php echo $summary_sort_dir; ?>">
<input type="hidden" name='expanded_combo_summary_divs' id='expanded_combo_summary_divs' value=''>
<input type="hidden" name="action" value="index">
<input type="hidden" name="module" value="Reports">
<?php 


if (isset($_REQUEST['save_as']) &&  $_REQUEST['save_as'] == 'true')
    $report_id = '';
else if (isset($reporter->saved_report->id) )
    $report_id = $reporter->saved_report->id;
elseif(!empty($_REQUEST['record'])) 
    $report_id = $_REQUEST['record'];
else  
    $report_id = ''; 
?>
<input type="hidden" name="record" value="<?php echo $report_id;?>">
<input type="hidden" name='report_def' value ="">
<input type="hidden" name='save_as' value ="">
<input type="hidden" name="page" value="report">
<input type="hidden" name="to_pdf" value="<?php if ( isset($_REQUEST['to_pdf'])) { echo $_REQUEST['to_pdf']; } ?>"/>
<input type="hidden" name="to_csv" value="<?php if ( isset($_REQUEST['to_csv'])) { echo $_REQUEST['to_csv']; } ?>"/>
<input type="hidden" name="save_report" value=""/>
<!--
<input type="hidden" name="report_module" value="<?php echo $reporter->module; ?>">
-->
<table border="0" cellspacing="0" cellpadding="0">
<tr>
<td style="padding-bottom: 2px;"">
<?php
$is_owner =  true;
if (isset($args['reporter']->saved_report) && $args['reporter']->saved_report->assigned_user_id != $current_user->id) 
	$is_owner = false;

if(ACLController::checkAccess('Reports', 'edit', $is_owner)) 
{?>
<input type=submit class="button" title="<?php echo $mod_strings['LBL_RUN_BUTTON_TITLE']; ?>" 
    accessKey="<?php echo $mod_strings['LBL_RUN_REPORT_BUTTON_KEY']?>" 
    value="<?php echo $mod_strings['LBL_RUN_REPORT_BUTTON_LABEL']; ?>" 
    onclick="this.form.to_pdf.value='';this.form.to_csv.value='';this.form.save_report.value=''"> 
<input type=submit class="button" title="<?php echo $app_strings['LBL_SAVE_BUTTON_TITLE']; ?>" 
    accessKey="<?php echo $app_strings['LBL_SAVE_BUTTON_KEY']?>" 
    value="<?php echo $app_strings['LBL_SAVE_BUTTON_LABEL']; ?>" 
    onclick="this.form.to_pdf.value='';this.form.to_csv.value='';this.form.save_report.value='on';">
<input type=submit class="button" title="<?php echo $app_strings['LBL_SAVE_AS_BUTTON_TITLE']; ?>" 
    accessKey="<?php echo $app_strings['LBL_SAVE_AS_BUTTON_KEY']?>" 
    value="<?php echo $app_strings['LBL_SAVE_AS_BUTTON_LABEL']; ?>" 
    onclick="this.form.to_pdf.value='';this.form.to_csv.value='';this.form.save_report.value='on';this.form.record.value='';this.form.save_as.value='true'"> 
<?php }?>    
<?php		
if(ACLController::checkAccess('Reports', 'export', $is_owner)) 
{
?>   
<input type=submit class="button" title="<?php echo $app_strings['LBL_VIEW_PDF_BUTTON_TITLE']; ?>" 
    accessKey="<?php echo $app_strings['LBL_VIEW_PDF_BUTTON_KEY']?>" 
    value="<?php echo $app_strings['LBL_VIEW_PDF_BUTTON_LABEL']; ?>" 
    onclick="this.form.save_report.value='';this.form.to_csv.value='';this.form.to_pdf.value='on'">
<?php }?>    
</td>
</tr>
</table>
<script>
var form_submit = "<?php echo (empty($_REQUEST['form_submit']) ? false : $_REQUEST['form_submit']);?>";
var tab_keys = new Array('module_join_tab','filters_tab','columns_tab','group_by_tab','chart_options_tab');
LBL_RELATED = '<?php echo $mod_strings['LBL_RELATED'] ?>';
function showReportTab(show_key)
{
 for(var i in tab_keys)
 {
	document.getElementById(tab_keys[i]).style.display='none';
 } 
 document.getElementById(show_key).style.display='block';
}
<?php
$global_json = getJSONobj();
global $ACLAllowedModules; 
$ACLAllowedModules = getACLAllowedModules();
echo 'ACLAllowedModules = ' . $global_json->encode(array_keys($ACLAllowedModules)); 
?>

</script>
<?php


require_once('include/tabs.php');
                                                                                     
$tabs = array();
                                                                                     
array_push($tabs,array('title'=>$mod_strings['LBL_1_REPORT_ON'],'link'=>'module_join_tab','key'=>'module_join_tab'));
array_push($tabs,array('title'=>$mod_strings['LBL_2_FILTER'],'link'=>'filters_tab','key'=>'filters_tab'));
//array_push($tabs,array('title'=>$mod_strings['LBL_3_GROUP'],'link'=>'group_by_tab','key'=>'group_by_tab'));
//array_push($tabs,array('title'=>$mod_strings['LBL_3_CHOOSE'],'link'=>'columns_tab','key'=>'columns_tab'));
if ( $args['reporter']->report_type == 'tabular') 
{
  array_push($tabs,array('title'=>$mod_strings['LBL_3_GROUP'],'hidden'=>true,'link'=>'group_by_tab','key'=>'group_by_tab'));
  array_push($tabs,array('title'=>$mod_strings['LBL_3_CHOOSE'],'link'=>'columns_tab','key'=>'columns_tab'));
  array_push($tabs,array('title'=>$mod_strings['LBL_5_CHART_OPTIONS'],'hidden'=>true,'link'=>'chart_options_tab','key'=>'chart_options_tab'));
} else {
  array_push($tabs,array('title'=>$mod_strings['LBL_3_GROUP'],'link'=>'group_by_tab','key'=>'group_by_tab'));
  array_push($tabs,array('title'=>$mod_strings['LBL_4_CHOOSE'],'link'=>'columns_tab','key'=>'columns_tab'));
  array_push($tabs,array('title'=>$mod_strings['LBL_5_CHART_OPTIONS'],'link'=>'chart_options_tab','key'=>'chart_options_tab'));
}

$current_key = 'module_join_tab';
$tab_panel= new SugarWidgetTabs($tabs,$current_key,'showReportTab');
echo "<BR>".$tab_panel->display();
?>

<table width="100%" border="0" cellspacing=0 cellpadding=0 class="tabForm" style="border-top: 0px;">
<tr>
<td valign="top" width="100%">
<?php template_reports_tables($args); ?>


<?php 
if( $reporter->report_type=='summary')
{
 $summary_display = '';

 if ( $reporter->show_columns)
 {
 $column_display = '';
 }
 else
 {
  $column_display = 'none';
 }
}
else
{
 $summary_display = 'none';
 $column_display = '';
}

$summary_join_selector = '&nbsp;<div style="padding-bottom:2px">'.$mod_strings['LBL_MODULE'].': <select onChange="viewJoinChanged(this);" id="view_join_summary" name="view_join_summary"></select></div>';

$chooser_args_summary = array('id'=>'summary_table','title'=>$mod_strings['LBL_CHOOSE_SUMMARIES'].':','left_name'=>'display_summary','right_name'=>'hidden_summary','left_label'=>$mod_strings['LBL_DISPLAY_SUMMARIES'],'right_label'=>$summary_join_selector,'display'=>$summary_display,'onmoveleft'=>'reload_columns(\'join\')','onmoveright'=>'reload_columns(\'join\')');


$join_selector = '&nbsp;<div style="padding-bottom:2px">'.$mod_strings['LBL_MODULE'].': <select onChange="viewJoinChanged(this);" id="view_join" name="view_join"></select></div>';

$chooser_args = array('id'=>'columns_table','title'=>$mod_strings['LBL_CHOOSE_COLUMNS'].':','left_name'=>'display_columns','right_name'=>'hidden_columns','left_label'=>$mod_strings['LBL_DISPLAY_COLUMNS'],'right_label'=>$join_selector,'display'=>$column_display,'topleftcontent'=>$join_selector,'onmoveleft'=>'reload_columns(\'join\')','onmoveright'=>'reload_columns(\'join\')');


?>
<div id="columns_tab" style="display: none">
<?php template_groups_chooser($chooser_args_summary); ?>
<div id="summary_more_div" <?php if ( $summary_display == 'none') { echo "style=\"display: none\"";};?>>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $mod_strings['LBL_LABEL'];?>:<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<input type='text' name='detailsummary_label_editor' id='detailsummary_label_editor' value='' onchange='saveLabel("detailsummary",this )'>
<div class="dataLabel">

<input type="checkbox" class="checkbox" name="show_details" id="show_details" onclick="showDetailsClicked(this);" <?php if ( $reporter->show_columns) { echo "CHECKED"; } ?>>&nbsp;
<?php echo $mod_strings['LBL_SHOW_DETAILS']; ?></div>
<br>
</div>

<?php template_groups_chooser($chooser_args);  ?>
<div id="columns_more_div"  <?php if ( $column_display == 'none') { echo "style=\"display: none\"";};?>>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $mod_strings['LBL_LABEL'];?>:<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<input type='text' name='column_label_editor' id='column_label_editor' value='' size=25 onchange='saveLabel("column", this)'>
</div>

</div>

<?php template_reports_filters($args); ?>
<div id='group_by_tab' style="display: none"
<?php if ( $args['reporter']->report_type == 'tabular') { ?>
style="display: none"
<?php } ?>>
<?php  template_reports_group_by($args); ?>
</div>
<div id='chart_options_tab' style="display: none">
<?php  template_reports_chart_options($args); ?>
</div>

</td>
</tr>
</table></p>
<table border="0" cellspacing="0" cellpadding="0">
<tr>
<td style="padding-bottom: 2px;"">
<?if(ACLController::checkAccess('Reports', 'edit', $is_owner)) 
{?>
<input type=submit class="button" title="<?php echo $mod_strings['LBL_RUN_BUTTON_TITLE']; ?>" 
    accessKey="<?php echo $mod_strings['LBL_RUN_REPORT_BUTTON_KEY']?>" 
    value="<?php echo $mod_strings['LBL_RUN_REPORT_BUTTON_LABEL']; ?>" 
    onclick="this.form.to_pdf.value='';this.form.to_csv.value='';this.form.save_report.value=''"> 
<input type=submit class="button" title="<?php echo $app_strings['LBL_SAVE_BUTTON_TITLE']; ?>" 
    accessKey="<?php echo $app_strings['LBL_SAVE_BUTTON_KEY']?>" 
    value="<?php echo $app_strings['LBL_SAVE_BUTTON_LABEL']; ?>" 
    onclick="this.form.to_pdf.value='';this.form.to_csv.value='';this.form.save_report.value='on';">
<input type=submit class="button" title="<?php echo $app_strings['LBL_SAVE_AS_BUTTON_TITLE']; ?>" 
    accessKey="<?php echo $app_strings['LBL_SAVE_AS_BUTTON_KEY']?>" 
    value="<?php echo $app_strings['LBL_SAVE_AS_BUTTON_LABEL']; ?>" 
    onclick="this.form.to_pdf.value='';this.form.to_csv.value='';this.form.save_report.value='on';this.form.record.value='';this.form.save_as.value='true'">
<?}?>
<?if(ACLController::checkAccess('Reports', 'export', $is_owner)) 
{?>
<input type=submit class="button" title="<?php echo $app_strings['LBL_VIEW_PDF_BUTTON_TITLE']; ?>" 
    accessKey="<?php echo $app_strings['LBL_VIEW_PDF_BUTTON_KEY']?>" 
    value="<?php echo $app_strings['LBL_VIEW_PDF_BUTTON_LABEL']; ?>" 
    onclick="this.form.save_report.value='';this.form.to_csv.value='';this.form.to_pdf.value='on'">
<?}?>

</td>
</tr>
</table>
</form>
</p>
<?php
// template_module_defs_js($args); 
?>
<script>
var current_db_type = '<?php echo $reporter->db->dbType;?>';
</script>
<script type="text/javascript" src="cache/modules/modules_def_<?php echo $current_language; ?>_<?php echo md5($current_user->id) ?>.js"></script>
<script type="text/javascript" src="include/javascript/sugar_grp_overlib.js"></script>
<div id="overDiv" style="position:absolute; visibility:hidden; z-index:1000;"></div>
<script>
                                                                                                       
var visible_modules;
var report_def;
var current_module;
// only defaulting to mysql.. actual dbType is set in templates_reports_request_js.php
var visible_fields = new Array();
var visible_fields_map =  new Object();
var visible_summary_fields = new Array();
var visible_summary_field_map =  new Object();
var current_report_type;
var display_columns_ref = 'display';
var hidden_columns_ref = 'hidden';
var field_defs;
var previous_links_map = new Object();
var previous_links =  new Array();
var display_summary_ref = 'display';
var hidden_summary_ref = 'hidden';
var users_array = new Array();

</script>
<?php template_reports_functions_js($args); ?>
<?php template_reports_request_vars_js($reporter,$args); ?>
<?php 
ob_start();
?>
<script language="javascript">
if(typeof YAHOO != 'undefined') YAHOO.util.Event.addListener(window, 'load', load_page);
</script>
<div id="report_results">
<?php 
$do_chart = false;

if ($reporter->report_type == 'summary' && 
     ! empty($reporter->report_def['summary_columns'])) 
{ 

		if ( $reporter->show_columns && 
			!empty($reporter->report_def['display_columns']) && 
          ! empty($reporter->report_def['group_defs'])) 
	{
		
		template_summary_combo_view($reporter,$args);
			$do_chart = true;
	} else if ($reporter->show_columns && 
	             	!empty($reporter->report_def['display_columns']) && 
          empty($reporter->report_def['group_defs'])) 
	{
		
		template_detail_and_total_list_view($reporter,$args); 
	} else if (! empty($reporter->report_def['group_defs'])) 
	{
		template_summary_list_view($reporter,$args); 
			$do_chart = true;
	} else	 
	{
		template_total_view($reporter,$args); 
		} 
} else if (! empty($reporter->report_def['display_columns']) ) 
{ 
	template_list_view($reporter,$args); 
		}

if ($reporter->report_def['chart_type']== 'none')
{
		$do_chart = false;
	}
?>
</div>
<?php
	$contents = ob_get_contents();
	ob_end_clean();

	if ($do_chart)
	{
   template_chart($reporter);
	}

	print $contents;
}

//////////////////////////////////////////////
// TEMPLATE:
// filters_top: string is filled up with the filter query string
// filters_top: table that holds the filter rows
//////////////////////////////////////////////
function template_reports_filters(&$args)
{
$reporter =$args['reporter'];
global $mod_strings;
?>
<div id="filters_tab" style="display: none">
<span class="dataLabel"><h5><?php echo $mod_strings['LBL_FILTERS']; ?>:</h5></span>
<?php echo $mod_strings['LBL_FILTER_CONDITIONS']; ?>
 <select name='filters_combiner' id='filters_combiner'>
   <option value='AND' <?php if(!empty($reporter->report_def['filters_combiner']) && $reporter->report_def['filters_combiner'] == 'AND') echo ' selected '; ?>><?php echo $mod_strings['LBL_FILTER_AND']; ?></option>
   <option value='OR' <?php if(!empty($reporter->report_def['filters_combiner']) && $reporter->report_def['filters_combiner'] == 'OR') echo ' selected '; ?>><?php echo $mod_strings['LBL_FILTER_OR']; ?></option>
</select>
<?php echo $mod_strings['LBL_FILTERS_END']; ?>
<br><br>
<input class=button type=button onClick='window.addFilter()' name='<?php echo $mod_strings['LBL_ADD_NEW_FILTER']; ?>' value='<?php echo $mod_strings['LBL_ADD_NEW_FILTER']; ?>'>
&nbsp;&nbsp;<?php echo $mod_strings['LBL_DATE_BASED_FILTERS']; ?>
<input type=hidden name='filters_def' value ="">
<?php
$sort_by ="";
$sort_dir ="";
if ( isset($reporter->report_def['sort_by']))
{
	$sort_dir = $reporter->report_def['sort_by'];
}

if ( isset($reporter->report_def['sort_dir']))
{
	$sort_dir = $reporter->report_def['sort_dir'];
}
?>
<table id='filters_top' border=0 cellpadding="0" cellspacing="0">
<tbody id='filters'></tbody>
</table>
</div>

<?php
}

//////////////////////////////////////////////
// TEMPLATE:
//////////////////////////////////////////////
function template_reports_group_by(&$args)
{
global $mod_strings;
?>
<span class="dataLabel"><h5><?php echo $mod_strings['LBL_GROUP_BY'];?>:</h5></span>
<table width="100%" cellpadding=0 cellspacing=0>
<tr id="group_by_button">
<td align=left>
<input class=button type=button onClick='addGroupByFromButton()' name='Add Column' value='<?php echo $mod_strings['LBL_ADD_COLUMN'];?>'>
</td>
</tr>
</table>
<input type=hidden name='group_by_def' value =""/>
<div id='group_by_div'>
<table id='group_by_table' border="0" cellpadding="0" cellspacing="0">
<tbody id='group_by_tbody'></tbody>
</table>
</div>

<?php
}

//////////////////////////////////////////////
// TEMPLATE:
//////////////////////////////////////////////
function template_reports_chart_options(&$args)
{
$reporter =$args['reporter'];
global $mod_strings;
$chart_types = array(
'none'=>$mod_strings['LBL_NO_CHART'],
'hBarF'=>$mod_strings['LBL_HORIZ_BAR'],
'vBarF'=>$mod_strings['LBL_VERT_BAR'],
'pieF'=>$mod_strings['LBL_PIE'],
'funnelF'=>$mod_strings['LBL_FUNNEL'],
'lineF'=>$mod_strings['LBL_LINE'],
);

$is_chart_dashlet = false;
if (isset($reporter->saved_report->is_chart_dashlet) && $reporter->saved_report->is_chart_dashlet == 1){
	$is_chart_dashlet = true;
}
?>
<span id="no_chart_text"><?php echo $mod_strings['LBL_GROUP_BY_REQUIRED']; ?></span>
<span class="dataLabel"><h5><?php echo $mod_strings['LBL_CHART_TYPE'];?>:</h5></span>
<table width="100%" cellpadding=0 cellspacing=0>
<tr>
<td align=left>
<select name='chart_type'>
<?php foreach ($chart_types as $thekey=>$theval) { ?>
<option value="<?php echo $thekey; ?>" <?php if ($reporter->report_def['chart_type'] == $thekey) { echo "SELECTED"; } ?>><?php echo $theval;?></option>
<?php } ?>
</select>
</td>
</tr>
</table>
<P/>
<span class="dataLabel"><h5><?php echo $mod_strings['LBL_USE_COLUMN_FOR'];?>:</h5></span>
<table width="100%" cellpadding=0 cellspacing=0>
<tr>
<td align=left>
<select name='numerical_chart_column'>
</select>
</td>
</tr>
</table>
<P/>
<span class="dataLabel"><h5><?php echo $mod_strings['LBL_CHART_DESCRIPTION'];?>:</h5></span>
<table width="100%" cellpadding=0 cellspacing=0>
<tr>
<td align=left>
<input name='chart_description' size='50' value="<?php echo htmlentities($reporter->chart_description, ENT_QUOTES, 'UTF-8');?>" maxsize="255"/>
</td>
</tr>
</table>
<?php
}


//////////////////////////////////////////////
// TEMPLATE:
//////////////////////////////////////////////

function juliansort($a,$b)
{
 global $app_list_strings;
 if ($app_list_strings['moduleList'][$a] > $app_list_strings['moduleList'][$b])
 {
  return 1;
 }
 return -1;
}

/*
  $assigned_user_html_def = array(
    'parent_id'=>'assigned_user_id',
    'parent_id_value'=>$focus->assigned_user_id,
    'parent_name'=>'assigned_user_name',
    'parent_name_value'=>$focus->assigned_user_name,
    'real_parent_name'=>'user_name',
    'module'=>'Users',
  );
*/
function get_select_related_html(&$args)
{
  global $global_json,$app_strings;

  if ( ! isset($args['form_name']))
  {
    $args['form_name'] = 'EditView';
  }

  $popup_request_data = array(
    'call_back_function' => 'set_return',
    'form_name' => $args['form_name'],
    'field_to_name_array' => array(
      'id' => $args['parent_id'],
      $args['real_parent_name'] => $args['parent_name'],
    ),
  );

  $request_data = $global_json->encode($popup_request_data);


  $content = "<input class='sqsEnabled' autocomplete='off' id='{$args['parent_name']}' name='{$args['parent_name']}' type='text' value='{$args['parent_name_value']}'>&nbsp;<input id='{$args['parent_id']}' name='{$args['parent_id']}' type='hidden' value='{$args['parent_id_value']}'/></slot>";
  $content .= "<input title='{$app_strings['LBL_SELECT_BUTTON_TITLE']}' accessKey='{$app_strings['LBL_SELECT_BUTTON_KEY']}' type='button' class='button' value='{$app_strings['LBL_SELECT_BUTTON_LABEL']}' name=btn1 ";

  if ( isset($args['tabindex']))
  {
    $content .= "tabindex='{$args['tabindex']}' ";
  }

  $content .= " onclick='open_popup(\"{$args['module']}\", 600, 400, \"\", true, false, $request_data);' />"; 

  return $content;

}


function js_setup()
{
  global $global_json;
  require_once('include/QuickSearchDefaults.php');
  $qsd = new QuickSearchDefaults();
  $sqs_objects = array('assigned_user_name' => $qsd->getQSUser(),
					'team_name' => $qsd->getQSTeam());
  $quicksearch_js = $qsd->getQSScripts();
$quicksearch_js .= '<script type="text/javascript" language="javascript">sqs_objects = ' . $global_json->encode($sqs_objects) . '</script>';
                                                                                
return $quicksearch_js;

}




function template_reports_tables(&$args)
{
global $report_modules;
global $mod_strings;
global $app_list_strings;
$reporter =$args['reporter'];

$classname = "dataLabel";


?>
<div id="module_join_tab">
<div>
&nbsp;<span id='checkGroups' style='display: none; color: red'><i><?php echo $mod_strings['LBL_TABLE_CHANGED']; ?></i></span>
</div>
<table border=0 width="100%" cellspacing="0" cellpadding="0">
<tr class="<?php echo $classname; ?>">
<td class="<?php echo $classname; ?>" width="50%">
<table border=0 width="100%" cellspacing="0" cellpadding="3">
<tr class="<?php echo $classname; ?>">
<td class="<?php echo $classname; ?>">
<h5><?php echo $mod_strings['LBL_MODULE']; ?>:</h5><!--<span class="dataField"><em>Select the root module to report on</em></span><br>-->
<select id='self' name="self" onChange="table_changed(this);">
<?php
// initial hardcoded SELECTED setting from php
// loop thru supported module tables


global $ACLAllowedModules;
uksort($ACLAllowedModules,"juliansort");


foreach ($ACLAllowedModules as $module=>$bean_name)
{

		if ($module == 'Reports') continue;
        // if module has been requested
        if ($module == $reporter->module)
        {
                $module_selected = ' SELECTED';
        }
        else
        {
                $module_selected = '';
        }
?>
<option value="<?php echo $module; ?>" <?php echo $module_selected; ?>><?php echo $app_list_strings['moduleList'][$module]; ?></option>
<?php } ?>
</select>
<a href="" class="button" style="padding: 2px; text-decoration: none;" onClick="add_related('self'); return(false);"><?php echo $mod_strings['LBL_ADD_RELATE']; ?></a>

</td>
</tr>
</table>
<input type=hidden name='links_def' value ="">
<div style="border-left: 2px dotted #000000; padding-left: 5px;" id="self_children"></div>
<table id='joins_table' cellpadding=0 cellspacing=0 border=0>
</table>
</td>
<td align="left" width="50%">
<br>
<table border=0 width="100%" cellspacing="0" cellpadding="0">
<tr class="<?php echo $classname; ?>">
<td class="<?php echo $classname; ?>"><?php echo $mod_strings['LBL_REPORT_NAME'];?>:</td>
<?php 
 $save_report_as = $mod_strings['LBL_UNTITLED'];
if (! empty($reporter->name))
{
 $save_report_as = $reporter->name;
}
?>
<td class="<?php echo $classname; ?>"><input type="text" size="30" value="<?php echo $save_report_as; ?>" name="save_report_as"/></td>
</tr>
<?php
global $current_user;
if ($current_user->is_admin) { ?>
<tr class="<?php echo $classname; ?>">
<td class="<?php echo $classname; ?>"><?php echo $mod_strings['LBL_SHOW_QUERY']; ?>:</td>
<td class="<?php echo $classname; ?>" style="vertical-align : middle;"><input type="checkbox" class="checkbox" name="show_query" <?php if ( ! empty($_REQUEST['show_query'])) { echo "CHECKED"; } ?>/></td>
</tr>
<?php } ?>
<?php
$focus = null;
if (! empty($reporter->saved_report))
{
	$focus = & $reporter->saved_report;
} else {
	$focus = & new SavedReport();
	$focus->assigned_user_name = (empty($_REQUEST['assigned_user_name']) ? '' : $_REQUEST['assigned_user_name']); 
	$focus->assigned_user_id = (empty($_REQUEST['assigned_user_id']) ? '' : $_REQUEST['assigned_user_id']);
	$focus->team_name = (empty($_REQUEST['team_name']) ? '' : $_REQUEST['team_name']); 
	$focus->team_id = (empty($_REQUEST['team_id']) ? '' : $_REQUEST['team_id']);
}
global $current_user;

if (empty($focus->assigned_user_id) && empty($focus->id))  $focus->assigned_user_id = $current_user->id;
if (empty($focus->assigned_user_name) && empty($focus->id))  $focus->assigned_user_name = $current_user->user_name;

  $assigned_user_html_def = array(
    'parent_id'=>'assigned_user_id',
    'parent_id_value'=>$focus->assigned_user_id,
    'parent_name'=>'assigned_user_name',
    'parent_name_value'=>$focus->assigned_user_name,
    'real_parent_name'=>'user_name',
    'module'=>'Users',
  );

  $assigned_user_html = get_select_related_html($assigned_user_html_def);

?>
<tr class="<?php echo $classname; ?>">
<td class="<?php echo $classname; ?>"><?php echo $mod_strings['LBL_OWNER']; ?>:</td>
<td class="<?php echo $classname; ?>" style="vertical-align : middle;"><?php echo $assigned_user_html; ?></td>
</tr>
<?php

if (empty($focus->id) && empty($_REQUEST['team_name'])) {
  $focus->team_name = $current_user->default_team_name;
  $focus->team_id =  $current_user->default_team;
} 

  $team_html_def = array(
    'parent_id'=>'team_id',
    'parent_id_value'=>$focus->team_id,
    'parent_name'=>'team_name',
    'parent_name_value'=>$focus->team_name,
    'real_parent_name'=>'name',
    'module'=>'Teams',
  );

  $team_html = get_select_related_html($team_html_def);

?>
<tr class="<?php echo $classname; ?>">
<td class="<?php echo $classname; ?>"><?php echo $mod_strings['LBL_TEAM']; ?>:</td>
<td class="<?php echo $classname; ?>" style="vertical-align : middle;"><?php echo $team_html; ?></td>
</table>

</td>
</tr>
<tr><td colspan="2">
<p/>
<p/>
<table>
<tr>
<?php 

if ( empty( $reporter->report_def['report_type'] ))
{
        $reporter->report_def['report_type']='tabular';
}
?>
<td  width="1%" align=center valign=middle><input type="radio" class="radio" onClick="reportTypeChanged();" id="report_type" name="report_type" value="tabular" <?php if (  $reporter->report_def['report_type'] == 'tabular') { ?> CHECKED<?php } ?>></td>
<td align="left" class="dataLabel" style="vertical-align : middle;"><?php echo $mod_strings['LBL_ROWS_AND_COLUMNS_REPORT']; ?></td>
</tr>
<tr>
<td width="1%" align=center valign=middle><input type="radio" class="radio" name="report_type" id="report_type" onclick="reportTypeChanged();" value="summary" <?php if ( $reporter->report_def['report_type'] == 'summary') { ?> CHECKED<?php } ?>></td>
<td align="left" class="dataLabel" style="vertical-align : middle;"><?php echo $mod_strings['LBL_SUMMATION_REPORT']; ?></td>
</tr>
<!--
<tr>
<td width="1%" align=center valign=middle>&nbsp;</td>
<td align="left" class="dataLabel" style="vertical-align : middle;"><input
                onclick="reportTypeChanged();"
                type="checkbox"
                name="show_columns"
                class="checkbox"
                style="vertical-align: middle;"
                <?php if ( $reporter->show_columns) { echo "CHECKED"; } ?>
                <?php if ( $reporter->report_def['report_type'] != 'summary') { echo "DISABLED"; } ?>
                >&nbsp;<?php echo $mod_strings['LBL_WITH_DETAILS'];?></td>
</tr>
-->

</table>

</td>
</tr>
</table>
</div>
<P/>
<?php
print js_setup();
}

?>
