<?php
if(!defined('sugarEntry') || !sugarEntry)
	die('Not A Valid Entry Point');
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Professional Subscription
 * Agreement ("License") which can be viewed at
 * http://www.sugarcrm.com/crm/products/sugar-professional-eula.html
 * By installing or using this file, You have unconditionally agreed to the
 * terms and conditions of the License, and You may not use this file except in
 * compliance with the License.  Under the terms of the license, You shall not,
 * among other things: 1) sublicense, resell, rent, lease, redistribute, assign
 * or otherwise transfer Your rights to the Software, and 2) use the Software
 * for timesharing or service bureau purposes such as hosting the Software for
 * commercial gain and/or for the benefit of a third party.  Use of the Software
 * may be subject to applicable fees and any use of the Software without first
 * paying applicable fees is strictly prohibited.  You do not have the right to
 * remove SugarCRM copyrights from the source code or user interface.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *  (i) the "Powered by SugarCRM" logo and
 *  (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * Your Warranty, Limitations of liability and Indemnity are expressly stated
 * in the License.  Please refer to the License for the specific language
 * governing these rights and limitations under the License.  Portions created
 * by SugarCRM are Copyright (C) 2004-2007 SugarCRM, Inc.; All Rights Reserved.
 ********************************************************************************/
/*********************************************************************************

 * Description:
 * Portions created by SugarCRM are Copyright(C) SugarCRM, Inc. All Rights
 * Reserved. Contributor(s): ______________________________________..
 * *******************************************************************************/
$_SESSION['upgrade_complete'] = '';

logThis('[At commit.php]');
$stop = true; // flag to show "next"

$standardErrorLevel = error_reporting();
logThis("Setting error_reporting() to E_ERROR while running upgrade");
error_reporting(E_ERROR);

set_time_limit(0);
/*
 * [unzip_dir] => /Users/curisu/www/head/cache/upload//upgrades/temp/QSugp3
 * [zip_from_dir]  => SugarEnt-Upgrade-4.0.1-to-4.2.1
 * rest_dir: /Users/curisu/www/head/cache/upload/SugarEnt-Upgrade-4.0.1-to-4.2.1-restore
 */

// flag upgradeSql script run method
$_SESSION['schema_change'] = $_REQUEST['schema_change'];

// prevent "REFRESH" double commits
if(!isset($_SESSION['committed'])) {
	$_SESSION['committed'] = true; // flag to prevent refresh double-commit
	unset($_SESSION['rebuild_relationships']);
	unset($_SESSION['rebuild_extensions']);

	$unzip_dir			= $_SESSION['unzip_dir'];
	$zip_from_dir		= $_SESSION['zip_from_dir'];
	$install_file		= urldecode($_SESSION['install_file']);
	$file_action		= "";
	$uh_status			= "";
	$errors				= array();
	$out				= '';
	$backupFilesExist	= false;
	$rest_dir			= clean_path(remove_file_extension($install_file) . "-restore");

	///////////////////////////////////////////////////////////////////////////////
	////	MAKE BACKUPS OF TARGET FILES
	$errors = commitMakeBackupFiles($rest_dir, $install_file, $unzip_dir, $zip_from_dir, array());
	////	END MAKE BACKUPS OF TARGET FILES
	///////////////////////////////////////////////////////////////////////////////


	///////////////////////////////////////////////////////////////////////////////
	////	HANDLE PREINSTALL SCRIPTS
	if(empty($errors)) {
		$file = "$unzip_dir/" . constant('SUGARCRM_PRE_INSTALL_FILE');
		if(is_file($file)) {
			$out .= "{$mod_strings['LBL_UW_INCLUDING']}: {$file} <br>\n";
			include($file);

			logThis('Running pre_install()...');
			pre_install();
			logThis('pre_install() done.');
		}
	}

	////	HANDLE PREINSTALL SCRIPTS
	///////////////////////////////////////////////////////////////////////////////

        //require_once('modules/Administration/cleanup50.php');
        // All the Studio customized modules should be preserved in pre_500 folder
		$customized_mods = '';
        if(substr($sugar_version,0,1) < 5){
	         if(isset($_SESSION['Customized_Modules']) && $_SESSION['Customized_Modules'] != null){
	        	$customized_mods = $_SESSION['Customized_Modules'];
	        	$dir = clean_path(getcwd().'/customized451modules');
				if(!file_exists($dir)) {
					mkdir($dir, 0755);
				}
				$customizedModulesdir = $dir.'/modules';
				if(!file_exists($customizedModulesdir)) {
					mkdir($customizedModulesdir, 0755);
				}
	        	foreach($customized_mods as $module_name=>$files) {
					if(is_dir($customizedModulesdir)){
					 //put the customized files from 451
					 mkdir($customizedModulesdir.'/'.$module_name,0755);
					 copyRecursiveBetweenDirectories(clean_path(getcwd()).'/modules/'.$module_name,$customizedModulesdir.'/'.$module_name);
					}
				}
	         }
		}

        //Force clean files not required for MVC. This is to make sure if a file which shouldn't
        //be in MVC is removed even though customized. All the customized files are save anyway.
        //Also check if the current version is same as target version
        if(substr($sugar_version,0,1) < 5){
	        logThis('Start cleaning Non MVC files...');
	        	cleaningNonMVCFiles();
	        logThis('End cleaning Non MVC files...');
	        //Removing file which match the md5
	        logThis('Start cleaning matching md5 files...');
		        $deleteNot=array('en_us.lang.php','company.jpg','Forms.php');
		        removeMd5MatchingFiles($deleteNot);
	        logThis('End cleaning matching md5 files...');
        }
        //Clean smarty from cache
        if(is_dir('cache/smarty')){
        	$allModFiles = array();
        	$allModFiles = findAllFiles('cache/smarty',$allModFiles);
           foreach($allModFiles as $file){
	           	//$file_md5_ref = str_replace(clean_path(getcwd()),'',$file);
	           	if(file_exists($file)){
					unlink($file);
	           	}
           }
        }
         //COPY ALL FILES FROM UPLOADED UPGRADE PACKAGE
         $split = commitCopyNewFiles($unzip_dir, $zip_from_dir);
		 $copiedFiles = $split['copiedFiles'];
		 $skippedFiles = $split['skippedFiles'];
		 //END COPY NEW FILES INTO TARGET INSTANCE

         if($customized_mods != null){
	    	foreach($customized_mods as $module_name=>$files) {
				mkdir(clean_path(getcwd().'/modules/'.$module_name.'/.pre_500'), 0755);
				mkdir(clean_path(getcwd().'/modules/'.$module_name.'/.500'), 0755);
				if(is_dir(clean_path(getcwd().'/modules/'.$module_name.'/.pre_500'))){
				 //put llthe files from module into pre_500
				 copyRecursiveBetweenDirectories(clean_path(getcwd()).'/customized451modules/modules/'.$module_name,clean_path(getcwd()).'/modules/'.$module_name.'/.pre_500');
			     //run these only in pre_500 modules
			     $cur_dir =clean_path(getcwd()).'/modules/'.$module_name.'/.pre_500';
			     if(!file_exists($cur_dir.'/metadata/subpaneldefs.php')){
			     	rename($cur_dir.'/layout_defs.php', $cur_dir.'/metadata/subpaneldefs.php');
			     }
			     if(!file_exists($cur_dir.'/metadata/subpanels')){
			     	rename($cur_dir.'/subpanels', $cur_dir.'/metadata/subpanels');
			     }
			     //Copy 500 dashlet files to the pre_500 module dashlet directory
			     if(file_exists($cur_dir.'/Dashlets')){
			     	//first clean the directory
			     	rmdir_recursive($cur_dir.'/Dashlets');
			     	//then copy from 500 to pre_500
			     	if(file_exists(clean_path(getcwd()).'/modules/'.$module_name.'/Dashlets')){
			     		copyRecursiveBetweenDirectories(clean_path(getcwd()).'/modules/'.$module_name.'/Dashlets',$cur_dir.'/Dashlets');
			     	}
			     }
				}
			 }
          }

        $upgraded_mods = '';
        if(substr($sugar_version,0,1) < 5){
	        if(isset($_SESSION['Upgraded_Modules']) && $_SESSION['Upgraded_Modules']){
	  			$upgraded_mods = $_SESSION['Upgraded_Modules'];
	        }
        }

	///////////////////////////////////////////////////////////////////////////////

	///////////////////////////////////////////////////////////////////////////////
	////	HANDLE POSTINSTALL SCRIPTS
	logThis('Starting post_install()...');


	if(empty($errors)) {
		$file = "$unzip_dir/" . constant('SUGARCRM_POST_INSTALL_FILE');
		if(is_file($file)) {
			include($file);
			post_install();

			// cn: only run conversion if admin selects "Sugar runs SQL"
			if(!empty($_SESSION['allTables']) && $_SESSION['schema_change'] == 'sugar')
				executeConvertTablesSql($db->dbType, $_SESSION['allTables']);
		}


    if(substr($sugar_version,0,1) < 5){
	    //delete yui2
		if(file_exists(clean_path(getcwd()).'/include/javascript/yui2')){
			copyRecursiveBetweenDirectories(clean_path(getcwd()).'/include/javascript/yui2',clean_path(getcwd()).'/include/javascript/yui');
			rmdir_recursive(clean_path(getcwd()).'/include/javascript/yui2');
		}
		//also copying the customized modules to the custom modules for upgrade
		if(file_exists(clean_path(getcwd()).'/upgraded451to500Files')){
			//copyRecursiveBetweenDirectories(clean_path(getcwd()).'/upgraded451to500Files/modules',clean_path(getcwd()).'/modules');
		    if(!file_exists(clean_path(getcwd()).'/custom')){
		    	mkdir(clean_path(getcwd()).'/custom', 0755);
		    }
		    if(!file_exists(clean_path(getcwd()).'/custom/modules')){
		    	mkdir(clean_path(getcwd()).'/custom/modules', 0755);
		    }
			copyRecursiveBetweenDirectories(clean_path(getcwd()).'/upgraded451to500Files/modules',clean_path(getcwd()).'/custom/modules');
			rmdir_recursive(clean_path(getcwd()).'/upgraded451to500Files');
		 }
		if(file_exists(clean_path(getcwd()).'/customized451modules')){
			rmdir_recursive(clean_path(getcwd()).'/customized451modules');
		 }
    }
       if($_SESSION['current_db_version'] != $_SESSION['target_db_version']){
			logThis('Performing UWrebuild()...');
			UWrebuild();
			logThis('UWrebuild() done.');
       }
		require("sugar_version.php");

		if(!rebuildConfigFile($sugar_config, $sugar_version)) {
			logThis('*** ERROR: could not write config.php! - upgrade will fail!');
			$errors[] = $mod_strings['ERR_UW_CONFIG_WRITE'];
		}
	}
	logThis('post_install() done.');
	//// END POSTINSTALL SCRIPTS
	///////////////////////////////////////////////////////////////////////////////
if($_SESSION['current_db_version'] == $_SESSION['target_db_version']){

	$_SESSION['license_seats_needed'] = '';
	//Clean modules from cache
    if(is_dir('cache/modules')){
    	$allModFiles = array();
    	$allModFiles = findAllFiles('cache/modules',$allModFiles);
       foreach($allModFiles as $file){
           	//$file_md5_ref = str_replace(clean_path(getcwd()),'',$file);
           	if(file_exists($file)){
				unlink($file);
           	}
       }
    }
    //Clean jsLanguage from cache
    if(is_dir('cache/jsLanguage')){
    	$allModFiles = array();
    	$allModFiles = findAllFiles('cache/jsLanguage',$allModFiles);
       foreach($allModFiles as $file){
           	//$file_md5_ref = str_replace(clean_path(getcwd()),'',$file);
           	if(file_exists($file)){
				unlink($file);
           	}
       }
    }
}
	///////////////////////////////////////////////////////////////////////////////
	////	REGISTER UPGRADE
	logThis('Registering upgrade with UpgradeHistory');
	if(empty($errors)) {
		$file_action = "copied";
		// if error was encountered, script should have died before now
		$new_upgrade = new UpgradeHistory();
		$new_upgrade->filename = $install_file;
		$new_upgrade->md5sum = md5_file($install_file);
		$new_upgrade->type = 'patch';
		$new_upgrade->version = $sugar_version;
		$new_upgrade->status = "installed";
		$new_upgrade->manifest =(!empty($_SESSION['install_manifest']) ? $_SESSION['install_manifest'] : '');
		$new_upgrade->save();
	}
	////	REGISTER UPGRADE
	///////////////////////////////////////////////////////////////////////////////
}else{
    $backupFilesExist = false;
    $copiedFiles = array();
    $skippedFiles = array();
}

// flag to prvent double-commits via refresh
$_SESSION['committed'] = true;

///////////////////////////////////////////////////////////////////////////////
////	FINISH AND OUTPUT
if(empty($errors)) {
	$stop = false;
}

$backupDesc = '';
if($backupFilesExist) {
	$backupDesc .= "<b>{$mod_strings['LBL_UW_BACKUP_FILES_EXIST_TITLE']}</b><br />";
	$backupDesc .= $mod_strings['LBL_UW_BACKUP_FILES_EXIST'] . ': ' . $rest_dir;
}
if(substr($sugar_version,0,1) < 5){
	//check for customized or upgraded modules
	if($customized_mods != null || $upgraded_mods != null){
		$customized_mods_Desc .= "<b>{$mod_strings['LBL_UW_CUSTOMIZED_OR_UPGRADED_MODULES']}</b><br />";
		$customized_mods_Desc .= "<a href='javascript:void(0); toggleNwFiles(\"customizedModules\");'>{$mod_strings['LBL_UW_SHOW']}</a>";
		$customized_mods_Desc .= "<div id='customizedModules' style='display:none;'>";
	    if($upgraded_mods != null){
		     $customized_mods_Desc .= $mod_strings['LBL_UW_FOLLOWING_MODULES_UPGRADED']. "<br />";
		     foreach($upgraded_mods as $upgraded_module_name=>$files) {
				$customized_mods_Desc .= $upgraded_module_name . "<br />";
			 }
	    }
	    if($customized_mods != null){
			$customized_mods_Desc .= $mod_strings['LBL_UW_FOLLOWING_MODULES_CUSTOMIZED']. "<br />";
			foreach($customized_mods as $customized_module_name=>$files) {
				$customized_mods_Desc .= $customized_module_name . "<br />";
			}
		}
		$customized_mods_Desc .= "</div>";
	}
}

$customized_mods_Desc = '';
$old_schema= '';
$old_schema_opt = '';

if($_SESSION['current_db_version'] != $_SESSION['target_db_version']){
	//old schema to be dropped
	$old_schema_contents = '';
	if(file_exists($_SESSION['unzip_dir'].'/scripts/drop_451schema_after_upgrade5.php')){
		require_once($_SESSION['unzip_dir'].'/scripts/drop_451schema_after_upgrade5.php');
		ob_start();
			$old_schema_contents=@drop_preUpgardeSchema(true);
		ob_end_clean();
	}
	$old_schema  = "<p><a href='javascript:void(0); toggleNwFiles(\"old_schemashow\");'>{$mod_strings['LBL_UW_SHOW_OLD_SCHEMA_TO_DROP']}</a>";
	$old_schema .= "<div id='old_schemashow' style='display:none;'>";
	$old_schema .= "<textarea readonly cols='80' rows='10'>{$old_schema_contents}</textarea>";
	$old_schema .= "</div></p>";

	$old_schema_opt="<b>{$mod_strings['LBL_UW_DROP_SCHEMA_METHOD']}</b>
					<select name=\"schema_drop\" id=\"select_schema_drop\" onchange=\"checkSchemaDropStatus();\">
						<option value=\"manual\">{$mod_strings['LBL_UW_DROP_SCHEMA_MANUAL']}</option>
						<option value=\"sugar\">{$mod_strings['LBL_UW_DROP_SCHEMA_UPGRADE_WIZARD']}</option>
					</select>
				";
}

$copiedDesc = '';
if(count($copiedFiles) > 0) {
	$copiedDesc .= "<b>{$mod_strings['LBL_UW_COPIED_FILES_TITLE']}</b><br />";
	$copiedDesc .= "<a href='javascript:void(0); toggleNwFiles(\"copiedFiles\");'>{$mod_strings['LBL_UW_SHOW']}</a>";
	$copiedDesc .= "<div id='copiedFiles' style='display:none;'>";

	foreach($copiedFiles as $file) {
		$copiedDesc .= $file . "<br />";
	}
	$copiedDesc .= "</div>";
}

$skippedDesc = '';
if(count($skippedFiles) > 0) {
	$skippedDesc .= "<b>{$mod_strings['LBL_UW_SKIPPED_FILES_TITLE']}</b><br />";
	$skippedDesc .= "<a href='javascript:void(0); toggleNwFiles(\"skippedFiles\");'>{$mod_strings['LBL_UW_SHOW']}</a>";
	$skippedDesc .= "<div id='skippedFiles' style='display:none;'>";

	foreach($skippedFiles as $file) {
		$skippedDesc .= $file . "<br />";
	}
	$skippedDesc .= "</div>";
}

$rebuildResult = "<b>{$mod_strings['LBL_UW_REBUILD_TITLE']}</b><br />";
$rebuildResult .= "<a href='javascript:void(0); toggleRebuild();'>{$mod_strings['LBL_UW_SHOW']}</a> <div id='rebuildResult'></div>";

$rebuildResult = '';

//moving unlink files to last
//unlinkTempFiles();

///////////////////////////////////////////////////////////////////////////////
////	HANDLE REMINDERS
commitHandleReminders($skippedFiles);
////	HANDLE REMINDERS
///////////////////////////////////////////////////////////////////////////////


logThis("Resetting error_reporting() to system level.");
error_reporting($standardErrorLevel);

///////////////////////////////////////////////////////////////////////////////
////	OUTPUT
$uwMain =<<<eoq
<script type="text/javascript" language="javascript">
	function toggleRebuild() {
		var target = document.getElementById('rebuildResult');

		if(target.innerHTML == '') {
			target.innerHTML = rebuildResult; // found in UWrebuild()
		} else {
			target.innerHTML = '';
		}
	}
</script>
<table cellpadding="3" cellspacing="0" border="0">
	<tr>
		<th align="left">
			{$mod_strings['LBL_UW_TITLE_COMMIT']}
		</th>
	</tr>
	<tr>
		<td align="left">
			<p>
			{$backupDesc}
			</p>
			<p>
			{$customized_mods_Desc}
			</p>
			<p>
			{$copiedDesc}
			</p>
			<p>
			{$skippedDesc}
			</p>
			<p>
			{$rebuildResult}
			</p>
		</td>
	</tr>
	<tr><td>
		<p>
		{$old_schema}
		</p>
	</td></tr>
	<tr><td>
		{$old_schema_opt}
	</td></tr>
</table>
<div id="upgradeDiv" style="display:none">
    <table cellspacing="0" cellpadding="0" border="0">
        <tr><td>
           <p><img src='modules/UpgradeWizard/processing.gif'> <br>{$mod_strings['LBL_UPGRADE_TAKES_TIME_HAVE_PATIENCE']}</p>
        </td></tr>
     </table>
 </div>
 <script>
function checkSchemaDropStatus() {
	if(document.getElementById('select_schema_drop') != null){
		var schemaSelect = document.getElementById('select_schema_drop');
		var schemaDropMethod = document.getElementById('schema_drop');
		if(schemaSelect.options[schemaSelect.selectedIndex].value == 'manual') {
			schemaDropMethod.value = 'manual';
		} else {
			schemaDropMethod.value = 'sugar';
		}
   }
}
 checkSchemaDropStatus();
 </script>
eoq;

$showBack = false;
$showCancel = false;
$showRecheck = false;
$showNext =($stop) ? false : true;

$stepBack = $_REQUEST['step'] - 1;
$stepNext = $_REQUEST['step'] + 1;
$stepCancel = -1;
$stepRecheck = $_REQUEST['step'];

$_SESSION['step'][$steps['files'][$_REQUEST['step']]] =($stop) ? 'failed' : 'success';
?>
