<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Professional Subscription
 * Agreement ("License") which can be viewed at
 * http://www.sugarcrm.com/crm/products/sugar-professional-eula.html
 * By installing or using this file, You have unconditionally agreed to the
 * terms and conditions of the License, and You may not use this file except in
 * compliance with the License.  Under the terms of the license, You shall not,
 * among other things: 1) sublicense, resell, rent, lease, redistribute, assign
 * or otherwise transfer Your rights to the Software, and 2) use the Software
 * for timesharing or service bureau purposes such as hosting the Software for
 * commercial gain and/or for the benefit of a third party.  Use of the Software
 * may be subject to applicable fees and any use of the Software without first
 * paying applicable fees is strictly prohibited.  You do not have the right to
 * remove SugarCRM copyrights from the source code or user interface.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *  (i) the "Powered by SugarCRM" logo and
 *  (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * Your Warranty, Limitations of liability and Indemnity are expressly stated
 * in the License.  Please refer to the License for the specific language
 * governing these rights and limitations under the License.  Portions created
 * by SugarCRM are Copyright (C) 2004-2007 SugarCRM, Inc.; All Rights Reserved.
 ********************************************************************************/
 
require_once('modules/Reports/SavedReport.php');

function create_default_reports() {
    global $current_language;

    $lang_strings = return_module_language($current_language, 'Reports');

    $default_reports = array();
    $default_reports[] = array('Opportunities', $lang_strings['DEFAULT_REPORT_TITLE_1'], '{"display_columns":[{"name":"name","label":"Opportunity Name","table_key":"self"},{"name":"name","label":"Account Name","table_key":"accounts"},{"name":"amount_usdollar","label":"Amount","table_key":"self"},{"name":"date_closed","label":"Expected Close Date","table_key":"self"},{"name":"probability","label":"Probability (%)","table_key":"self"},{"name":"full_name","label":"Assigned to","table_key":"assigned_user_link"}],"summary_columns":[],"order_by":[{"name":"probability","label":"Probability (%)","table_key":"self","sort_dir":"a"}],"filters_def":[{"name":"date_closed","table_key":"self","qualifier_name":"between_dates","input_name0":"2005-07-01","input_name1":"2005-09-30"}],"group_defs":[],"links_def":["accounts","team_link","created_by_link","modified_user_link","assigned_user_link"],"module":"Opportunities","report_name":"Current Quarter Forecast\\n","report_type":"tabular"}','tabular');
    $default_reports[] = array('Opportunities', $lang_strings['DEFAULT_REPORT_TITLE_2'], '{"display_columns":[{"name":"name","label":"Opportunity Name","table_key":"self"},{"name":"name","label":"Account Name","table_key":"accounts"},{"name":"amount_usdollar","label":"Amount","table_key":"self"},{"name":"description","label":"Description","table_key":"self"},{"name":"next_step","label":"Next Step","table_key":"self"},{"name":"date_closed","label":"Expected Close Date","table_key":"self"},{"name":"probability","label":"Probability (%)","table_key":"self"}],"summary_columns":[],"order_by":[{"name":"probability","label":"Probability (%)","table_key":"self","sort_dir":"a"}],"filters_def":[],"group_defs":[],"links_def":["accounts","team_link","created_by_link","modified_user_link","assigned_user_link"],"module":"Opportunities","report_name":"Detailed Forecast","report_type":"tabular"}','tabular');
    $default_reports[] = array('Accounts', $lang_strings['DEFAULT_REPORT_TITLE_3'], '{"display_columns":[{"name":"name","label":"Account Name","table_key":"self"},{"name":"phone_office","label":"Phone Office","table_key":"self"},{"name":"description","label":"Description","table_key":"self"},{"name":"annual_revenue","label":"Annual Revenue","table_key":"self"},{"name":"account_type","label":"Type","table_key":"self"},{"name":"full_name","label":"Assigned to","table_key":"assigned_user_link"}],"summary_columns":[],"filters_def":[{"name":"account_type","table_key":"self","qualifier_name":"is","input_name0":"Partner"}],"group_defs":[],"links_def":["member_of","team_link","created_by_link","modified_user_link","assigned_user_link"],"module":"Accounts","report_name":"Partner Account List","order_by":[],"report_type":"tabular"}','tabular');
    $default_reports[] = array('Accounts', $lang_strings['DEFAULT_REPORT_TITLE_4'], '{"display_columns":[{"name":"name","label":"Account Name","table_key":"self"},{"name":"website","label":"Website","table_key":"self"},{"name":"phone_office","label":"Phone Office","table_key":"self"},{"name":"description","label":"Description","table_key":"self"},{"name":"account_type","label":"Type","table_key":"self"},{"name":"full_name","label":"Assigned to","table_key":"assigned_user_link"}],"summary_columns":[],"filters_def":[{"name":"account_type","table_key":"self","qualifier_name":"is","input_name0":"Customer"}],"group_defs":[],"links_def":["member_of","team_link","created_by_link","modified_user_link","assigned_user_link"],"module":"Accounts","report_name":"Customer Account List","order_by":[],"report_type":"tabular"}','tabular');
    $default_reports[] = array('Contacts', $lang_strings['DEFAULT_REPORT_TITLE_5'], '{"display_columns":[{"name":"date_modified","label":"Last Modified","table_key":"self"},{"name":"full_name","label":"Contact Name","table_key":"self"},{"name":"phone_work","label":"Office Phone","table_key":"self"},{"name":"name","label":"Account Name","table_key":"accounts"},{"name":"alt_address_country","label":"Alternate Address Country","table_key":"self"},{"name":"full_name","label":"Assigned to","table_key":"assigned_user_link"}],"summary_columns":[],"filters_def":[{"name":"do_not_call","table_key":"self","qualifier_name":"equals","input_name0":["no"]}],"group_defs":[],"links_def":["accounts","reports_to_link","team_link","created_by_link","modified_user_link","assigned_user_link"],"order_by":[],"module":"Contacts","report_name":"Call list by last date contacted","report_type":"tabular"}','tabular');
    $default_reports[] = array('Opportunities', $lang_strings['DEFAULT_REPORT_TITLE_6'], '{"report_type":"summary","display_columns":[{"name":"lead_source","label":"Lead Source","table_key":"self"},{"name":"name","label":"Opportunity Name","table_key":"self"},{"name":"name","label":"Account Name","table_key":"accounts"},{"name":"amount_usdollar","label":"Amount","table_key":"self"},{"name":"sales_stage","label":"Sales Stage","table_key":"self"},{"name":"probability","label":"Probability (%)","table_key":"self"},{"name":"full_name","label":"Assigned to","table_key":"assigned_user_link"}],"summary_columns":[{"name":"lead_source","label":"Opportunities: Lead Source","table_key":"self"},{"name":"count","label":"Count","group_function":"count","table_key":"self"}],"order_by":[{"name":"amount_usdollar","label":"Amount","table_key":"self","sort_dir":"d"}],"filters_def":[],"group_defs":[{"name":"lead_source","label":"Lead Source","table_key":"self"}],"links_def":["accounts","team_link","created_by_link","modified_user_link","assigned_user_link"],"module":"Opportunities","report_name":"Opportunities by Lead Source","chart_type":"hBarF","chart_description":"","numerical_chart_column":"count"}','detailed_summary','hBarF');

    // Cases
    $default_reports[] = array('Cases', $lang_strings['DEFAULT_REPORT_TITLE_7'], '{"report_type":"summary","display_columns":[{"name":"case_number","label":"Cases: Number","table_key":"self"},{"name":"name","label":"Cases: Subject","table_key":"self"},{"name":"date_entered","label":"Cases: Date Created","table_key":"self"}],"summary_columns":[{"name":"count","label":"Count","group_function":"count","table_key":"self"},{"name":"status","label":"Cases: Status","table_key":"self","is_group_by":"visible"},{"name":"user_name","label":"Assigned to User: User Name","table_key":"self_link_0","is_group_by":"visible"}],"filters_def":[{"name":"status","table_key":"self","qualifier_name":"one_of","input_name0":["New","Assigned","Pending Input"]}],"filters_combiner":"AND","group_defs":[{"name":"user_name","label":"User Name","table_key":"self_link_0"},{"name":"status","label":"Status","table_key":"self"}],"full_table_list":{"self":{"parent":"","value":"Cases","module":"Cases","label":"Cases","children":{"self_link_0":"self_link_0"}},"self_link_0":{"parent":"self","children":[],"value":"assigned_user_link","label":"Assigned to User","link_def":{"name":"assigned_user_link","relationship_name":"cases_assigned_user","bean_is_lhs":"","link_type":"one","label":"Assigned to User","table_key":"self_link_0"},"module":"Users"}},"module":"Cases","report_name":"' . $lang_strings['DEFAULT_REPORT_TITLE_7'] . '","chart_type":"hBarF","chart_description":"","numerical_chart_column":"count","assigned_user_id":"1"}', 'detailed_summary','hBarF');
    $default_reports[] = array('Cases', $lang_strings['DEFAULT_REPORT_TITLE_8'], '{"report_type":"summary","display_columns":[{"name":"case_number","label":"Cases: Number","table_key":"self"},{"name":"name","label":"Cases: Subject","table_key":"self"},{"name":"name","label":"Account: Name","table_key":"self_link_1"}],"summary_columns":[{"name":"date_entered","label":"Date Created","table_key":"self","qualifier":"month","is_group_by":"hidden","column_function":"month"},{"name":"count","label":"Count","group_function":"count","table_key":"self"},{"name":"date_entered","label":"Cases: Month: Date Created","column_function":"month","table_key":"self"},{"name":"user_name","label":"Assigned to User: User Name","table_key":"self_link_0","is_group_by":"visible"}],"filters_def":[{"name":"status","table_key":"self","qualifier_name":"one_of","input_name0":["New","Assigned","Pending Input"]}],"filters_combiner":"AND","group_defs":[{"name":"date_entered","label":"Date Created","table_key":"self","qualifier":"month","is_group_by":"hidden","column_function":"month"},{"name":"user_name","label":"User Name","table_key":"self_link_0"}],"full_table_list":{"self":{"parent":"","value":"Cases","module":"Cases","label":"Cases","children":{"self_link_0":"self_link_0","self_link_1":"self_link_1"}},"self_link_0":{"parent":"self","children":[],"value":"assigned_user_link","label":"Assigned to User","link_def":{"name":"assigned_user_link","relationship_name":"cases_assigned_user","bean_is_lhs":"","link_type":"one","label":"Assigned to User","table_key":"self_link_0"},"module":"Users"},"self_link_1":{"parent":"self","children":[],"value":"account","label":"Account","link_def":{"name":"account","relationship_name":"account_cases","bean_is_lhs":"","link_type":"one","label":"Account","table_key":"self_link_1"},"module":"Accounts"}},"module":"Cases","report_name":"Open Cases By Month By User","chart_type":"vBarF","chart_description":"","numerical_chart_column":"count","assigned_user_id":"1"}', 'detailed_summary','vBarF');
    $default_reports[] = array('Cases', $lang_strings['DEFAULT_REPORT_TITLE_9'], '{"report_type":"summary","display_columns":[{"name":"case_number","label":"Cases: Number","table_key":"self"},{"name":"name","label":"Cases: Subject","table_key":"self"},{"name":"name","label":"Account: Name","table_key":"self_link_1"}],"summary_columns":[{"name":"count","label":"Count","group_function":"count","table_key":"self"},{"name":"priority","label":"Cases: Priority","table_key":"self","is_group_by":"visible"},{"name":"user_name","label":"Assigned to User: User Name","table_key":"self_link_0","is_group_by":"visible"}],"filters_def":[{"name":"status","table_key":"self","qualifier_name":"one_of","input_name0":["New","Assigned","Pending Input"]}],"filters_combiner":"AND","group_defs":[{"name":"user_name","label":"User Name","table_key":"self_link_0"},{"name":"priority","label":"Priority","table_key":"self"}],"full_table_list":{"self":{"parent":"","value":"Cases","module":"Cases","label":"Cases","children":{"self_link_0":"self_link_0","self_link_1":"self_link_1"}},"self_link_0":{"parent":"self","children":[],"value":"assigned_user_link","label":"Assigned to User","link_def":{"name":"assigned_user_link","relationship_name":"cases_assigned_user","bean_is_lhs":"","link_type":"one","label":"Assigned to User","table_key":"self_link_0"},"module":"Users"},"self_link_1":{"parent":"self","children":[],"value":"account","label":"Account","link_def":{"name":"account","relationship_name":"account_cases","bean_is_lhs":"","link_type":"one","label":"Account","table_key":"self_link_1"},"module":"Accounts"}},"module":"Cases","report_name":"Open Cases By Priority By User","chart_type":"hBarF","chart_description":"","numerical_chart_column":"count","assigned_user_id":"1"}', 'detailed_summary','hBarF');
    $default_reports[] = array('Cases', $lang_strings['DEFAULT_REPORT_TITLE_10'], '{"report_type":"summary","display_columns":[],"summary_columns":[{"name":"date_entered","label":"Date Created","table_key":"self","qualifier":"month","is_group_by":"hidden","column_function":"month"},{"name":"count","label":"Count","group_function":"count","table_key":"self"},{"name":"date_entered","label":"Cases: Month: Date Created","column_function":"month","table_key":"self"}],"filters_def":[],"filters_combiner":"AND","group_defs":[{"name":"date_entered","label":"Date Created","table_key":"self","qualifier":"month","is_group_by":"hidden","column_function":"month"}],"full_table_list":{"self":{"parent":"","value":"Cases","module":"Cases","label":"Cases","children":[]}},"module":"Cases","report_name":"' . $lang_strings['DEFAULT_REPORT_TITLE_10'] . '","chart_type":"vBarF","chart_description":"","numerical_chart_column":"count","assigned_user_id":"1"}', 'summary','vBarF');
    
    // Pipeline
    $default_reports[] = array('Opportunities', $lang_strings['DEFAULT_REPORT_TITLE_11'], '{"report_type":"summary","display_columns":[],"summary_columns":[{"name":"amount_usdollar","label":"Opportunities: SUM: Amount","group_function":"sum","table_key":"self"},{"name":"opportunity_type","label":"Opportunities: Type","table_key":"self","is_group_by":"visible"},{"name":"name","label":"Team: Team Name","table_key":"self_link_0","is_group_by":"visible"}],"filters_def":[{"name":"sales_stage","table_key":"self","qualifier_name":"one_of","input_name0":["Prospecting","Qualification","Needs Analysis","Value Proposition","Id. Decision Makers","Perception Analysis","Proposal\/Price Quote","Negotiation\/Review"]}],"filters_combiner":"AND","group_defs":[{"name":"name","label":"Team Name","table_key":"self_link_0"},{"name":"opportunity_type","label":"Type","table_key":"self"}],"full_table_list":{"self":{"parent":"","value":"Opportunities","module":"Opportunities","label":"Opportunities","children":{"self_link_0":"self_link_0"}},"self_link_0":{"parent":"self","children":[],"value":"team_link","label":"Team","link_def":{"name":"team_link","relationship_name":"opportunities_team","bean_is_lhs":"","link_type":"one","label":"Team","table_key":"self_link_0"},"module":"Teams"}},"module":"Opportunities","report_name":"' . $lang_strings['DEFAULT_REPORT_TITLE_11'] . '","chart_type":"hBarF","chart_description":"","numerical_chart_column":"self:amount_usdollar:sum","assigned_user_id":"1"}', 'summary','hBarF');
    $default_reports[] = array('Opportunities', $lang_strings['DEFAULT_REPORT_TITLE_12'], '{"report_type":"summary","display_columns":[],"summary_columns":[{"name":"amount_usdollar","label":"Opportunities: SUM: Amount","group_function":"sum","table_key":"self"},{"name":"name","label":"Team: Team Name","table_key":"self_link_0","is_group_by":"visible"},{"name":"user_name","label":"Assigned to User: User Name","table_key":"self_link_1","is_group_by":"visible"}],"filters_def":[{"name":"sales_stage","table_key":"self","qualifier_name":"one_of","input_name0":["Prospecting","Qualification","Needs Analysis","Value Proposition","Id. Decision Makers","Perception Analysis","Proposal\/Price Quote","Negotiation\/Review"]}],"filters_combiner":"AND","group_defs":[{"name":"name","label":"Team Name","table_key":"self_link_0"},{"name":"user_name","label":"User Name","table_key":"self_link_1"}],"full_table_list":{"self":{"parent":"","value":"Opportunities","module":"Opportunities","label":"Opportunities","children":{"self_link_0":"self_link_0","self_link_1":"self_link_1"}},"self_link_0":{"parent":"self","children":[],"value":"team_link","label":"Team","link_def":{"name":"team_link","relationship_name":"opportunities_team","bean_is_lhs":"","link_type":"one","label":"Team","table_key":"self_link_0"},"module":"Teams"},"self_link_1":{"parent":"self","children":[],"value":"assigned_user_link","label":"Assigned to User","link_def":{"name":"assigned_user_link","relationship_name":"opportunities_assigned_user","bean_is_lhs":"","link_type":"one","label":"Assigned to User","table_key":"self_link_1"},"module":"Users"}},"module":"Opportunities","report_name":"' .$lang_strings['DEFAULT_REPORT_TITLE_12'] . '","chart_type":"hBarF","chart_description":"","numerical_chart_column":"self:amount_usdollar:sum","assigned_user_id":"1"}', 'summary','hBarF'); 
    $default_reports[] = array('Opportunities', $lang_strings['DEFAULT_REPORT_TITLE_17'], '{"report_type":"summary","display_columns":[],"summary_columns":[{"name":"amount_usdollar","label":"Opportunities: SUM: Amount","group_function":"sum","table_key":"self"},{"name":"lead_source","label":"Opportunities: Lead Source","table_key":"self","is_group_by":"visible"},{"name":"count","label":"Count","group_function":"count","table_key":"self"}],"filters_def":[{"name":"sales_stage","table_key":"self","qualifier_name":"is","input_name0":["Closed Won"]}],"filters_combiner":"AND","group_defs":[{"name":"lead_source","label":"Lead Source","table_key":"self"}],"full_table_list":{"self":{"parent":"","value":"Opportunities","module":"Opportunities","label":"Opportunities","children":[]}},"module":"Opportunities","report_name":"' .$lang_strings['DEFAULT_REPORT_TITLE_17'] . '","chart_type":"hBarF","chart_description":"","numerical_chart_column":"self:amount_usdollar:sum","assigned_user_id":"1"}', 'summary','hBarF');
    
    // Activities
    $default_reports[] = array('Tasks', $lang_strings['DEFAULT_REPORT_TITLE_13'], '{"report_type":"summary","display_columns":[],"summary_columns":[{"name":"count","label":"Count","group_function":"count","table_key":"self"},{"name":"name","label":"Team: Team Name","table_key":"self_link_0","is_group_by":"visible"},{"name":"user_name","label":"Assigned to User: User Name","table_key":"self_link_1","is_group_by":"visible"}],"filters_def":[],"filters_combiner":"AND","group_defs":[{"name":"name","label":"Team Name","table_key":"self_link_0"},{"name":"user_name","label":"User Name","table_key":"self_link_1"}],"full_table_list":{"self":{"parent":"","value":"Tasks","module":"Tasks","label":"Tasks","children":{"self_link_0":"self_link_0","self_link_1":"self_link_1"}},"self_link_0":{"parent":"self","children":[],"value":"team_link","label":"Team","link_def":{"name":"team_link","relationship_name":"tasks_team","bean_is_lhs":"","link_type":"one","label":"Team","table_key":"self_link_0"},"module":"Teams"},"self_link_1":{"parent":"self","children":[],"value":"assigned_user_link","label":"Assigned to User","link_def":{"name":"assigned_user_link","relationship_name":"tasks_assigned_user","bean_is_lhs":"","link_type":"one","label":"Assigned to User","table_key":"self_link_1"},"module":"Users"}},"module":"Tasks","report_name":"' . $lang_strings['DEFAULT_REPORT_TITLE_13'] . '","chart_type":"hBarF","chart_description":"","numerical_chart_column":"count","assigned_user_id":"1"}', 'summary','hBarF');
    $default_reports[] = array('Meetings', $lang_strings['DEFAULT_REPORT_TITLE_14'], '{"report_type":"summary","display_columns":[],"summary_columns":[{"name":"count","label":"Count","group_function":"count","table_key":"self"},{"name":"name","label":"Team: Team Name","table_key":"self_link_0","is_group_by":"visible"},{"name":"user_name","label":"Assigned to User: User Name","table_key":"self_link_1","is_group_by":"visible"}],"filters_def":[],"filters_combiner":"AND","group_defs":[{"name":"name","label":"Team Name","table_key":"self_link_0"},{"name":"user_name","label":"User Name","table_key":"self_link_1"}],"full_table_list":{"self":{"parent":"","value":"Meetings","module":"Meetings","label":"Meetings","children":{"self_link_0":"self_link_0","self_link_1":"self_link_1"}},"self_link_0":{"parent":"self","children":[],"value":"team_link","label":"Team","link_def":{"name":"team_link","relationship_name":"meetings_team","bean_is_lhs":"","link_type":"one","label":"Team","table_key":"self_link_0"},"module":"Teams"},"self_link_1":{"parent":"self","children":[],"value":"assigned_user_link","label":"Assigned to User","link_def":{"name":"assigned_user_link","relationship_name":"meetings_assigned_user","bean_is_lhs":"","link_type":"one","label":"Assigned to User","table_key":"self_link_1"},"module":"Users"}},"module":"Meetings","report_name":"' . $lang_strings['DEFAULT_REPORT_TITLE_14'] . '","chart_type":"hBarF","chart_description":"","numerical_chart_column":"count","assigned_user_id":"1"}', 'summary','hBarF');
    $default_reports[] = array('Calls', $lang_strings['DEFAULT_REPORT_TITLE_15'], '{"report_type":"summary","display_columns":[],"summary_columns":[{"name":"count","label":"Count","group_function":"count","table_key":"self"},{"name":"name","label":"Team: Team Name","table_key":"self_link_0","is_group_by":"visible"},{"name":"user_name","label":"Assigned to User: User Name","table_key":"self_link_1","is_group_by":"visible"}],"filters_def":[],"filters_combiner":"AND","group_defs":[{"name":"name","label":"Team Name","table_key":"self_link_0"},{"name":"user_name","label":"User Name","table_key":"self_link_1"}],"full_table_list":{"self":{"parent":"","value":"Calls","module":"Calls","label":"Calls","children":{"self_link_0":"self_link_0","self_link_1":"self_link_1"}},"self_link_0":{"parent":"self","children":[],"value":"team_link","label":"Team","link_def":{"name":"team_link","relationship_name":"calls_team","bean_is_lhs":"","link_type":"one","label":"Team","table_key":"self_link_0"},"module":"Teams"},"self_link_1":{"parent":"self","children":[],"value":"assigned_user_link","label":"Assigned to User","link_def":{"name":"assigned_user_link","relationship_name":"calls_assigned_user","bean_is_lhs":"","link_type":"one","label":"Assigned to User","table_key":"self_link_1"},"module":"Users"}},"module":"Calls","report_name":"' . $lang_strings['DEFAULT_REPORT_TITLE_15'] . '","chart_type":"hBarF","chart_description":"","numerical_chart_column":"count","assigned_user_id":"1"}', 'summary','hBarF');
    
    // Accounts
    $default_reports[] = array('Accounts', $lang_strings['DEFAULT_REPORT_TITLE_16'], '{"report_type":"summary","display_columns":[],"summary_columns":[{"name":"count","label":"Count","group_function":"count","table_key":"self"},{"name":"account_type","label":"Accounts: Type","table_key":"self","is_group_by":"visible"},{"name":"industry","label":"Accounts: Industry","table_key":"self","is_group_by":"visible"}],"filters_def":[],"filters_combiner":"AND","group_defs":[{"name":"account_type","label":"Type","table_key":"self"},{"name":"industry","label":"Industry","table_key":"self"}],"full_table_list":{"self":{"parent":"","value":"Accounts","module":"Accounts","label":"Accounts","children":[]}},"module":"Accounts","report_name":"' . $lang_strings['DEFAULT_REPORT_TITLE_16'] . '","chart_type":"hBarF","chart_description":"","numerical_chart_column":"count","assigned_user_id":"1"}', 'summary', 'hBarF');
    
    // Leads
	$default_reports[] = array('Leads', $lang_strings['DEFAULT_REPORT_TITLE_18'], '{"report_type":"summary","display_columns":[],"summary_columns":[{"name":"count","label":"Count","group_function":"count","table_key":"self"},{"name":"lead_source","label":"Leads: Lead Source","table_key":"self","is_group_by":"visible"}],"filters_def":[],"filters_combiner":"AND","group_defs":[{"name":"lead_source","label":"Lead Source","table_key":"self"}],"full_table_list":{"self":{"parent":"","value":"Leads","module":"Leads","label":"Leads","children":{"self_link_0":"self_link_0"}},"self_link_0":{"parent":"self","children":[],"value":"assigned_user_link","label":"Assigned To User","link_def":{"name":"assigned_user_link","relationship_name":"leads_assigned_user","bean_is_lhs":"","link_type":"one","label":"Assigned To User","table_key":"self_link_0"},"module":"Users"}},"module":"Leads","report_name":"' . $lang_strings['DEFAULT_REPORT_TITLE_18'] . '","chart_type":"vBarF","chart_description":"","numerical_chart_column":"count","assigned_user_id":"1"}', 'summary', 'vBarF');    
    
    foreach ($default_reports as $report) {
        $saved_report = new SavedReport();
        if ($report[3] == 'tabular') {
        	$result = $saved_report->save_report(-1, 1, $report[1], $report[0], $report[3], $report[2], 1, '1', 'none');
        }
		else {
        	$result = $saved_report->save_report(-1, 1, $report[1], $report[0], $report[3], $report[2], 1, '1', $report[4]);
        }
    }
                                                                                                       
}
   
?>
